module ol_external_qqxggggg_ddxggggg_1
  implicit none
  integer :: dummy_counter
  ! Permutation and inverse permutation of external particles
  integer, save :: external_perm_qqxggggg_ddxggggg_1(7) = &
                     [ (dummy_counter, dummy_counter = 1, 7) ]
  integer, save :: external_perm_inv_qqxggggg_ddxggggg_1(7) = &
                     [ (dummy_counter, dummy_counter = 1, 7) ]
  integer, save :: extcomb_perm_qqxggggg_ddxggggg_1(0:29) = &
                     [ (dummy_counter, dummy_counter = 0, 29) ]
  ! Particle types (mapping of fields to integers is not fixed!)
  integer, save :: particle_types_qqxggggg_ddxggggg_1(7) = &
                     [ 1, 2, 3, 3, 3, 3, 3 ]
  ! Colour and helicity average factors per particle
  integer, save :: average_factors_qqxggggg_ddxggggg_1(7) = &
                     [ 6, 6, 16, 16, 16, 16, 16 ]
  ! Average factor; initialised to the identity permutation
  integer, save :: average_factor_qqxggggg_ddxggggg_1 = &
                     4320
  integer, save :: channel_number_qqxggggg_ddxggggg_1 = -1
  ! external particle helicities
  logical, save :: hel_not_initialised = .true.
  integer, save :: H(7,128) ! H(i,la) = helicity of particle i in configuration la
  integer, save :: H_HC(128,7)
  integer, save :: POLSEL(7) = 0
  integer, save :: photonid_qqxggggg_ddxggggg_1(7) = 0

  contains

  subroutine n_external(n) &
      & bind(c,name="ol_f_n_external_qqxggggg_ddxggggg_1")
    ! Return the number of external particles
    implicit none
    integer, intent(out) :: n
    n = 7
  end subroutine n_external


  subroutine n_external_c(n) &
      & bind(c,name="ol_n_external_qqxggggg_ddxggggg_1")
    use, intrinsic :: iso_c_binding, only: c_int
    implicit none
    integer(c_int) :: n
    n = 7
  end subroutine n_external_c

  subroutine averagefactor_c(avgf) &
      & bind(c,name="ol_averagefactor_qqxggggg_ddxggggg_1")
    use KIND_TYPES, only: DREALKIND
    implicit none
    real(DREALKIND), intent(out) :: avgf
    avgf = average_factor_qqxggggg_ddxggggg_1
  end subroutine averagefactor_c

  subroutine set_permutation(perm) &
      & bind(c,name="ol_f_set_permutation_qqxggggg_ddxggggg_1")
    use ol_parameters_decl_/**/DREALKIND, only: out_symmetry_on
    use ol_external_decl_/**/DREALKIND, only: n_scatt
    use ol_generic, only: factorial
    implicit none
    integer, intent(in) :: perm(7)
    integer :: i, j, ii, jj
    integer :: particle_types_perm_qqxggggg_ddxggggg_1(7)
    external_perm_qqxggggg_ddxggggg_1 = perm
    do i = 1, 7
      external_perm_inv_qqxggggg_ddxggggg_1( &
        external_perm_qqxggggg_ddxggggg_1(i)) = i
      particle_types_perm_qqxggggg_ddxggggg_1(i) = &
        particle_types_qqxggggg_ddxggggg_1( &
        external_perm_qqxggggg_ddxggggg_1(i))
    end do
    do i = 1, 7
      do j = 1, i
        if (external_perm_qqxggggg_ddxggggg_1(i) >= &
          external_perm_qqxggggg_ddxggggg_1(j)) then
          ii = external_perm_qqxggggg_ddxggggg_1(i)
          jj = external_perm_qqxggggg_ddxggggg_1(j)
        else
          ii = external_perm_qqxggggg_ddxggggg_1(j)
          jj = external_perm_qqxggggg_ddxggggg_1(i)
        end if
        extcomb_perm_qqxggggg_ddxggggg_1((i*(i-1))/2 + j) = (ii*(ii-1))/2 + jj
      end do
    end do
    ! Colour and helicity average factor
    average_factor_qqxggggg_ddxggggg_1 = 1
    do i = 1, n_scatt
      average_factor_qqxggggg_ddxggggg_1 = &
        average_factor_qqxggggg_ddxggggg_1 &
        * average_factors_qqxggggg_ddxggggg_1( &
        external_perm_qqxggggg_ddxggggg_1(i))
    end do
    ! Symmetry factor for outgoing particles
    if (out_symmetry_on /= 0) then
      do i = 1, 7
        average_factor_qqxggggg_ddxggggg_1 = &
          average_factor_qqxggggg_ddxggggg_1 &
          * factorial(count(particle_types_perm_qqxggggg_ddxggggg_1(n_scatt+1:7) == i))
      end do
    end if
  end subroutine set_permutation


  subroutine set_permutation_c(perm) &
      & bind(c,name="ol_set_permutation_qqxggggg_ddxggggg_1")
    use, intrinsic :: iso_c_binding, only: c_int
    implicit none
    integer(c_int), intent(in) :: perm(7)
    integer :: f_perm(7)
    f_perm = perm
    call set_permutation(f_perm)
  end subroutine set_permutation_c


  subroutine get_last_perm(perm) &
      & bind(c,name="ol_f_get_last_perm_qqxggggg_ddxggggg_1")
    integer, intent(out) :: perm(7)
    perm = external_perm_qqxggggg_ddxggggg_1
  end subroutine get_last_perm


  subroutine get_masses(m_ex) &
      & bind(c,name="ol_f_get_masses_qqxggggg_ddxggggg_1")
    ! Return the masses of the external particles in the current permutation.
    use KIND_TYPES, only: DREALKIND
    use ol_parameters_decl_/**/DREALKIND
    implicit none
    real(DREALKIND), intent(out) :: m_ex(7)
    integer        :: i
    real(DREALKIND) :: m_ex_orig(7)
    ! External particle masses for in the identity permutation
    m_ex_orig = [ rZERO, rZERO, rZERO, rZERO, rZERO, rZERO, rZERO ]
    do i = 1, 7
      m_ex(i) = m_ex_orig(external_perm_qqxggggg_ddxggggg_1(i))
    end do
  end subroutine get_masses


  subroutine get_masses_c(m_ex) &
      & bind(c,name="ol_get_masses_qqxggggg_ddxggggg_1")
    use KIND_TYPES, only: DREALKIND
    use, intrinsic :: iso_c_binding, only: c_double
    implicit none
    real(c_double), intent(out) :: m_ex(7)
    real(DREALKIND) :: f_m_ex(7)
    call get_masses(f_m_ex)
    m_ex = f_m_ex
  end subroutine get_masses_c


  subroutine rambo(sqrt_s, p_rambo) &
      & bind(c,name="ol_f_rambo_qqxggggg_ddxggggg_1")
    use KIND_TYPES, only: DREALKIND
    use ol_kinematics_/**/DREALKIND, only: rambo_generic => rambo
    implicit none
    real(DREALKIND), intent(in) :: sqrt_s
    real(DREALKIND), intent(out) :: p_rambo(0:3,7)
    real(DREALKIND) :: m_ex(7)
    call get_masses(m_ex)
    call rambo_generic(sqrt_s, m_ex, p_rambo)
  end subroutine rambo


  subroutine rambo_c(sqrt_s, p_rambo) &
      & bind(c,name="ol_rambo_qqxggggg_ddxggggg_1")
    use KIND_TYPES, only: DREALKIND
    use, intrinsic :: iso_c_binding, only: c_double
    implicit none
    real(c_double), intent(in) :: sqrt_s
    real(c_double), intent(out) :: p_rambo(0:3,7)
    real(DREALKIND) :: f_sqrt_s
    real(DREALKIND) :: f_p_rambo(0:3,7)
    f_sqrt_s = sqrt_s
    call rambo(f_sqrt_s, f_p_rambo)
    p_rambo = f_p_rambo
  end subroutine rambo_c


  subroutine hel_init
    implicit none
    integer :: binpos, flip, binco
    hel_not_initialised = .false.
    ! helicity configurations for this process
  H(:,  1) = [ -1, -1, -1, -1, -1, -1, -1 ]
  H(:,  2) = [ -1, -1, -1, -1, -1, -1,  1 ]
  H(:,  3) = [ -1, -1, -1, -1, -1,  1, -1 ]
  H(:,  4) = [ -1, -1, -1, -1, -1,  1,  1 ]
  H(:,  5) = [ -1, -1, -1, -1,  1, -1, -1 ]
  H(:,  6) = [ -1, -1, -1, -1,  1, -1,  1 ]
  H(:,  7) = [ -1, -1, -1, -1,  1,  1, -1 ]
  H(:,  8) = [ -1, -1, -1, -1,  1,  1,  1 ]
  H(:,  9) = [ -1, -1, -1,  1, -1, -1, -1 ]
  H(:, 10) = [ -1, -1, -1,  1, -1, -1,  1 ]
  H(:, 11) = [ -1, -1, -1,  1, -1,  1, -1 ]
  H(:, 12) = [ -1, -1, -1,  1, -1,  1,  1 ]
  H(:, 13) = [ -1, -1, -1,  1,  1, -1, -1 ]
  H(:, 14) = [ -1, -1, -1,  1,  1, -1,  1 ]
  H(:, 15) = [ -1, -1, -1,  1,  1,  1, -1 ]
  H(:, 16) = [ -1, -1, -1,  1,  1,  1,  1 ]
  H(:, 17) = [ -1, -1,  1, -1, -1, -1, -1 ]
  H(:, 18) = [ -1, -1,  1, -1, -1, -1,  1 ]
  H(:, 19) = [ -1, -1,  1, -1, -1,  1, -1 ]
  H(:, 20) = [ -1, -1,  1, -1, -1,  1,  1 ]
  H(:, 21) = [ -1, -1,  1, -1,  1, -1, -1 ]
  H(:, 22) = [ -1, -1,  1, -1,  1, -1,  1 ]
  H(:, 23) = [ -1, -1,  1, -1,  1,  1, -1 ]
  H(:, 24) = [ -1, -1,  1, -1,  1,  1,  1 ]
  H(:, 25) = [ -1, -1,  1,  1, -1, -1, -1 ]
  H(:, 26) = [ -1, -1,  1,  1, -1, -1,  1 ]
  H(:, 27) = [ -1, -1,  1,  1, -1,  1, -1 ]
  H(:, 28) = [ -1, -1,  1,  1, -1,  1,  1 ]
  H(:, 29) = [ -1, -1,  1,  1,  1, -1, -1 ]
  H(:, 30) = [ -1, -1,  1,  1,  1, -1,  1 ]
  H(:, 31) = [ -1, -1,  1,  1,  1,  1, -1 ]
  H(:, 32) = [ -1, -1,  1,  1,  1,  1,  1 ]
  H(:, 33) = [ -1,  1, -1, -1, -1, -1, -1 ]
  H(:, 34) = [ -1,  1, -1, -1, -1, -1,  1 ]
  H(:, 35) = [ -1,  1, -1, -1, -1,  1, -1 ]
  H(:, 36) = [ -1,  1, -1, -1, -1,  1,  1 ]
  H(:, 37) = [ -1,  1, -1, -1,  1, -1, -1 ]
  H(:, 38) = [ -1,  1, -1, -1,  1, -1,  1 ]
  H(:, 39) = [ -1,  1, -1, -1,  1,  1, -1 ]
  H(:, 40) = [ -1,  1, -1, -1,  1,  1,  1 ]
  H(:, 41) = [ -1,  1, -1,  1, -1, -1, -1 ]
  H(:, 42) = [ -1,  1, -1,  1, -1, -1,  1 ]
  H(:, 43) = [ -1,  1, -1,  1, -1,  1, -1 ]
  H(:, 44) = [ -1,  1, -1,  1, -1,  1,  1 ]
  H(:, 45) = [ -1,  1, -1,  1,  1, -1, -1 ]
  H(:, 46) = [ -1,  1, -1,  1,  1, -1,  1 ]
  H(:, 47) = [ -1,  1, -1,  1,  1,  1, -1 ]
  H(:, 48) = [ -1,  1, -1,  1,  1,  1,  1 ]
  H(:, 49) = [ -1,  1,  1, -1, -1, -1, -1 ]
  H(:, 50) = [ -1,  1,  1, -1, -1, -1,  1 ]
  H(:, 51) = [ -1,  1,  1, -1, -1,  1, -1 ]
  H(:, 52) = [ -1,  1,  1, -1, -1,  1,  1 ]
  H(:, 53) = [ -1,  1,  1, -1,  1, -1, -1 ]
  H(:, 54) = [ -1,  1,  1, -1,  1, -1,  1 ]
  H(:, 55) = [ -1,  1,  1, -1,  1,  1, -1 ]
  H(:, 56) = [ -1,  1,  1, -1,  1,  1,  1 ]
  H(:, 57) = [ -1,  1,  1,  1, -1, -1, -1 ]
  H(:, 58) = [ -1,  1,  1,  1, -1, -1,  1 ]
  H(:, 59) = [ -1,  1,  1,  1, -1,  1, -1 ]
  H(:, 60) = [ -1,  1,  1,  1, -1,  1,  1 ]
  H(:, 61) = [ -1,  1,  1,  1,  1, -1, -1 ]
  H(:, 62) = [ -1,  1,  1,  1,  1, -1,  1 ]
  H(:, 63) = [ -1,  1,  1,  1,  1,  1, -1 ]
  H(:, 64) = [ -1,  1,  1,  1,  1,  1,  1 ]
  H(:, 65) = [  1, -1, -1, -1, -1, -1, -1 ]
  H(:, 66) = [  1, -1, -1, -1, -1, -1,  1 ]
  H(:, 67) = [  1, -1, -1, -1, -1,  1, -1 ]
  H(:, 68) = [  1, -1, -1, -1, -1,  1,  1 ]
  H(:, 69) = [  1, -1, -1, -1,  1, -1, -1 ]
  H(:, 70) = [  1, -1, -1, -1,  1, -1,  1 ]
  H(:, 71) = [  1, -1, -1, -1,  1,  1, -1 ]
  H(:, 72) = [  1, -1, -1, -1,  1,  1,  1 ]
  H(:, 73) = [  1, -1, -1,  1, -1, -1, -1 ]
  H(:, 74) = [  1, -1, -1,  1, -1, -1,  1 ]
  H(:, 75) = [  1, -1, -1,  1, -1,  1, -1 ]
  H(:, 76) = [  1, -1, -1,  1, -1,  1,  1 ]
  H(:, 77) = [  1, -1, -1,  1,  1, -1, -1 ]
  H(:, 78) = [  1, -1, -1,  1,  1, -1,  1 ]
  H(:, 79) = [  1, -1, -1,  1,  1,  1, -1 ]
  H(:, 80) = [  1, -1, -1,  1,  1,  1,  1 ]
  H(:, 81) = [  1, -1,  1, -1, -1, -1, -1 ]
  H(:, 82) = [  1, -1,  1, -1, -1, -1,  1 ]
  H(:, 83) = [  1, -1,  1, -1, -1,  1, -1 ]
  H(:, 84) = [  1, -1,  1, -1, -1,  1,  1 ]
  H(:, 85) = [  1, -1,  1, -1,  1, -1, -1 ]
  H(:, 86) = [  1, -1,  1, -1,  1, -1,  1 ]
  H(:, 87) = [  1, -1,  1, -1,  1,  1, -1 ]
  H(:, 88) = [  1, -1,  1, -1,  1,  1,  1 ]
  H(:, 89) = [  1, -1,  1,  1, -1, -1, -1 ]
  H(:, 90) = [  1, -1,  1,  1, -1, -1,  1 ]
  H(:, 91) = [  1, -1,  1,  1, -1,  1, -1 ]
  H(:, 92) = [  1, -1,  1,  1, -1,  1,  1 ]
  H(:, 93) = [  1, -1,  1,  1,  1, -1, -1 ]
  H(:, 94) = [  1, -1,  1,  1,  1, -1,  1 ]
  H(:, 95) = [  1, -1,  1,  1,  1,  1, -1 ]
  H(:, 96) = [  1, -1,  1,  1,  1,  1,  1 ]
  H(:, 97) = [  1,  1, -1, -1, -1, -1, -1 ]
  H(:, 98) = [  1,  1, -1, -1, -1, -1,  1 ]
  H(:, 99) = [  1,  1, -1, -1, -1,  1, -1 ]
  H(:,100) = [  1,  1, -1, -1, -1,  1,  1 ]
  H(:,101) = [  1,  1, -1, -1,  1, -1, -1 ]
  H(:,102) = [  1,  1, -1, -1,  1, -1,  1 ]
  H(:,103) = [  1,  1, -1, -1,  1,  1, -1 ]
  H(:,104) = [  1,  1, -1, -1,  1,  1,  1 ]
  H(:,105) = [  1,  1, -1,  1, -1, -1, -1 ]
  H(:,106) = [  1,  1, -1,  1, -1, -1,  1 ]
  H(:,107) = [  1,  1, -1,  1, -1,  1, -1 ]
  H(:,108) = [  1,  1, -1,  1, -1,  1,  1 ]
  H(:,109) = [  1,  1, -1,  1,  1, -1, -1 ]
  H(:,110) = [  1,  1, -1,  1,  1, -1,  1 ]
  H(:,111) = [  1,  1, -1,  1,  1,  1, -1 ]
  H(:,112) = [  1,  1, -1,  1,  1,  1,  1 ]
  H(:,113) = [  1,  1,  1, -1, -1, -1, -1 ]
  H(:,114) = [  1,  1,  1, -1, -1, -1,  1 ]
  H(:,115) = [  1,  1,  1, -1, -1,  1, -1 ]
  H(:,116) = [  1,  1,  1, -1, -1,  1,  1 ]
  H(:,117) = [  1,  1,  1, -1,  1, -1, -1 ]
  H(:,118) = [  1,  1,  1, -1,  1, -1,  1 ]
  H(:,119) = [  1,  1,  1, -1,  1,  1, -1 ]
  H(:,120) = [  1,  1,  1, -1,  1,  1,  1 ]
  H(:,121) = [  1,  1,  1,  1, -1, -1, -1 ]
  H(:,122) = [  1,  1,  1,  1, -1, -1,  1 ]
  H(:,123) = [  1,  1,  1,  1, -1,  1, -1 ]
  H(:,124) = [  1,  1,  1,  1, -1,  1,  1 ]
  H(:,125) = [  1,  1,  1,  1,  1, -1, -1 ]
  H(:,126) = [  1,  1,  1,  1,  1, -1,  1 ]
  H(:,127) = [  1,  1,  1,  1,  1,  1, -1 ]
  H(:,128) = [  1,  1,  1,  1,  1,  1,  1 ]

  H_HC(:,3) = [ ((((2*(binco-1)+flip)*16+binpos, flip = 0, 1), binpos = 1, 16), binco = 1, 128/16/2) ]
  H_HC(:,4) = [ ((((2*(binco-1)+flip)*8+binpos, flip = 0, 1), binpos = 1, 8), binco = 1, 128/8/2) ]
  H_HC(:,5) = [ ((((2*(binco-1)+flip)*4+binpos, flip = 0, 1), binpos = 1, 4), binco = 1, 128/4/2) ]
  H_HC(:,6) = [ ((((2*(binco-1)+flip)*2+binpos, flip = 0, 1), binpos = 1, 2), binco = 1, 128/2/2) ]
  H_HC(:,7) = [ ((((2*(binco-1)+flip)*1+binpos, flip = 0, 1), binpos = 1, 1), binco = 1, 128/1/2) ]
  end subroutine hel_init


  subroutine pol_init(pol) &
      & bind(c,name="ol_f_pol_init_qqxggggg_ddxggggg_1")
    implicit none
    integer, intent(in) :: pol(7)
    POLSEL = pol
  end subroutine pol_init


  subroutine set_photons(photon_id) &
      & bind(c,name="ol_f_set_photons_qqxggggg_ddxggggg_1")
    implicit none
    integer, intent(in) :: photon_id(7)
    photonid_qqxggggg_ddxggggg_1 = photon_id
  end subroutine set_photons


end module ol_external_qqxggggg_ddxggggg_1


module ol_settings_qqxggggg_ddxggggg_1
  implicit none
  ! Activates optimized helicity bookkeeping. Default=false
    logical, save :: hel_mem_opt = .false.
  ! Calculate loop correlators
    logical, save :: loopcc = .false.

  contains

  subroutine set_hel_mem_opt(set) &
      & bind(c,name="ol_hel_mem_opt_qqxggggg_ddxggggg_1")
    implicit none
    logical, intent(in) :: set
    hel_mem_opt = set
  end subroutine set_hel_mem_opt

  subroutine set_loopcc(set,was) &
      & bind(c,name="ol_loopcc_qqxggggg_ddxggggg_1")
    implicit none
    logical, intent(in) :: set
    logical :: was
    was = loopcc
    loopcc = set
  end subroutine set_loopcc

end module ol_settings_qqxggggg_ddxggggg_1

module colour_basis_qqxggggg_ddxggggg_1
  implicit none
  ! tree colour basis
  integer, save :: extcolours(7) = [1,1,2,2,2,2,2]
  contains

  pure subroutine tree_colbasis_dim(extcols, ncolb, ncoupl, maxpows, nhel) &
    & bind(c, name="ol_tree_colbasis_dim_qqxggggg_ddxggggg_1")
    implicit none
    ! colour representation of external particles: 0=neutral, 1=fundamental, 2=adjoint
    integer, intent(out) :: extcols(7)
    ! number of tree colour basis elements; number of selected couplings, number of selected powers per coupling
    integer, intent(out) :: ncolb, ncoupl, maxpows
    ! number of helicity configurations (all, not just non-vanishing)
    integer, intent(out) :: nhel
    extcols = extcolours
    ncolb = 120
    ncoupl = 1
    maxpows = 1
    nhel = 128
  end subroutine tree_colbasis_dim

  subroutine tree_colbasis(basis, powers) &
    & bind(c, name="ol_tree_colbasis_qqxggggg_ddxggggg_1")
    implicit none
    integer, intent(out) :: powers(1,1)
    integer, intent(out) :: basis(3,120)
#if 1 > 0
    ! selected powers for each selected coupling
    powers = reshape([0], [1,1])
#endif
#if 120 > 0
    ! tree colour basis: [[composition_number, permutation_number, *coupling_powers], ...]
    basis = reshape( &
      [4,1746,0,4,1752,0,4,1770,0,4,1776,0,4,1794,0,4,1800,0,4,1866,0,4,1872,0,4,1890,0,4,1896,0,4,1914,0,4,1920,0,4,1986,0,4 &
      ,1992,0,4,2010,0,4,2016,0,4,2034,0,4,2040,0,4,2106,0,4,2112,0,4,2130,0,4,2136,0,4,2154,0,4,2160,0,4,2466,0,4,2472,0,4 &
      ,2490,0,4,2496,0,4,2514,0,4,2520,0,4,2586,0,4,2592,0,4,2610,0,4,2616,0,4,2634,0,4,2640,0,4,2706,0,4,2712,0,4,2730,0,4 &
      ,2736,0,4,2754,0,4,2760,0,4,2826,0,4,2832,0,4,2850,0,4,2856,0,4,2874,0,4,2880,0,4,3186,0,4,3192,0,4,3210,0,4,3216,0,4 &
      ,3234,0,4,3240,0,4,3306,0,4,3312,0,4,3330,0,4,3336,0,4,3354,0,4,3360,0,4,3426,0,4,3432,0,4,3450,0,4,3456,0,4,3474,0,4 &
      ,3480,0,4,3546,0,4,3552,0,4,3570,0,4,3576,0,4,3594,0,4,3600,0,4,3906,0,4,3912,0,4,3930,0,4,3936,0,4,3954,0,4,3960,0,4 &
      ,4026,0,4,4032,0,4,4050,0,4,4056,0,4,4074,0,4,4080,0,4,4146,0,4,4152,0,4,4170,0,4,4176,0,4,4194,0,4,4200,0,4,4266,0,4 &
      ,4272,0,4,4290,0,4,4296,0,4,4314,0,4,4320,0,4,4626,0,4,4632,0,4,4650,0,4,4656,0,4,4674,0,4,4680,0,4,4746,0,4,4752,0,4 &
      ,4770,0,4,4776,0,4,4794,0,4,4800,0,4,4866,0,4,4872,0,4,4890,0,4,4896,0,4,4914,0,4,4920,0,4,4986,0,4,4992,0,4,5010,0,4 &
      ,5016,0,4,5034,0,4,5040,0], &
      [3,120])
#endif
  end subroutine tree_colbasis


  pure subroutine loop_colbasis_dim(extcols, ncolb, ncoupl, maxpows, nhel) &
    & bind(c, name="ol_loop_colbasis_dim_qqxggggg_ddxggggg_1")
    implicit none
    ! colour representation of external particles: 0=neutral, 1=fundamental, 2=adjoint
    integer, intent(out) :: extcols(7)
    ! number of loop colour basis elements; number of selected couplings, number of selected powers per coupling
    integer, intent(out) :: ncolb, ncoupl, maxpows
    ! number of helicity configurations (all, not just non-vanishing)
    integer, intent(out) :: nhel
    extcols = extcolours
    ncolb = 120
    ncoupl = 1
    maxpows = 1
    nhel = 128
  end subroutine loop_colbasis_dim

  subroutine loop_colbasis(basis, powers) &
    & bind(c, name="ol_loop_colbasis_qqxggggg_ddxggggg_1")
    implicit none
    integer, intent(out) :: powers(1,1)
    integer, intent(out) :: basis(3,120)
#if 1 > 0
    ! selected powers for each selected coupling
    powers = reshape([0], [1,1])
#endif
#if 120 > 0
    basis = 0 ! TODO
    ! loop colour basis: [[composition_number, permutation_number, *coupling_powers], ...]
!    basis = reshape( &
!<\*colourbasis\*>, &
!      [3,Part[{{120, 120}}, -1, 21]])
#endif
  end subroutine loop_colbasis


end module colour_basis_qqxggggg_ddxggggg_1

! **********************************************************************
module ol_heltables_qqxggggg_ddxggggg_1
! **********************************************************************
  use KIND_TYPES, only: intkind2
  implicit none

  logical :: heltables_not_init = .true.

  ! helicity states of external particles
  ! integer, save :: &
  !   H1(2) = [-1,1], &
  !   H2(3) = [-1,0,1]
  !   ...
  integer, save :: &
    H1(2) = [-1,1], &
    H2(2) = [-1,1], &
    H3(2) = [-1,1], &
    H4(2) = [-1,1], &
    H5(2) = [-1,1], &
    H6(2) = [-1,1], &
    H7(2) = [-1,1]

  ! number of helicity states for wave functions returned by a propagator call: n2(sz)
  ! number of helicity states for wave functions in a v-point vertex call (v >= 3)
  ! or a contraction (v = 3): n<v>(v,sz)
  integer(intkind2), save :: n2(130), n3(3,2556), n4(4,195)

  ! helicity tables used in the construction of the h helicity states of a wave function (amplitude)
  ! from an v-point vertex (contraction): t<v>x<h>(v-1,h,sz)
  integer(intkind2), save :: t3x4(2,4,21), t3x8(2,8,105), t3x16(2,16,540), t3x128(2,128,1890), t4x8(3,8,30), t4x32(3,32,45), &
    t4x16(3,16,120)

  ! change of global-helicity state resulting from flip of individual-particle helicity
  integer(intkind2), save :: eflip(128,7)
  integer,           save :: exthel(128,7)
  integer,           save :: firstpol(7)

  contains

! **********************************************************************
subroutine init_heltables
! **********************************************************************
  use ol_helicity_init, only: heltable
  implicit none

  ! I/O helicity tables for vertices, propagators and contractions;
  ! helicity table for a vertex call: n_in/n_out are the number helicity states of the incoming/outgoing wave functions
  ! call heltable([<n_in1>, <n_in2>, ..., <n_out>], n, t)
  ! propagators only need the number of helicity configurations which is equal for the incoming and outgoing wave function
  ! n = <n>
  call heltable([2,2,4], n3(:,1), t3x4(:,:,1))
  call heltable([2,2,2,8], n4(:,1), t4x8(:,:,1))
  call heltable([4,2,2,16], n4(:,2), t4x16(:,:,1))
  call heltable([2,2,2,8], n4(:,3), t4x8(:,:,2))
  call heltable([2,2,2,8], n4(:,4), t4x8(:,:,3))
  call heltable([2,2,4,16], n4(:,5), t4x16(:,:,2))
  call heltable([2,4,2,16], n4(:,6), t4x16(:,:,3))
  call heltable([2,2,2,8], n4(:,7), t4x8(:,:,4))
  call heltable([4,2,2,16], n4(:,8), t4x16(:,:,4))
  call heltable([2,2,2,8], n4(:,9), t4x8(:,:,5))
  call heltable([2,2,2,8], n4(:,10), t4x8(:,:,6))
  call heltable([2,2,4,16], n4(:,11), t4x16(:,:,5))
  call heltable([2,4,2,16], n4(:,12), t4x16(:,:,6))
  call heltable([2,2,2,8], n4(:,13), t4x8(:,:,7))
  call heltable([4,2,2,16], n4(:,14), t4x16(:,:,7))
  call heltable([2,2,2,8], n4(:,15), t4x8(:,:,8))
  call heltable([2,2,2,8], n4(:,16), t4x8(:,:,9))
  call heltable([2,2,4,16], n4(:,17), t4x16(:,:,8))
  call heltable([2,4,2,16], n4(:,18), t4x16(:,:,9))
  call heltable([2,2,2,8], n4(:,19), t4x8(:,:,10))
  call heltable([4,2,2,16], n4(:,20), t4x16(:,:,10))
  call heltable([2,2,4,16], n4(:,21), t4x16(:,:,11))
  call heltable([2,4,2,16], n4(:,22), t4x16(:,:,12))
  call heltable([2,2,2,8], n4(:,23), t4x8(:,:,11))
  call heltable([2,2,2,8], n4(:,24), t4x8(:,:,12))
  call heltable([2,2,2,8], n4(:,25), t4x8(:,:,13))
  call heltable([4,2,2,16], n4(:,26), t4x16(:,:,13))
  call heltable([2,2,2,8], n4(:,27), t4x8(:,:,14))
  call heltable([2,2,2,8], n4(:,28), t4x8(:,:,15))
  call heltable([2,2,4,16], n4(:,29), t4x16(:,:,14))
  call heltable([2,4,2,16], n4(:,30), t4x16(:,:,15))
  call heltable([2,2,2,8], n4(:,31), t4x8(:,:,16))
  call heltable([4,2,2,16], n4(:,32), t4x16(:,:,16))
  call heltable([2,2,2,8], n4(:,33), t4x8(:,:,17))
  call heltable([2,2,2,8], n4(:,34), t4x8(:,:,18))
  call heltable([2,2,4,16], n4(:,35), t4x16(:,:,17))
  call heltable([2,4,2,16], n4(:,36), t4x16(:,:,18))
  call heltable([2,2,2,8], n4(:,37), t4x8(:,:,19))
  call heltable([4,2,2,16], n4(:,38), t4x16(:,:,19))
  call heltable([2,2,4,16], n4(:,39), t4x16(:,:,20))
  call heltable([2,4,2,16], n4(:,40), t4x16(:,:,21))
  call heltable([2,2,2,8], n4(:,41), t4x8(:,:,20))
  call heltable([2,2,2,8], n4(:,42), t4x8(:,:,21))
  call heltable([2,2,2,8], n4(:,43), t4x8(:,:,22))
  call heltable([4,2,2,16], n4(:,44), t4x16(:,:,22))
  call heltable([2,2,2,8], n4(:,45), t4x8(:,:,23))
  call heltable([2,2,2,8], n4(:,46), t4x8(:,:,24))
  call heltable([2,2,4,16], n4(:,47), t4x16(:,:,23))
  call heltable([2,4,2,16], n4(:,48), t4x16(:,:,24))
  call heltable([2,2,2,8], n4(:,49), t4x8(:,:,25))
  call heltable([4,2,2,16], n4(:,50), t4x16(:,:,25))
  call heltable([2,2,4,16], n4(:,51), t4x16(:,:,26))
  call heltable([2,4,2,16], n4(:,52), t4x16(:,:,27))
  call heltable([2,2,2,8], n4(:,53), t4x8(:,:,26))
  call heltable([2,2,2,8], n4(:,54), t4x8(:,:,27))
  call heltable([2,2,2,8], n4(:,55), t4x8(:,:,28))
  call heltable([4,2,2,16], n4(:,56), t4x16(:,:,28))
  call heltable([2,2,4,16], n4(:,57), t4x16(:,:,29))
  call heltable([2,4,2,16], n4(:,58), t4x16(:,:,30))
  call heltable([2,2,2,8], n4(:,59), t4x8(:,:,29))
  call heltable([2,2,2,8], n4(:,60), t4x8(:,:,30))
  call heltable([2,2,4], n3(:,2), t3x4(:,:,2))
  call heltable([2,2,4], n3(:,3), t3x4(:,:,3))
  call heltable([4,4,2,32], n4(:,61), t4x32(:,:,1))
  call heltable([4,2,4,32], n4(:,62), t4x32(:,:,2))
  call heltable([2,4,4,32], n4(:,63), t4x32(:,:,3))
  call heltable([2,2,4], n3(:,4), t3x4(:,:,4))
  call heltable([4,4,2,32], n4(:,64), t4x32(:,:,4))
  call heltable([4,2,4,32], n4(:,65), t4x32(:,:,5))
  call heltable([2,4,4,32], n4(:,66), t4x32(:,:,6))
  call heltable([4,2,8], n3(:,5), t3x8(:,:,1))
  call heltable([4,2,2,16], n4(:,67), t4x16(:,:,31))
  call heltable([2,2,4,16], n4(:,68), t4x16(:,:,32))
  call heltable([2,4,2,16], n4(:,69), t4x16(:,:,33))
  call heltable([4,2,8], n3(:,6), t3x8(:,:,2))
  call heltable([2,2,4], n3(:,7), t3x4(:,:,5))
  call heltable([4,4,2,32], n4(:,70), t4x32(:,:,7))
  call heltable([4,2,4,32], n4(:,71), t4x32(:,:,8))
  call heltable([2,4,4,32], n4(:,72), t4x32(:,:,9))
  call heltable([4,2,8], n3(:,8), t3x8(:,:,3))
  call heltable([4,2,2,16], n4(:,73), t4x16(:,:,34))
  call heltable([2,2,4,16], n4(:,74), t4x16(:,:,35))
  call heltable([2,4,2,16], n4(:,75), t4x16(:,:,36))
  call heltable([4,2,8], n3(:,9), t3x8(:,:,4))
  call heltable([4,2,8], n3(:,10), t3x8(:,:,5))
  call heltable([4,2,2,16], n4(:,76), t4x16(:,:,37))
  call heltable([2,2,4,16], n4(:,77), t4x16(:,:,38))
  call heltable([2,4,2,16], n4(:,78), t4x16(:,:,39))
  call heltable([4,2,8], n3(:,11), t3x8(:,:,6))
  call heltable([4,4,16], n3(:,12), t3x16(:,:,1))
  call heltable([2,2,4], n3(:,13), t3x4(:,:,6))
  call heltable([2,2,4], n3(:,14), t3x4(:,:,7))
  call heltable([4,4,2,32], n4(:,79), t4x32(:,:,10))
  call heltable([4,2,4,32], n4(:,80), t4x32(:,:,11))
  call heltable([2,4,4,32], n4(:,81), t4x32(:,:,12))
  call heltable([2,2,4], n3(:,15), t3x4(:,:,8))
  call heltable([4,4,2,32], n4(:,82), t4x32(:,:,13))
  call heltable([4,2,4,32], n4(:,83), t4x32(:,:,14))
  call heltable([2,4,4,32], n4(:,84), t4x32(:,:,15))
  call heltable([4,2,8], n3(:,16), t3x8(:,:,7))
  call heltable([4,2,2,16], n4(:,85), t4x16(:,:,40))
  call heltable([2,2,4,16], n4(:,86), t4x16(:,:,41))
  call heltable([2,4,2,16], n4(:,87), t4x16(:,:,42))
  call heltable([2,4,8], n3(:,17), t3x8(:,:,8))
  call heltable([2,2,4], n3(:,18), t3x4(:,:,9))
  call heltable([2,2,4], n3(:,19), t3x4(:,:,10))
  call heltable([4,4,2,32], n4(:,88), t4x32(:,:,16))
  call heltable([4,2,4,32], n4(:,89), t4x32(:,:,17))
  call heltable([2,4,4,32], n4(:,90), t4x32(:,:,18))
  call heltable([2,2,4], n3(:,20), t3x4(:,:,11))
  call heltable([4,2,4,32], n4(:,91), t4x32(:,:,19))
  call heltable([2,4,4,32], n4(:,92), t4x32(:,:,20))
  call heltable([4,4,2,32], n4(:,93), t4x32(:,:,21))
  call heltable([4,2,8], n3(:,21), t3x8(:,:,9))
  call heltable([4,2,2,16], n4(:,94), t4x16(:,:,43))
  call heltable([2,2,4,16], n4(:,95), t4x16(:,:,44))
  call heltable([2,4,2,16], n4(:,96), t4x16(:,:,45))
  call heltable([2,4,8], n3(:,22), t3x8(:,:,10))
  call heltable([4,2,4,32], n4(:,97), t4x32(:,:,22))
  call heltable([2,4,4,32], n4(:,98), t4x32(:,:,23))
  call heltable([4,4,2,32], n4(:,99), t4x32(:,:,24))
  call heltable([2,4,2,16], n4(:,100), t4x16(:,:,46))
  call heltable([4,2,2,16], n4(:,101), t4x16(:,:,47))
  call heltable([2,2,4,16], n4(:,102), t4x16(:,:,48))
  call heltable([2,4,8], n3(:,23), t3x8(:,:,11))
  call heltable([4,2,4,32], n4(:,103), t4x32(:,:,25))
  call heltable([2,4,4,32], n4(:,104), t4x32(:,:,26))
  call heltable([4,4,2,32], n4(:,105), t4x32(:,:,27))
  call heltable([2,4,2,16], n4(:,106), t4x16(:,:,49))
  call heltable([4,2,2,16], n4(:,107), t4x16(:,:,50))
  call heltable([2,2,4,16], n4(:,108), t4x16(:,:,51))
  call heltable([2,4,8], n3(:,24), t3x8(:,:,12))
  call heltable([2,2,4,16], n4(:,109), t4x16(:,:,52))
  call heltable([2,4,2,16], n4(:,110), t4x16(:,:,53))
  call heltable([4,2,2,16], n4(:,111), t4x16(:,:,54))
  call heltable([2,4,8], n3(:,25), t3x8(:,:,13))
  call heltable([2,2,4,16], n4(:,112), t4x16(:,:,55))
  call heltable([2,4,2,16], n4(:,113), t4x16(:,:,56))
  call heltable([4,2,2,16], n4(:,114), t4x16(:,:,57))
  call heltable([2,4,8], n3(:,26), t3x8(:,:,14))
  call heltable([2,8,16], n3(:,27), t3x16(:,:,2))
  call heltable([2,8,16], n3(:,28), t3x16(:,:,3))
  call heltable([2,8,16], n3(:,29), t3x16(:,:,4))
  call heltable([2,8,16], n3(:,30), t3x16(:,:,5))
  call heltable([2,8,16], n3(:,31), t3x16(:,:,6))
  call heltable([2,8,16], n3(:,32), t3x16(:,:,7))
  call heltable([4,2,4,32], n4(:,115), t4x32(:,:,28))
  call heltable([2,4,4,32], n4(:,116), t4x32(:,:,29))
  call heltable([4,4,2,32], n4(:,117), t4x32(:,:,30))
  call heltable([2,4,2,16], n4(:,118), t4x16(:,:,58))
  call heltable([4,2,2,16], n4(:,119), t4x16(:,:,59))
  call heltable([2,2,4,16], n4(:,120), t4x16(:,:,60))
  call heltable([4,2,8], n3(:,33), t3x8(:,:,15))
  call heltable([2,4,2,16], n4(:,121), t4x16(:,:,61))
  call heltable([4,2,2,16], n4(:,122), t4x16(:,:,62))
  call heltable([2,2,4,16], n4(:,123), t4x16(:,:,63))
  call heltable([4,2,8], n3(:,34), t3x8(:,:,16))
  call heltable([4,4,16], n3(:,35), t3x16(:,:,8))
  call heltable([4,2,4,32], n4(:,124), t4x32(:,:,31))
  call heltable([2,4,4,32], n4(:,125), t4x32(:,:,32))
  call heltable([4,4,2,32], n4(:,126), t4x32(:,:,33))
  call heltable([2,4,2,16], n4(:,127), t4x16(:,:,64))
  call heltable([4,2,2,16], n4(:,128), t4x16(:,:,65))
  call heltable([2,2,4,16], n4(:,129), t4x16(:,:,66))
  call heltable([2,4,8], n3(:,36), t3x8(:,:,17))
  call heltable([4,2,4,32], n4(:,130), t4x32(:,:,34))
  call heltable([2,4,4,32], n4(:,131), t4x32(:,:,35))
  call heltable([4,4,2,32], n4(:,132), t4x32(:,:,36))
  call heltable([2,4,2,16], n4(:,133), t4x16(:,:,67))
  call heltable([4,2,2,16], n4(:,134), t4x16(:,:,68))
  call heltable([2,2,4,16], n4(:,135), t4x16(:,:,69))
  call heltable([2,4,8], n3(:,37), t3x8(:,:,18))
  call heltable([2,2,4,16], n4(:,136), t4x16(:,:,70))
  call heltable([2,4,2,16], n4(:,137), t4x16(:,:,71))
  call heltable([4,2,2,16], n4(:,138), t4x16(:,:,72))
  call heltable([2,4,8], n3(:,38), t3x8(:,:,19))
  call heltable([2,2,4,16], n4(:,139), t4x16(:,:,73))
  call heltable([2,4,2,16], n4(:,140), t4x16(:,:,74))
  call heltable([4,2,2,16], n4(:,141), t4x16(:,:,75))
  call heltable([2,4,8], n3(:,39), t3x8(:,:,20))
  call heltable([2,8,16], n3(:,40), t3x16(:,:,9))
  call heltable([2,8,16], n3(:,41), t3x16(:,:,10))
  call heltable([2,8,16], n3(:,42), t3x16(:,:,11))
  call heltable([2,8,16], n3(:,43), t3x16(:,:,12))
  call heltable([2,8,16], n3(:,44), t3x16(:,:,13))
  call heltable([2,8,16], n3(:,45), t3x16(:,:,14))
  call heltable([2,2,4,16], n4(:,142), t4x16(:,:,76))
  call heltable([2,4,2,16], n4(:,143), t4x16(:,:,77))
  call heltable([4,2,2,16], n4(:,144), t4x16(:,:,78))
  call heltable([4,2,8], n3(:,46), t3x8(:,:,21))
  call heltable([4,4,16], n3(:,47), t3x16(:,:,15))
  call heltable([2,2,4,16], n4(:,145), t4x16(:,:,79))
  call heltable([2,4,2,16], n4(:,146), t4x16(:,:,80))
  call heltable([4,2,2,16], n4(:,147), t4x16(:,:,81))
  call heltable([2,4,8], n3(:,48), t3x8(:,:,22))
  call heltable([2,2,4,16], n4(:,148), t4x16(:,:,82))
  call heltable([2,4,2,16], n4(:,149), t4x16(:,:,83))
  call heltable([4,2,2,16], n4(:,150), t4x16(:,:,84))
  call heltable([2,4,8], n3(:,49), t3x8(:,:,23))
  call heltable([2,8,16], n3(:,50), t3x16(:,:,16))
  call heltable([2,8,16], n3(:,51), t3x16(:,:,17))
  call heltable([2,8,16], n3(:,52), t3x16(:,:,18))
  call heltable([2,8,16], n3(:,53), t3x16(:,:,19))
  call heltable([2,8,16], n3(:,54), t3x16(:,:,20))
  call heltable([2,8,16], n3(:,55), t3x16(:,:,21))
  call heltable([4,4,16], n3(:,56), t3x16(:,:,22))
  call heltable([8,2,16], n3(:,57), t3x16(:,:,23))
  call heltable([8,2,16], n3(:,58), t3x16(:,:,24))
  call heltable([8,2,16], n3(:,59), t3x16(:,:,25))
  call heltable([2,8,16], n3(:,60), t3x16(:,:,26))
  call heltable([2,8,16], n3(:,61), t3x16(:,:,27))
  call heltable([2,8,16], n3(:,62), t3x16(:,:,28))
  call heltable([4,2,4,32], n4(:,151), t4x32(:,:,37))
  call heltable([2,4,4,32], n4(:,152), t4x32(:,:,38))
  call heltable([4,4,2,32], n4(:,153), t4x32(:,:,39))
  call heltable([2,4,2,16], n4(:,154), t4x16(:,:,85))
  call heltable([4,2,2,16], n4(:,155), t4x16(:,:,86))
  call heltable([2,2,4,16], n4(:,156), t4x16(:,:,87))
  call heltable([4,2,8], n3(:,63), t3x8(:,:,24))
  call heltable([2,4,2,16], n4(:,157), t4x16(:,:,88))
  call heltable([4,2,2,16], n4(:,158), t4x16(:,:,89))
  call heltable([2,2,4,16], n4(:,159), t4x16(:,:,90))
  call heltable([4,2,8], n3(:,64), t3x8(:,:,25))
  call heltable([4,4,16], n3(:,65), t3x16(:,:,29))
  call heltable([4,2,4,32], n4(:,160), t4x32(:,:,40))
  call heltable([2,4,4,32], n4(:,161), t4x32(:,:,41))
  call heltable([4,4,2,32], n4(:,162), t4x32(:,:,42))
  call heltable([2,4,2,16], n4(:,163), t4x16(:,:,91))
  call heltable([4,2,2,16], n4(:,164), t4x16(:,:,92))
  call heltable([2,2,4,16], n4(:,165), t4x16(:,:,93))
  call heltable([2,4,8], n3(:,66), t3x8(:,:,26))
  call heltable([4,2,4,32], n4(:,166), t4x32(:,:,43))
  call heltable([2,4,4,32], n4(:,167), t4x32(:,:,44))
  call heltable([4,4,2,32], n4(:,168), t4x32(:,:,45))
  call heltable([2,4,2,16], n4(:,169), t4x16(:,:,94))
  call heltable([4,2,2,16], n4(:,170), t4x16(:,:,95))
  call heltable([2,2,4,16], n4(:,171), t4x16(:,:,96))
  call heltable([2,4,8], n3(:,67), t3x8(:,:,27))
  call heltable([2,2,4,16], n4(:,172), t4x16(:,:,97))
  call heltable([2,4,2,16], n4(:,173), t4x16(:,:,98))
  call heltable([4,2,2,16], n4(:,174), t4x16(:,:,99))
  call heltable([2,4,8], n3(:,68), t3x8(:,:,28))
  call heltable([2,2,4,16], n4(:,175), t4x16(:,:,100))
  call heltable([2,4,2,16], n4(:,176), t4x16(:,:,101))
  call heltable([4,2,2,16], n4(:,177), t4x16(:,:,102))
  call heltable([2,4,8], n3(:,69), t3x8(:,:,29))
  call heltable([2,8,16], n3(:,70), t3x16(:,:,30))
  call heltable([2,8,16], n3(:,71), t3x16(:,:,31))
  call heltable([2,8,16], n3(:,72), t3x16(:,:,32))
  call heltable([2,8,16], n3(:,73), t3x16(:,:,33))
  call heltable([2,8,16], n3(:,74), t3x16(:,:,34))
  call heltable([2,8,16], n3(:,75), t3x16(:,:,35))
  call heltable([2,2,4,16], n4(:,178), t4x16(:,:,103))
  call heltable([2,4,2,16], n4(:,179), t4x16(:,:,104))
  call heltable([4,2,2,16], n4(:,180), t4x16(:,:,105))
  call heltable([4,2,8], n3(:,76), t3x8(:,:,30))
  call heltable([4,4,16], n3(:,77), t3x16(:,:,36))
  call heltable([2,2,4,16], n4(:,181), t4x16(:,:,106))
  call heltable([2,4,2,16], n4(:,182), t4x16(:,:,107))
  call heltable([4,2,2,16], n4(:,183), t4x16(:,:,108))
  call heltable([2,4,8], n3(:,78), t3x8(:,:,31))
  call heltable([2,2,4,16], n4(:,184), t4x16(:,:,109))
  call heltable([2,4,2,16], n4(:,185), t4x16(:,:,110))
  call heltable([4,2,2,16], n4(:,186), t4x16(:,:,111))
  call heltable([2,4,8], n3(:,79), t3x8(:,:,32))
  call heltable([2,8,16], n3(:,80), t3x16(:,:,37))
  call heltable([2,8,16], n3(:,81), t3x16(:,:,38))
  call heltable([2,8,16], n3(:,82), t3x16(:,:,39))
  call heltable([2,8,16], n3(:,83), t3x16(:,:,40))
  call heltable([2,8,16], n3(:,84), t3x16(:,:,41))
  call heltable([2,8,16], n3(:,85), t3x16(:,:,42))
  call heltable([4,4,16], n3(:,86), t3x16(:,:,43))
  call heltable([8,2,16], n3(:,87), t3x16(:,:,44))
  call heltable([8,2,16], n3(:,88), t3x16(:,:,45))
  call heltable([8,2,16], n3(:,89), t3x16(:,:,46))
  call heltable([2,8,16], n3(:,90), t3x16(:,:,47))
  call heltable([2,8,16], n3(:,91), t3x16(:,:,48))
  call heltable([2,8,16], n3(:,92), t3x16(:,:,49))
  call heltable([2,2,4,16], n4(:,187), t4x16(:,:,112))
  call heltable([2,4,2,16], n4(:,188), t4x16(:,:,113))
  call heltable([4,2,2,16], n4(:,189), t4x16(:,:,114))
  call heltable([4,2,8], n3(:,93), t3x8(:,:,33))
  call heltable([4,4,16], n3(:,94), t3x16(:,:,50))
  call heltable([2,2,4,16], n4(:,190), t4x16(:,:,115))
  call heltable([2,4,2,16], n4(:,191), t4x16(:,:,116))
  call heltable([4,2,2,16], n4(:,192), t4x16(:,:,117))
  call heltable([2,4,8], n3(:,95), t3x8(:,:,34))
  call heltable([2,2,4,16], n4(:,193), t4x16(:,:,118))
  call heltable([2,4,2,16], n4(:,194), t4x16(:,:,119))
  call heltable([4,2,2,16], n4(:,195), t4x16(:,:,120))
  call heltable([2,4,8], n3(:,96), t3x8(:,:,35))
  call heltable([2,8,16], n3(:,97), t3x16(:,:,51))
  call heltable([2,8,16], n3(:,98), t3x16(:,:,52))
  call heltable([2,8,16], n3(:,99), t3x16(:,:,53))
  call heltable([2,8,16], n3(:,100), t3x16(:,:,54))
  call heltable([2,8,16], n3(:,101), t3x16(:,:,55))
  call heltable([2,8,16], n3(:,102), t3x16(:,:,56))
  call heltable([4,4,16], n3(:,103), t3x16(:,:,57))
  call heltable([8,2,16], n3(:,104), t3x16(:,:,58))
  call heltable([8,2,16], n3(:,105), t3x16(:,:,59))
  call heltable([8,2,16], n3(:,106), t3x16(:,:,60))
  call heltable([2,8,16], n3(:,107), t3x16(:,:,61))
  call heltable([2,8,16], n3(:,108), t3x16(:,:,62))
  call heltable([2,8,16], n3(:,109), t3x16(:,:,63))
  call heltable([4,4,16], n3(:,110), t3x16(:,:,64))
  call heltable([8,2,16], n3(:,111), t3x16(:,:,65))
  call heltable([8,2,16], n3(:,112), t3x16(:,:,66))
  call heltable([8,2,16], n3(:,113), t3x16(:,:,67))
  call heltable([8,2,16], n3(:,114), t3x16(:,:,68))
  call heltable([8,2,16], n3(:,115), t3x16(:,:,69))
  call heltable([8,2,16], n3(:,116), t3x16(:,:,70))
  call heltable([2,2,4], n3(:,117), t3x4(:,:,12))
  call heltable([2,2,4], n3(:,118), t3x4(:,:,13))
  n2(1) = 4
  n2(2) = 4
  call heltable([4,4,16], n3(:,119), t3x16(:,:,71))
  call heltable([4,2,8], n3(:,120), t3x8(:,:,36))
  call heltable([2,8,16], n3(:,121), t3x16(:,:,72))
  call heltable([2,4,8], n3(:,122), t3x8(:,:,37))
  n2(3) = 16
  call heltable([2,8,16], n3(:,123), t3x16(:,:,73))
  n2(4) = 16
  call heltable([2,8,16], n3(:,124), t3x16(:,:,74))
  n2(5) = 16
  call heltable([2,2,4], n3(:,125), t3x4(:,:,14))
  n2(6) = 4
  call heltable([4,4,16], n3(:,126), t3x16(:,:,75))
  call heltable([2,8,16], n3(:,127), t3x16(:,:,76))
  call heltable([2,4,8], n3(:,128), t3x8(:,:,38))
  n2(7) = 16
  call heltable([2,8,16], n3(:,129), t3x16(:,:,77))
  n2(8) = 16
  call heltable([2,8,16], n3(:,130), t3x16(:,:,78))
  n2(9) = 16
  call heltable([2,2,4], n3(:,131), t3x4(:,:,15))
  n2(10) = 4
  call heltable([4,4,16], n3(:,132), t3x16(:,:,79))
  call heltable([2,8,16], n3(:,133), t3x16(:,:,80))
  call heltable([2,4,8], n3(:,134), t3x8(:,:,39))
  n2(11) = 16
  call heltable([2,8,16], n3(:,135), t3x16(:,:,81))
  n2(12) = 16
  call heltable([2,8,16], n3(:,136), t3x16(:,:,82))
  n2(13) = 16
  call heltable([2,2,4], n3(:,137), t3x4(:,:,16))
  n2(14) = 4
  call heltable([4,4,16], n3(:,138), t3x16(:,:,83))
  call heltable([2,8,16], n3(:,139), t3x16(:,:,84))
  call heltable([2,4,8], n3(:,140), t3x8(:,:,40))
  n2(15) = 16
  call heltable([2,8,16], n3(:,141), t3x16(:,:,85))
  n2(16) = 16
  call heltable([2,8,16], n3(:,142), t3x16(:,:,86))
  n2(17) = 16
  call heltable([2,2,4], n3(:,143), t3x4(:,:,17))
  call heltable([2,2,4], n3(:,144), t3x4(:,:,18))
  n2(18) = 4
  n2(19) = 4
  call heltable([4,4,16], n3(:,145), t3x16(:,:,87))
  call heltable([2,4,8], n3(:,146), t3x8(:,:,41))
  call heltable([8,2,16], n3(:,147), t3x16(:,:,88))
  call heltable([4,2,8], n3(:,148), t3x8(:,:,42))
  n2(20) = 16
  call heltable([8,2,16], n3(:,149), t3x16(:,:,89))
  n2(21) = 16
  call heltable([8,2,16], n3(:,150), t3x16(:,:,90))
  n2(22) = 16
  call heltable([2,2,4], n3(:,151), t3x4(:,:,19))
  n2(23) = 4
  call heltable([4,4,16], n3(:,152), t3x16(:,:,91))
  call heltable([8,2,16], n3(:,153), t3x16(:,:,92))
  call heltable([4,2,8], n3(:,154), t3x8(:,:,43))
  n2(24) = 16
  call heltable([8,2,16], n3(:,155), t3x16(:,:,93))
  n2(25) = 16
  call heltable([8,2,16], n3(:,156), t3x16(:,:,94))
  n2(26) = 16
  call heltable([2,2,4], n3(:,157), t3x4(:,:,20))
  n2(27) = 4
  call heltable([4,4,16], n3(:,158), t3x16(:,:,95))
  call heltable([8,2,16], n3(:,159), t3x16(:,:,96))
  call heltable([4,2,8], n3(:,160), t3x8(:,:,44))
  n2(28) = 16
  call heltable([8,2,16], n3(:,161), t3x16(:,:,97))
  n2(29) = 16
  call heltable([8,2,16], n3(:,162), t3x16(:,:,98))
  n2(30) = 16
  call heltable([2,2,4], n3(:,163), t3x4(:,:,21))
  n2(31) = 4
  call heltable([4,4,16], n3(:,164), t3x16(:,:,99))
  call heltable([8,2,16], n3(:,165), t3x16(:,:,100))
  call heltable([4,2,8], n3(:,166), t3x8(:,:,45))
  n2(32) = 16
  call heltable([8,2,16], n3(:,167), t3x16(:,:,101))
  n2(33) = 16
  call heltable([8,2,16], n3(:,168), t3x16(:,:,102))
  n2(34) = 16
  call heltable([4,2,8], n3(:,169), t3x8(:,:,46))
  call heltable([2,4,8], n3(:,170), t3x8(:,:,47))
  call heltable([2,4,8], n3(:,171), t3x8(:,:,48))
  call heltable([4,2,8], n3(:,172), t3x8(:,:,49))
  call heltable([4,2,8], n3(:,173), t3x8(:,:,50))
  call heltable([2,4,8], n3(:,174), t3x8(:,:,51))
  call heltable([4,2,8], n3(:,175), t3x8(:,:,52))
  call heltable([2,4,8], n3(:,176), t3x8(:,:,53))
  call heltable([4,2,8], n3(:,177), t3x8(:,:,54))
  call heltable([2,4,8], n3(:,178), t3x8(:,:,55))
  call heltable([4,2,8], n3(:,179), t3x8(:,:,56))
  n2(35) = 8
  call heltable([2,4,8], n3(:,180), t3x8(:,:,57))
  call heltable([2,4,8], n3(:,181), t3x8(:,:,58))
  call heltable([4,2,8], n3(:,182), t3x8(:,:,59))
  call heltable([4,2,8], n3(:,183), t3x8(:,:,60))
  n2(36) = 8
  call heltable([2,4,8], n3(:,184), t3x8(:,:,61))
  call heltable([2,4,8], n3(:,185), t3x8(:,:,62))
  call heltable([4,2,8], n3(:,186), t3x8(:,:,63))
  call heltable([4,2,8], n3(:,187), t3x8(:,:,64))
  n2(37) = 8
  call heltable([2,4,8], n3(:,188), t3x8(:,:,65))
  call heltable([2,4,8], n3(:,189), t3x8(:,:,66))
  call heltable([4,2,8], n3(:,190), t3x8(:,:,67))
  call heltable([4,2,8], n3(:,191), t3x8(:,:,68))
  n2(38) = 8
  call heltable([2,4,8], n3(:,192), t3x8(:,:,69))
  call heltable([4,4,16], n3(:,193), t3x16(:,:,103))
  call heltable([2,8,16], n3(:,194), t3x16(:,:,104))
  call heltable([2,4,8], n3(:,195), t3x8(:,:,70))
  n2(39) = 16
  call heltable([2,8,16], n3(:,196), t3x16(:,:,105))
  n2(40) = 16
  call heltable([2,8,16], n3(:,197), t3x16(:,:,106))
  n2(41) = 16
  call heltable([4,4,16], n3(:,198), t3x16(:,:,107))
  call heltable([2,8,16], n3(:,199), t3x16(:,:,108))
  call heltable([2,4,8], n3(:,200), t3x8(:,:,71))
  n2(42) = 16
  call heltable([2,8,16], n3(:,201), t3x16(:,:,109))
  n2(43) = 16
  call heltable([2,8,16], n3(:,202), t3x16(:,:,110))
  n2(44) = 16
  call heltable([4,4,16], n3(:,203), t3x16(:,:,111))
  call heltable([2,8,16], n3(:,204), t3x16(:,:,112))
  call heltable([2,4,8], n3(:,205), t3x8(:,:,72))
  n2(45) = 16
  call heltable([2,8,16], n3(:,206), t3x16(:,:,113))
  n2(46) = 16
  call heltable([2,8,16], n3(:,207), t3x16(:,:,114))
  n2(47) = 16
  call heltable([4,4,16], n3(:,208), t3x16(:,:,115))
  call heltable([8,2,16], n3(:,209), t3x16(:,:,116))
  call heltable([4,2,8], n3(:,210), t3x8(:,:,73))
  n2(48) = 16
  call heltable([8,2,16], n3(:,211), t3x16(:,:,117))
  n2(49) = 16
  call heltable([8,2,16], n3(:,212), t3x16(:,:,118))
  n2(50) = 16
  call heltable([4,4,16], n3(:,213), t3x16(:,:,119))
  call heltable([8,2,16], n3(:,214), t3x16(:,:,120))
  call heltable([4,2,8], n3(:,215), t3x8(:,:,74))
  n2(51) = 16
  call heltable([8,2,16], n3(:,216), t3x16(:,:,121))
  n2(52) = 16
  call heltable([8,2,16], n3(:,217), t3x16(:,:,122))
  n2(53) = 16
  call heltable([4,4,16], n3(:,218), t3x16(:,:,123))
  call heltable([8,2,16], n3(:,219), t3x16(:,:,124))
  call heltable([4,2,8], n3(:,220), t3x8(:,:,75))
  n2(54) = 16
  call heltable([8,2,16], n3(:,221), t3x16(:,:,125))
  n2(55) = 16
  call heltable([8,2,16], n3(:,222), t3x16(:,:,126))
  n2(56) = 16
  call heltable([2,4,8], n3(:,223), t3x8(:,:,76))
  call heltable([4,2,8], n3(:,224), t3x8(:,:,77))
  call heltable([4,2,8], n3(:,225), t3x8(:,:,78))
  n2(57) = 8
  call heltable([2,4,8], n3(:,226), t3x8(:,:,79))
  call heltable([2,4,8], n3(:,227), t3x8(:,:,80))
  call heltable([4,2,8], n3(:,228), t3x8(:,:,81))
  call heltable([4,2,8], n3(:,229), t3x8(:,:,82))
  n2(58) = 8
  call heltable([2,4,8], n3(:,230), t3x8(:,:,83))
  call heltable([2,4,8], n3(:,231), t3x8(:,:,84))
  call heltable([4,2,8], n3(:,232), t3x8(:,:,85))
  call heltable([4,2,8], n3(:,233), t3x8(:,:,86))
  n2(59) = 8
  call heltable([2,4,8], n3(:,234), t3x8(:,:,87))
  call heltable([4,4,16], n3(:,235), t3x16(:,:,127))
  call heltable([2,8,16], n3(:,236), t3x16(:,:,128))
  call heltable([2,4,8], n3(:,237), t3x8(:,:,88))
  n2(60) = 16
  call heltable([2,8,16], n3(:,238), t3x16(:,:,129))
  n2(61) = 16
  call heltable([2,8,16], n3(:,239), t3x16(:,:,130))
  n2(62) = 16
  call heltable([4,4,16], n3(:,240), t3x16(:,:,131))
  call heltable([2,8,16], n3(:,241), t3x16(:,:,132))
  call heltable([2,4,8], n3(:,242), t3x8(:,:,89))
  n2(63) = 16
  call heltable([2,8,16], n3(:,243), t3x16(:,:,133))
  n2(64) = 16
  call heltable([2,8,16], n3(:,244), t3x16(:,:,134))
  n2(65) = 16
  call heltable([4,4,16], n3(:,245), t3x16(:,:,135))
  call heltable([8,2,16], n3(:,246), t3x16(:,:,136))
  call heltable([4,2,8], n3(:,247), t3x8(:,:,90))
  n2(66) = 16
  call heltable([8,2,16], n3(:,248), t3x16(:,:,137))
  n2(67) = 16
  call heltable([8,2,16], n3(:,249), t3x16(:,:,138))
  n2(68) = 16
  call heltable([4,4,16], n3(:,250), t3x16(:,:,139))
  call heltable([8,2,16], n3(:,251), t3x16(:,:,140))
  call heltable([4,2,8], n3(:,252), t3x8(:,:,91))
  n2(69) = 16
  call heltable([8,2,16], n3(:,253), t3x16(:,:,141))
  n2(70) = 16
  call heltable([8,2,16], n3(:,254), t3x16(:,:,142))
  n2(71) = 16
  call heltable([2,4,8], n3(:,255), t3x8(:,:,92))
  call heltable([4,2,8], n3(:,256), t3x8(:,:,93))
  call heltable([4,2,8], n3(:,257), t3x8(:,:,94))
  n2(72) = 8
  call heltable([2,4,8], n3(:,258), t3x8(:,:,95))
  call heltable([2,4,8], n3(:,259), t3x8(:,:,96))
  call heltable([4,2,8], n3(:,260), t3x8(:,:,97))
  call heltable([4,2,8], n3(:,261), t3x8(:,:,98))
  n2(73) = 8
  call heltable([2,4,8], n3(:,262), t3x8(:,:,99))
  call heltable([4,4,16], n3(:,263), t3x16(:,:,143))
  call heltable([2,8,16], n3(:,264), t3x16(:,:,144))
  call heltable([2,4,8], n3(:,265), t3x8(:,:,100))
  n2(74) = 16
  call heltable([2,8,16], n3(:,266), t3x16(:,:,145))
  n2(75) = 16
  call heltable([2,8,16], n3(:,267), t3x16(:,:,146))
  n2(76) = 16
  call heltable([4,4,16], n3(:,268), t3x16(:,:,147))
  call heltable([8,2,16], n3(:,269), t3x16(:,:,148))
  call heltable([4,2,8], n3(:,270), t3x8(:,:,101))
  n2(77) = 16
  call heltable([8,2,16], n3(:,271), t3x16(:,:,149))
  n2(78) = 16
  call heltable([8,2,16], n3(:,272), t3x16(:,:,150))
  n2(79) = 16
  call heltable([2,4,8], n3(:,273), t3x8(:,:,102))
  call heltable([4,2,8], n3(:,274), t3x8(:,:,103))
  call heltable([4,2,8], n3(:,275), t3x8(:,:,104))
  n2(80) = 8
  call heltable([2,4,8], n3(:,276), t3x8(:,:,105))
  call heltable([4,4,16], n3(:,277), t3x16(:,:,151))
  call heltable([4,4,16], n3(:,278), t3x16(:,:,152))
  call heltable([4,4,16], n3(:,279), t3x16(:,:,153))
  call heltable([8,2,16], n3(:,280), t3x16(:,:,154))
  call heltable([8,2,16], n3(:,281), t3x16(:,:,155))
  call heltable([8,2,16], n3(:,282), t3x16(:,:,156))
  call heltable([2,8,16], n3(:,283), t3x16(:,:,157))
  call heltable([8,2,16], n3(:,284), t3x16(:,:,158))
  call heltable([2,8,16], n3(:,285), t3x16(:,:,159))
  call heltable([4,4,16], n3(:,286), t3x16(:,:,160))
  call heltable([4,4,16], n3(:,287), t3x16(:,:,161))
  call heltable([4,4,16], n3(:,288), t3x16(:,:,162))
  call heltable([8,2,16], n3(:,289), t3x16(:,:,163))
  call heltable([8,2,16], n3(:,290), t3x16(:,:,164))
  call heltable([8,2,16], n3(:,291), t3x16(:,:,165))
  call heltable([2,8,16], n3(:,292), t3x16(:,:,166))
  call heltable([8,2,16], n3(:,293), t3x16(:,:,167))
  call heltable([2,8,16], n3(:,294), t3x16(:,:,168))
  call heltable([4,4,16], n3(:,295), t3x16(:,:,169))
  call heltable([4,4,16], n3(:,296), t3x16(:,:,170))
  call heltable([4,4,16], n3(:,297), t3x16(:,:,171))
  call heltable([8,2,16], n3(:,298), t3x16(:,:,172))
  call heltable([8,2,16], n3(:,299), t3x16(:,:,173))
  call heltable([8,2,16], n3(:,300), t3x16(:,:,174))
  call heltable([2,8,16], n3(:,301), t3x16(:,:,175))
  call heltable([8,2,16], n3(:,302), t3x16(:,:,176))
  call heltable([2,8,16], n3(:,303), t3x16(:,:,177))
  call heltable([4,4,16], n3(:,304), t3x16(:,:,178))
  call heltable([4,4,16], n3(:,305), t3x16(:,:,179))
  call heltable([8,2,16], n3(:,306), t3x16(:,:,180))
  call heltable([8,2,16], n3(:,307), t3x16(:,:,181))
  call heltable([2,8,16], n3(:,308), t3x16(:,:,182))
  call heltable([2,8,16], n3(:,309), t3x16(:,:,183))
  call heltable([2,8,16], n3(:,310), t3x16(:,:,184))
  call heltable([4,4,16], n3(:,311), t3x16(:,:,185))
  call heltable([4,4,16], n3(:,312), t3x16(:,:,186))
  call heltable([8,2,16], n3(:,313), t3x16(:,:,187))
  call heltable([8,2,16], n3(:,314), t3x16(:,:,188))
  call heltable([2,8,16], n3(:,315), t3x16(:,:,189))
  call heltable([2,8,16], n3(:,316), t3x16(:,:,190))
  call heltable([2,8,16], n3(:,317), t3x16(:,:,191))
  call heltable([4,4,16], n3(:,318), t3x16(:,:,192))
  call heltable([4,4,16], n3(:,319), t3x16(:,:,193))
  call heltable([8,2,16], n3(:,320), t3x16(:,:,194))
  call heltable([2,8,16], n3(:,321), t3x16(:,:,195))
  call heltable([8,2,16], n3(:,322), t3x16(:,:,196))
  call heltable([2,8,16], n3(:,323), t3x16(:,:,197))
  call heltable([2,8,16], n3(:,324), t3x16(:,:,198))
  call heltable([2,8,16], n3(:,325), t3x16(:,:,199))
  call heltable([2,8,16], n3(:,326), t3x16(:,:,200))
  call heltable([2,8,16], n3(:,327), t3x16(:,:,201))
  call heltable([2,8,16], n3(:,328), t3x16(:,:,202))
  call heltable([2,8,16], n3(:,329), t3x16(:,:,203))
  call heltable([2,8,16], n3(:,330), t3x16(:,:,204))
  call heltable([2,8,16], n3(:,331), t3x16(:,:,205))
  call heltable([2,8,16], n3(:,332), t3x16(:,:,206))
  call heltable([2,8,16], n3(:,333), t3x16(:,:,207))
  call heltable([2,8,16], n3(:,334), t3x16(:,:,208))
  call heltable([2,8,16], n3(:,335), t3x16(:,:,209))
  call heltable([2,8,16], n3(:,336), t3x16(:,:,210))
  call heltable([4,4,16], n3(:,337), t3x16(:,:,211))
  n2(81) = 8
  call heltable([4,4,16], n3(:,338), t3x16(:,:,212))
  n2(82) = 8
  call heltable([4,4,16], n3(:,339), t3x16(:,:,213))
  n2(83) = 8
  call heltable([4,4,16], n3(:,340), t3x16(:,:,214))
  n2(84) = 8
  call heltable([4,4,16], n3(:,341), t3x16(:,:,215))
  n2(85) = 8
  call heltable([4,4,16], n3(:,342), t3x16(:,:,216))
  n2(86) = 8
  call heltable([2,8,16], n3(:,343), t3x16(:,:,217))
  call heltable([2,8,16], n3(:,344), t3x16(:,:,218))
  call heltable([8,2,16], n3(:,345), t3x16(:,:,219))
  call heltable([2,8,16], n3(:,346), t3x16(:,:,220))
  call heltable([8,2,16], n3(:,347), t3x16(:,:,221))
  call heltable([8,2,16], n3(:,348), t3x16(:,:,222))
  call heltable([4,4,16], n3(:,349), t3x16(:,:,223))
  call heltable([4,4,16], n3(:,350), t3x16(:,:,224))
  n2(87) = 8
  call heltable([4,4,16], n3(:,351), t3x16(:,:,225))
  call heltable([4,4,16], n3(:,352), t3x16(:,:,226))
  n2(88) = 8
  call heltable([4,4,16], n3(:,353), t3x16(:,:,227))
  n2(89) = 8
  n2(90) = 8
  call heltable([2,8,16], n3(:,354), t3x16(:,:,228))
  call heltable([2,8,16], n3(:,355), t3x16(:,:,229))
  call heltable([8,2,16], n3(:,356), t3x16(:,:,230))
  call heltable([2,8,16], n3(:,357), t3x16(:,:,231))
  call heltable([8,2,16], n3(:,358), t3x16(:,:,232))
  call heltable([8,2,16], n3(:,359), t3x16(:,:,233))
  call heltable([4,4,16], n3(:,360), t3x16(:,:,234))
  call heltable([4,4,16], n3(:,361), t3x16(:,:,235))
  n2(91) = 8
  call heltable([4,4,16], n3(:,362), t3x16(:,:,236))
  n2(92) = 8
  n2(93) = 8
  n2(94) = 8
  call heltable([8,2,16], n3(:,363), t3x16(:,:,237))
  call heltable([8,2,16], n3(:,364), t3x16(:,:,238))
  call heltable([8,2,16], n3(:,365), t3x16(:,:,239))
  call heltable([8,2,16], n3(:,366), t3x16(:,:,240))
  call heltable([8,2,16], n3(:,367), t3x16(:,:,241))
  call heltable([2,8,16], n3(:,368), t3x16(:,:,242))
  call heltable([4,4,16], n3(:,369), t3x16(:,:,243))
  n2(95) = 8
  call heltable([4,4,16], n3(:,370), t3x16(:,:,244))
  n2(96) = 8
  call heltable([2,8,16], n3(:,371), t3x16(:,:,245))
  call heltable([8,2,16], n3(:,372), t3x16(:,:,246))
  call heltable([2,8,16], n3(:,373), t3x16(:,:,247))
  call heltable([8,2,16], n3(:,374), t3x16(:,:,248))
  call heltable([8,2,16], n3(:,375), t3x16(:,:,249))
  call heltable([4,4,16], n3(:,376), t3x16(:,:,250))
  n2(97) = 8
  n2(98) = 8
  n2(99) = 8
  call heltable([8,2,16], n3(:,377), t3x16(:,:,251))
  call heltable([8,2,16], n3(:,378), t3x16(:,:,252))
  call heltable([8,2,16], n3(:,379), t3x16(:,:,253))
  call heltable([8,2,16], n3(:,380), t3x16(:,:,254))
  call heltable([2,8,16], n3(:,381), t3x16(:,:,255))
  call heltable([4,4,16], n3(:,382), t3x16(:,:,256))
  n2(100) = 8
  n2(101) = 8
  n2(102) = 8
  call heltable([8,2,16], n3(:,383), t3x16(:,:,257))
  call heltable([8,2,16], n3(:,384), t3x16(:,:,258))
  call heltable([8,2,16], n3(:,385), t3x16(:,:,259))
  call heltable([8,2,16], n3(:,386), t3x16(:,:,260))
  call heltable([2,8,16], n3(:,387), t3x16(:,:,261))
  call heltable([8,2,16], n3(:,388), t3x16(:,:,262))
  call heltable([8,2,16], n3(:,389), t3x16(:,:,263))
  call heltable([8,2,16], n3(:,390), t3x16(:,:,264))
  call heltable([8,2,16], n3(:,391), t3x16(:,:,265))
  call heltable([8,2,16], n3(:,392), t3x16(:,:,266))
  call heltable([2,8,16], n3(:,393), t3x16(:,:,267))
  call heltable([8,2,16], n3(:,394), t3x16(:,:,268))
  call heltable([8,2,16], n3(:,395), t3x16(:,:,269))
  call heltable([2,8,16], n3(:,396), t3x16(:,:,270))
  call heltable([8,2,16], n3(:,397), t3x16(:,:,271))
  call heltable([2,8,16], n3(:,398), t3x16(:,:,272))
  call heltable([8,2,16], n3(:,399), t3x16(:,:,273))
  call heltable([4,4,16], n3(:,400), t3x16(:,:,274))
  n2(103) = 8
  call heltable([4,4,16], n3(:,401), t3x16(:,:,275))
  n2(104) = 8
  call heltable([4,4,16], n3(:,402), t3x16(:,:,276))
  n2(105) = 8
  call heltable([4,4,16], n3(:,403), t3x16(:,:,277))
  n2(106) = 8
  call heltable([4,4,16], n3(:,404), t3x16(:,:,278))
  n2(107) = 8
  call heltable([4,4,16], n3(:,405), t3x16(:,:,279))
  n2(108) = 8
  call heltable([2,8,16], n3(:,406), t3x16(:,:,280))
  call heltable([2,8,16], n3(:,407), t3x16(:,:,281))
  call heltable([8,2,16], n3(:,408), t3x16(:,:,282))
  call heltable([2,8,16], n3(:,409), t3x16(:,:,283))
  call heltable([8,2,16], n3(:,410), t3x16(:,:,284))
  call heltable([8,2,16], n3(:,411), t3x16(:,:,285))
  call heltable([4,4,16], n3(:,412), t3x16(:,:,286))
  n2(109) = 8
  call heltable([4,4,16], n3(:,413), t3x16(:,:,287))
  call heltable([4,4,16], n3(:,414), t3x16(:,:,288))
  n2(110) = 8
  call heltable([4,4,16], n3(:,415), t3x16(:,:,289))
  n2(111) = 8
  call heltable([4,4,16], n3(:,416), t3x16(:,:,290))
  n2(112) = 8
  call heltable([2,8,16], n3(:,417), t3x16(:,:,291))
  call heltable([2,8,16], n3(:,418), t3x16(:,:,292))
  call heltable([8,2,16], n3(:,419), t3x16(:,:,293))
  call heltable([2,8,16], n3(:,420), t3x16(:,:,294))
  call heltable([8,2,16], n3(:,421), t3x16(:,:,295))
  call heltable([8,2,16], n3(:,422), t3x16(:,:,296))
  call heltable([4,4,16], n3(:,423), t3x16(:,:,297))
  n2(113) = 8
  call heltable([4,4,16], n3(:,424), t3x16(:,:,298))
  n2(114) = 8
  call heltable([4,4,16], n3(:,425), t3x16(:,:,299))
  call heltable([8,2,16], n3(:,426), t3x16(:,:,300))
  call heltable([8,2,16], n3(:,427), t3x16(:,:,301))
  call heltable([2,8,16], n3(:,428), t3x16(:,:,302))
  call heltable([2,8,16], n3(:,429), t3x16(:,:,303))
  call heltable([2,8,16], n3(:,430), t3x16(:,:,304))
  call heltable([8,2,16], n3(:,431), t3x16(:,:,305))
  n2(115) = 8
  call heltable([4,4,16], n3(:,432), t3x16(:,:,306))
  n2(116) = 8
  call heltable([4,4,16], n3(:,433), t3x16(:,:,307))
  call heltable([2,8,16], n3(:,434), t3x16(:,:,308))
  call heltable([2,8,16], n3(:,435), t3x16(:,:,309))
  call heltable([2,8,16], n3(:,436), t3x16(:,:,310))
  call heltable([8,2,16], n3(:,437), t3x16(:,:,311))
  call heltable([8,2,16], n3(:,438), t3x16(:,:,312))
  n2(117) = 8
  call heltable([4,4,16], n3(:,439), t3x16(:,:,313))
  call heltable([8,2,16], n3(:,440), t3x16(:,:,314))
  call heltable([2,8,16], n3(:,441), t3x16(:,:,315))
  call heltable([2,8,16], n3(:,442), t3x16(:,:,316))
  call heltable([2,8,16], n3(:,443), t3x16(:,:,317))
  call heltable([8,2,16], n3(:,444), t3x16(:,:,318))
  n2(118) = 8
  call heltable([4,4,16], n3(:,445), t3x16(:,:,319))
  call heltable([8,2,16], n3(:,446), t3x16(:,:,320))
  call heltable([2,8,16], n3(:,447), t3x16(:,:,321))
  call heltable([2,8,16], n3(:,448), t3x16(:,:,322))
  call heltable([8,2,16], n3(:,449), t3x16(:,:,323))
  call heltable([2,8,16], n3(:,450), t3x16(:,:,324))
  call heltable([2,8,16], n3(:,451), t3x16(:,:,325))
  call heltable([2,8,16], n3(:,452), t3x16(:,:,326))
  call heltable([2,8,16], n3(:,453), t3x16(:,:,327))
  call heltable([2,8,16], n3(:,454), t3x16(:,:,328))
  call heltable([2,8,16], n3(:,455), t3x16(:,:,329))
  call heltable([8,2,16], n3(:,456), t3x16(:,:,330))
  call heltable([2,8,16], n3(:,457), t3x16(:,:,331))
  call heltable([8,2,16], n3(:,458), t3x16(:,:,332))
  call heltable([2,8,16], n3(:,459), t3x16(:,:,333))
  call heltable([8,2,16], n3(:,460), t3x16(:,:,334))
  call heltable([2,8,16], n3(:,461), t3x16(:,:,335))
  call heltable([2,8,16], n3(:,462), t3x16(:,:,336))
  call heltable([4,4,16], n3(:,463), t3x16(:,:,337))
  call heltable([4,4,16], n3(:,464), t3x16(:,:,338))
  call heltable([4,4,16], n3(:,465), t3x16(:,:,339))
  call heltable([4,4,16], n3(:,466), t3x16(:,:,340))
  n2(119) = 8
  n2(120) = 8
  call heltable([2,8,16], n3(:,467), t3x16(:,:,341))
  call heltable([2,8,16], n3(:,468), t3x16(:,:,342))
  call heltable([8,2,16], n3(:,469), t3x16(:,:,343))
  call heltable([2,8,16], n3(:,470), t3x16(:,:,344))
  call heltable([8,2,16], n3(:,471), t3x16(:,:,345))
  call heltable([8,2,16], n3(:,472), t3x16(:,:,346))
  call heltable([4,4,16], n3(:,473), t3x16(:,:,347))
  call heltable([4,4,16], n3(:,474), t3x16(:,:,348))
  call heltable([4,4,16], n3(:,475), t3x16(:,:,349))
  n2(121) = 8
  call heltable([8,2,16], n3(:,476), t3x16(:,:,350))
  call heltable([8,2,16], n3(:,477), t3x16(:,:,351))
  call heltable([8,2,16], n3(:,478), t3x16(:,:,352))
  call heltable([8,2,16], n3(:,479), t3x16(:,:,353))
  call heltable([8,2,16], n3(:,480), t3x16(:,:,354))
  call heltable([2,8,16], n3(:,481), t3x16(:,:,355))
  call heltable([4,4,16], n3(:,482), t3x16(:,:,356))
  n2(122) = 8
  call heltable([2,8,16], n3(:,483), t3x16(:,:,357))
  call heltable([8,2,16], n3(:,484), t3x16(:,:,358))
  call heltable([2,8,16], n3(:,485), t3x16(:,:,359))
  call heltable([8,2,16], n3(:,486), t3x16(:,:,360))
  call heltable([8,2,16], n3(:,487), t3x16(:,:,361))
  call heltable([4,4,16], n3(:,488), t3x16(:,:,362))
  n2(123) = 8
  call heltable([8,2,16], n3(:,489), t3x16(:,:,363))
  call heltable([8,2,16], n3(:,490), t3x16(:,:,364))
  call heltable([8,2,16], n3(:,491), t3x16(:,:,365))
  call heltable([8,2,16], n3(:,492), t3x16(:,:,366))
  call heltable([2,8,16], n3(:,493), t3x16(:,:,367))
  n2(124) = 8
  n2(125) = 8
  call heltable([2,8,16], n3(:,494), t3x16(:,:,368))
  call heltable([8,2,16], n3(:,495), t3x16(:,:,369))
  call heltable([8,2,16], n3(:,496), t3x16(:,:,370))
  call heltable([2,8,16], n3(:,497), t3x16(:,:,371))
  call heltable([8,2,16], n3(:,498), t3x16(:,:,372))
  call heltable([8,2,16], n3(:,499), t3x16(:,:,373))
  call heltable([8,2,16], n3(:,500), t3x16(:,:,374))
  call heltable([8,2,16], n3(:,501), t3x16(:,:,375))
  call heltable([8,2,16], n3(:,502), t3x16(:,:,376))
  call heltable([2,8,16], n3(:,503), t3x16(:,:,377))
  call heltable([8,2,16], n3(:,504), t3x16(:,:,378))
  call heltable([2,8,16], n3(:,505), t3x16(:,:,379))
  call heltable([2,8,16], n3(:,506), t3x16(:,:,380))
  call heltable([8,2,16], n3(:,507), t3x16(:,:,381))
  call heltable([4,4,16], n3(:,508), t3x16(:,:,382))
  call heltable([4,4,16], n3(:,509), t3x16(:,:,383))
  call heltable([4,4,16], n3(:,510), t3x16(:,:,384))
  call heltable([4,4,16], n3(:,511), t3x16(:,:,385))
  n2(126) = 8
  n2(127) = 8
  call heltable([2,8,16], n3(:,512), t3x16(:,:,386))
  call heltable([2,8,16], n3(:,513), t3x16(:,:,387))
  call heltable([8,2,16], n3(:,514), t3x16(:,:,388))
  call heltable([2,8,16], n3(:,515), t3x16(:,:,389))
  call heltable([8,2,16], n3(:,516), t3x16(:,:,390))
  call heltable([8,2,16], n3(:,517), t3x16(:,:,391))
  call heltable([4,4,16], n3(:,518), t3x16(:,:,392))
  call heltable([4,4,16], n3(:,519), t3x16(:,:,393))
  call heltable([4,4,16], n3(:,520), t3x16(:,:,394))
  call heltable([8,2,16], n3(:,521), t3x16(:,:,395))
  call heltable([8,2,16], n3(:,522), t3x16(:,:,396))
  call heltable([2,8,16], n3(:,523), t3x16(:,:,397))
  call heltable([2,8,16], n3(:,524), t3x16(:,:,398))
  call heltable([2,8,16], n3(:,525), t3x16(:,:,399))
  call heltable([8,2,16], n3(:,526), t3x16(:,:,400))
  call heltable([4,4,16], n3(:,527), t3x16(:,:,401))
  n2(128) = 8
  call heltable([2,8,16], n3(:,528), t3x16(:,:,402))
  call heltable([2,8,16], n3(:,529), t3x16(:,:,403))
  call heltable([2,8,16], n3(:,530), t3x16(:,:,404))
  call heltable([8,2,16], n3(:,531), t3x16(:,:,405))
  call heltable([8,2,16], n3(:,532), t3x16(:,:,406))
  call heltable([4,4,16], n3(:,533), t3x16(:,:,407))
  call heltable([8,2,16], n3(:,534), t3x16(:,:,408))
  call heltable([2,8,16], n3(:,535), t3x16(:,:,409))
  call heltable([2,8,16], n3(:,536), t3x16(:,:,410))
  call heltable([2,8,16], n3(:,537), t3x16(:,:,411))
  call heltable([8,2,16], n3(:,538), t3x16(:,:,412))
  n2(129) = 8
  call heltable([2,8,16], n3(:,539), t3x16(:,:,413))
  call heltable([2,8,16], n3(:,540), t3x16(:,:,414))
  call heltable([2,8,16], n3(:,541), t3x16(:,:,415))
  call heltable([8,2,16], n3(:,542), t3x16(:,:,416))
  call heltable([2,8,16], n3(:,543), t3x16(:,:,417))
  call heltable([2,8,16], n3(:,544), t3x16(:,:,418))
  call heltable([2,8,16], n3(:,545), t3x16(:,:,419))
  call heltable([2,8,16], n3(:,546), t3x16(:,:,420))
  call heltable([2,8,16], n3(:,547), t3x16(:,:,421))
  call heltable([8,2,16], n3(:,548), t3x16(:,:,422))
  call heltable([2,8,16], n3(:,549), t3x16(:,:,423))
  call heltable([8,2,16], n3(:,550), t3x16(:,:,424))
  call heltable([8,2,16], n3(:,551), t3x16(:,:,425))
  call heltable([2,8,16], n3(:,552), t3x16(:,:,426))
  call heltable([4,4,16], n3(:,553), t3x16(:,:,427))
  call heltable([4,4,16], n3(:,554), t3x16(:,:,428))
  call heltable([4,4,16], n3(:,555), t3x16(:,:,429))
  n2(130) = 8
  call heltable([8,2,16], n3(:,556), t3x16(:,:,430))
  call heltable([8,2,16], n3(:,557), t3x16(:,:,431))
  call heltable([8,2,16], n3(:,558), t3x16(:,:,432))
  call heltable([8,2,16], n3(:,559), t3x16(:,:,433))
  call heltable([8,2,16], n3(:,560), t3x16(:,:,434))
  call heltable([2,8,16], n3(:,561), t3x16(:,:,435))
  call heltable([4,4,16], n3(:,562), t3x16(:,:,436))
  call heltable([4,4,16], n3(:,563), t3x16(:,:,437))
  call heltable([4,4,16], n3(:,564), t3x16(:,:,438))
  call heltable([8,2,16], n3(:,565), t3x16(:,:,439))
  call heltable([8,2,16], n3(:,566), t3x16(:,:,440))
  call heltable([2,8,16], n3(:,567), t3x16(:,:,441))
  call heltable([2,8,16], n3(:,568), t3x16(:,:,442))
  call heltable([2,8,16], n3(:,569), t3x16(:,:,443))
  call heltable([8,2,16], n3(:,570), t3x16(:,:,444))
  call heltable([2,8,16], n3(:,571), t3x16(:,:,445))
  call heltable([8,2,16], n3(:,572), t3x16(:,:,446))
  call heltable([8,2,16], n3(:,573), t3x16(:,:,447))
  call heltable([8,2,16], n3(:,574), t3x16(:,:,448))
  call heltable([2,8,16], n3(:,575), t3x16(:,:,449))
  call heltable([2,8,16], n3(:,576), t3x16(:,:,450))
  call heltable([8,2,16], n3(:,577), t3x16(:,:,451))
  call heltable([2,8,16], n3(:,578), t3x16(:,:,452))
  call heltable([2,8,16], n3(:,579), t3x16(:,:,453))
  call heltable([8,2,16], n3(:,580), t3x16(:,:,454))
  call heltable([8,2,16], n3(:,581), t3x16(:,:,455))
  call heltable([8,2,16], n3(:,582), t3x16(:,:,456))
  call heltable([2,8,16], n3(:,583), t3x16(:,:,457))
  call heltable([2,8,16], n3(:,584), t3x16(:,:,458))
  call heltable([2,8,16], n3(:,585), t3x16(:,:,459))
  call heltable([2,8,16], n3(:,586), t3x16(:,:,460))
  call heltable([8,2,16], n3(:,587), t3x16(:,:,461))
  call heltable([2,8,16], n3(:,588), t3x16(:,:,462))
  call heltable([2,8,16], n3(:,589), t3x16(:,:,463))
  call heltable([2,8,16], n3(:,590), t3x16(:,:,464))
  call heltable([8,2,16], n3(:,591), t3x16(:,:,465))
  call heltable([2,8,16], n3(:,592), t3x16(:,:,466))
  call heltable([2,8,16], n3(:,593), t3x16(:,:,467))
  call heltable([8,2,16], n3(:,594), t3x16(:,:,468))
  call heltable([2,8,16], n3(:,595), t3x16(:,:,469))
  call heltable([2,8,16], n3(:,596), t3x16(:,:,470))
  call heltable([8,2,16], n3(:,597), t3x16(:,:,471))
  call heltable([8,2,16], n3(:,598), t3x16(:,:,472))
  call heltable([2,8,16], n3(:,599), t3x16(:,:,473))
  call heltable([8,2,16], n3(:,600), t3x16(:,:,474))
  call heltable([8,2,16], n3(:,601), t3x16(:,:,475))
  call heltable([2,8,16], n3(:,602), t3x16(:,:,476))
  call heltable([2,8,16], n3(:,603), t3x16(:,:,477))
  call heltable([8,2,16], n3(:,604), t3x16(:,:,478))
  call heltable([8,2,16], n3(:,605), t3x16(:,:,479))
  call heltable([2,8,16], n3(:,606), t3x16(:,:,480))
  call heltable([8,2,16], n3(:,607), t3x16(:,:,481))
  call heltable([8,2,16], n3(:,608), t3x16(:,:,482))
  call heltable([8,2,16], n3(:,609), t3x16(:,:,483))
  call heltable([2,8,16], n3(:,610), t3x16(:,:,484))
  call heltable([8,2,16], n3(:,611), t3x16(:,:,485))
  call heltable([2,8,16], n3(:,612), t3x16(:,:,486))
  call heltable([2,8,16], n3(:,613), t3x16(:,:,487))
  call heltable([2,8,16], n3(:,614), t3x16(:,:,488))
  call heltable([8,2,16], n3(:,615), t3x16(:,:,489))
  call heltable([8,2,16], n3(:,616), t3x16(:,:,490))
  call heltable([2,8,16], n3(:,617), t3x16(:,:,491))
  call heltable([2,8,16], n3(:,618), t3x16(:,:,492))
  call heltable([2,8,16], n3(:,619), t3x16(:,:,493))
  call heltable([8,2,16], n3(:,620), t3x16(:,:,494))
  call heltable([2,8,16], n3(:,621), t3x16(:,:,495))
  call heltable([2,8,16], n3(:,622), t3x16(:,:,496))
  call heltable([2,8,16], n3(:,623), t3x16(:,:,497))
  call heltable([8,2,16], n3(:,624), t3x16(:,:,498))
  call heltable([2,8,16], n3(:,625), t3x16(:,:,499))
  call heltable([2,8,16], n3(:,626), t3x16(:,:,500))
  call heltable([2,8,16], n3(:,627), t3x16(:,:,501))
  call heltable([8,2,16], n3(:,628), t3x16(:,:,502))
  call heltable([2,8,16], n3(:,629), t3x16(:,:,503))
  call heltable([8,2,16], n3(:,630), t3x16(:,:,504))
  call heltable([2,8,16], n3(:,631), t3x16(:,:,505))
  call heltable([8,2,16], n3(:,632), t3x16(:,:,506))
  call heltable([8,2,16], n3(:,633), t3x16(:,:,507))
  call heltable([2,8,16], n3(:,634), t3x16(:,:,508))
  call heltable([2,8,16], n3(:,635), t3x16(:,:,509))
  call heltable([2,8,16], n3(:,636), t3x16(:,:,510))
  call heltable([2,8,16], n3(:,637), t3x16(:,:,511))
  call heltable([8,2,16], n3(:,638), t3x16(:,:,512))
  call heltable([8,2,16], n3(:,639), t3x16(:,:,513))
  call heltable([8,2,16], n3(:,640), t3x16(:,:,514))
  call heltable([2,8,16], n3(:,641), t3x16(:,:,515))
  call heltable([2,8,16], n3(:,642), t3x16(:,:,516))
  call heltable([2,8,16], n3(:,643), t3x16(:,:,517))
  call heltable([8,2,16], n3(:,644), t3x16(:,:,518))
  call heltable([2,8,16], n3(:,645), t3x16(:,:,519))
  call heltable([2,8,16], n3(:,646), t3x16(:,:,520))
  call heltable([8,2,16], n3(:,647), t3x16(:,:,521))
  call heltable([2,8,16], n3(:,648), t3x16(:,:,522))
  call heltable([2,8,16], n3(:,649), t3x16(:,:,523))
  call heltable([8,2,16], n3(:,650), t3x16(:,:,524))
  call heltable([8,2,16], n3(:,651), t3x16(:,:,525))
  call heltable([2,8,16], n3(:,652), t3x16(:,:,526))
  call heltable([2,8,16], n3(:,653), t3x16(:,:,527))
  call heltable([2,8,16], n3(:,654), t3x16(:,:,528))
  call heltable([2,8,16], n3(:,655), t3x16(:,:,529))
  call heltable([8,2,16], n3(:,656), t3x16(:,:,530))
  call heltable([8,2,16], n3(:,657), t3x16(:,:,531))
  call heltable([8,2,16], n3(:,658), t3x16(:,:,532))
  call heltable([2,8,16], n3(:,659), t3x16(:,:,533))
  call heltable([2,8,16], n3(:,660), t3x16(:,:,534))
  call heltable([2,8,16], n3(:,661), t3x16(:,:,535))
  call heltable([8,2,16], n3(:,662), t3x16(:,:,536))
  call heltable([2,8,16], n3(:,663), t3x16(:,:,537))
  call heltable([2,8,16], n3(:,664), t3x16(:,:,538))
  call heltable([8,2,16], n3(:,665), t3x16(:,:,539))
  call heltable([2,8,16], n3(:,666), t3x16(:,:,540))
  call heltable([8,16,128], n3(:,667), t3x128(:,:,1))
  call heltable([16,8,128], n3(:,668), t3x128(:,:,2))
  call heltable([16,8,128], n3(:,669), t3x128(:,:,3))
  call heltable([8,16,128], n3(:,670), t3x128(:,:,4))
  call heltable([8,16,128], n3(:,671), t3x128(:,:,5))
  call heltable([8,16,128], n3(:,672), t3x128(:,:,6))
  call heltable([8,16,128], n3(:,673), t3x128(:,:,7))
  call heltable([8,16,128], n3(:,674), t3x128(:,:,8))
  call heltable([8,16,128], n3(:,675), t3x128(:,:,9))
  call heltable([8,16,128], n3(:,676), t3x128(:,:,10))
  call heltable([16,8,128], n3(:,677), t3x128(:,:,11))
  call heltable([16,8,128], n3(:,678), t3x128(:,:,12))
  call heltable([8,16,128], n3(:,679), t3x128(:,:,13))
  call heltable([8,16,128], n3(:,680), t3x128(:,:,14))
  call heltable([8,16,128], n3(:,681), t3x128(:,:,15))
  call heltable([8,16,128], n3(:,682), t3x128(:,:,16))
  call heltable([8,16,128], n3(:,683), t3x128(:,:,17))
  call heltable([8,16,128], n3(:,684), t3x128(:,:,18))
  call heltable([8,16,128], n3(:,685), t3x128(:,:,19))
  call heltable([16,8,128], n3(:,686), t3x128(:,:,20))
  call heltable([16,8,128], n3(:,687), t3x128(:,:,21))
  call heltable([8,16,128], n3(:,688), t3x128(:,:,22))
  call heltable([8,16,128], n3(:,689), t3x128(:,:,23))
  call heltable([8,16,128], n3(:,690), t3x128(:,:,24))
  call heltable([8,16,128], n3(:,691), t3x128(:,:,25))
  call heltable([8,16,128], n3(:,692), t3x128(:,:,26))
  call heltable([8,16,128], n3(:,693), t3x128(:,:,27))
  call heltable([8,16,128], n3(:,694), t3x128(:,:,28))
  call heltable([8,16,128], n3(:,695), t3x128(:,:,29))
  call heltable([8,16,128], n3(:,696), t3x128(:,:,30))
  call heltable([16,8,128], n3(:,697), t3x128(:,:,31))
  call heltable([16,8,128], n3(:,698), t3x128(:,:,32))
  call heltable([16,8,128], n3(:,699), t3x128(:,:,33))
  call heltable([16,8,128], n3(:,700), t3x128(:,:,34))
  call heltable([16,8,128], n3(:,701), t3x128(:,:,35))
  call heltable([16,8,128], n3(:,702), t3x128(:,:,36))
  call heltable([8,16,128], n3(:,703), t3x128(:,:,37))
  call heltable([16,8,128], n3(:,704), t3x128(:,:,38))
  call heltable([16,8,128], n3(:,705), t3x128(:,:,39))
  call heltable([8,16,128], n3(:,706), t3x128(:,:,40))
  call heltable([8,16,128], n3(:,707), t3x128(:,:,41))
  call heltable([8,16,128], n3(:,708), t3x128(:,:,42))
  call heltable([8,16,128], n3(:,709), t3x128(:,:,43))
  call heltable([8,16,128], n3(:,710), t3x128(:,:,44))
  call heltable([8,16,128], n3(:,711), t3x128(:,:,45))
  call heltable([8,16,128], n3(:,712), t3x128(:,:,46))
  call heltable([16,8,128], n3(:,713), t3x128(:,:,47))
  call heltable([16,8,128], n3(:,714), t3x128(:,:,48))
  call heltable([8,16,128], n3(:,715), t3x128(:,:,49))
  call heltable([8,16,128], n3(:,716), t3x128(:,:,50))
  call heltable([8,16,128], n3(:,717), t3x128(:,:,51))
  call heltable([8,16,128], n3(:,718), t3x128(:,:,52))
  call heltable([8,16,128], n3(:,719), t3x128(:,:,53))
  call heltable([8,16,128], n3(:,720), t3x128(:,:,54))
  call heltable([8,16,128], n3(:,721), t3x128(:,:,55))
  call heltable([8,16,128], n3(:,722), t3x128(:,:,56))
  call heltable([8,16,128], n3(:,723), t3x128(:,:,57))
  call heltable([16,8,128], n3(:,724), t3x128(:,:,58))
  call heltable([16,8,128], n3(:,725), t3x128(:,:,59))
  call heltable([16,8,128], n3(:,726), t3x128(:,:,60))
  call heltable([16,8,128], n3(:,727), t3x128(:,:,61))
  call heltable([16,8,128], n3(:,728), t3x128(:,:,62))
  call heltable([16,8,128], n3(:,729), t3x128(:,:,63))
  call heltable([8,16,128], n3(:,730), t3x128(:,:,64))
  call heltable([16,8,128], n3(:,731), t3x128(:,:,65))
  call heltable([16,8,128], n3(:,732), t3x128(:,:,66))
  call heltable([8,16,128], n3(:,733), t3x128(:,:,67))
  call heltable([8,16,128], n3(:,734), t3x128(:,:,68))
  call heltable([8,16,128], n3(:,735), t3x128(:,:,69))
  call heltable([8,16,128], n3(:,736), t3x128(:,:,70))
  call heltable([8,16,128], n3(:,737), t3x128(:,:,71))
  call heltable([8,16,128], n3(:,738), t3x128(:,:,72))
  call heltable([8,16,128], n3(:,739), t3x128(:,:,73))
  call heltable([8,16,128], n3(:,740), t3x128(:,:,74))
  call heltable([8,16,128], n3(:,741), t3x128(:,:,75))
  call heltable([16,8,128], n3(:,742), t3x128(:,:,76))
  call heltable([16,8,128], n3(:,743), t3x128(:,:,77))
  call heltable([16,8,128], n3(:,744), t3x128(:,:,78))
  call heltable([16,8,128], n3(:,745), t3x128(:,:,79))
  call heltable([16,8,128], n3(:,746), t3x128(:,:,80))
  call heltable([16,8,128], n3(:,747), t3x128(:,:,81))
  call heltable([8,16,128], n3(:,748), t3x128(:,:,82))
  call heltable([8,16,128], n3(:,749), t3x128(:,:,83))
  call heltable([8,16,128], n3(:,750), t3x128(:,:,84))
  call heltable([16,8,128], n3(:,751), t3x128(:,:,85))
  call heltable([16,8,128], n3(:,752), t3x128(:,:,86))
  call heltable([16,8,128], n3(:,753), t3x128(:,:,87))
  call heltable([16,8,128], n3(:,754), t3x128(:,:,88))
  call heltable([16,8,128], n3(:,755), t3x128(:,:,89))
  call heltable([16,8,128], n3(:,756), t3x128(:,:,90))
  call heltable([4,32,128], n3(:,757), t3x128(:,:,91))
  call heltable([4,32,128], n3(:,758), t3x128(:,:,92))
  call heltable([4,32,128], n3(:,759), t3x128(:,:,93))
  call heltable([4,32,128], n3(:,760), t3x128(:,:,94))
  call heltable([4,32,128], n3(:,761), t3x128(:,:,95))
  call heltable([4,32,128], n3(:,762), t3x128(:,:,96))
  call heltable([8,16,128], n3(:,763), t3x128(:,:,97))
  call heltable([8,16,128], n3(:,764), t3x128(:,:,98))
  call heltable([8,16,128], n3(:,765), t3x128(:,:,99))
  call heltable([16,8,128], n3(:,766), t3x128(:,:,100))
  call heltable([16,8,128], n3(:,767), t3x128(:,:,101))
  call heltable([16,8,128], n3(:,768), t3x128(:,:,102))
  call heltable([4,32,128], n3(:,769), t3x128(:,:,103))
  call heltable([4,32,128], n3(:,770), t3x128(:,:,104))
  call heltable([4,32,128], n3(:,771), t3x128(:,:,105))
  call heltable([8,16,128], n3(:,772), t3x128(:,:,106))
  call heltable([8,16,128], n3(:,773), t3x128(:,:,107))
  call heltable([8,16,128], n3(:,774), t3x128(:,:,108))
  call heltable([16,8,128], n3(:,775), t3x128(:,:,109))
  call heltable([16,8,128], n3(:,776), t3x128(:,:,110))
  call heltable([16,8,128], n3(:,777), t3x128(:,:,111))
  call heltable([8,16,128], n3(:,778), t3x128(:,:,112))
  call heltable([8,16,128], n3(:,779), t3x128(:,:,113))
  call heltable([8,16,128], n3(:,780), t3x128(:,:,114))
  call heltable([16,8,128], n3(:,781), t3x128(:,:,115))
  call heltable([16,8,128], n3(:,782), t3x128(:,:,116))
  call heltable([16,8,128], n3(:,783), t3x128(:,:,117))
  call heltable([8,16,128], n3(:,784), t3x128(:,:,118))
  call heltable([8,16,128], n3(:,785), t3x128(:,:,119))
  call heltable([8,16,128], n3(:,786), t3x128(:,:,120))
  call heltable([4,32,128], n3(:,787), t3x128(:,:,121))
  call heltable([4,32,128], n3(:,788), t3x128(:,:,122))
  call heltable([4,32,128], n3(:,789), t3x128(:,:,123))
  call heltable([4,32,128], n3(:,790), t3x128(:,:,124))
  call heltable([4,32,128], n3(:,791), t3x128(:,:,125))
  call heltable([4,32,128], n3(:,792), t3x128(:,:,126))
  call heltable([8,16,128], n3(:,793), t3x128(:,:,127))
  call heltable([8,16,128], n3(:,794), t3x128(:,:,128))
  call heltable([8,16,128], n3(:,795), t3x128(:,:,129))
  call heltable([16,8,128], n3(:,796), t3x128(:,:,130))
  call heltable([16,8,128], n3(:,797), t3x128(:,:,131))
  call heltable([16,8,128], n3(:,798), t3x128(:,:,132))
  call heltable([4,32,128], n3(:,799), t3x128(:,:,133))
  call heltable([4,32,128], n3(:,800), t3x128(:,:,134))
  call heltable([4,32,128], n3(:,801), t3x128(:,:,135))
  call heltable([4,32,128], n3(:,802), t3x128(:,:,136))
  call heltable([4,32,128], n3(:,803), t3x128(:,:,137))
  call heltable([4,32,128], n3(:,804), t3x128(:,:,138))
  call heltable([8,16,128], n3(:,805), t3x128(:,:,139))
  call heltable([8,16,128], n3(:,806), t3x128(:,:,140))
  call heltable([8,16,128], n3(:,807), t3x128(:,:,141))
  call heltable([16,8,128], n3(:,808), t3x128(:,:,142))
  call heltable([16,8,128], n3(:,809), t3x128(:,:,143))
  call heltable([16,8,128], n3(:,810), t3x128(:,:,144))
  call heltable([4,32,128], n3(:,811), t3x128(:,:,145))
  call heltable([4,32,128], n3(:,812), t3x128(:,:,146))
  call heltable([4,32,128], n3(:,813), t3x128(:,:,147))
  call heltable([8,16,128], n3(:,814), t3x128(:,:,148))
  call heltable([8,16,128], n3(:,815), t3x128(:,:,149))
  call heltable([8,16,128], n3(:,816), t3x128(:,:,150))
  call heltable([16,8,128], n3(:,817), t3x128(:,:,151))
  call heltable([16,8,128], n3(:,818), t3x128(:,:,152))
  call heltable([16,8,128], n3(:,819), t3x128(:,:,153))
  call heltable([4,32,128], n3(:,820), t3x128(:,:,154))
  call heltable([4,32,128], n3(:,821), t3x128(:,:,155))
  call heltable([4,32,128], n3(:,822), t3x128(:,:,156))
  call heltable([8,16,128], n3(:,823), t3x128(:,:,157))
  call heltable([8,16,128], n3(:,824), t3x128(:,:,158))
  call heltable([8,16,128], n3(:,825), t3x128(:,:,159))
  call heltable([16,8,128], n3(:,826), t3x128(:,:,160))
  call heltable([16,8,128], n3(:,827), t3x128(:,:,161))
  call heltable([16,8,128], n3(:,828), t3x128(:,:,162))
  call heltable([8,16,128], n3(:,829), t3x128(:,:,163))
  call heltable([8,16,128], n3(:,830), t3x128(:,:,164))
  call heltable([8,16,128], n3(:,831), t3x128(:,:,165))
  call heltable([16,8,128], n3(:,832), t3x128(:,:,166))
  call heltable([16,8,128], n3(:,833), t3x128(:,:,167))
  call heltable([16,8,128], n3(:,834), t3x128(:,:,168))
  call heltable([8,16,128], n3(:,835), t3x128(:,:,169))
  call heltable([8,16,128], n3(:,836), t3x128(:,:,170))
  call heltable([8,16,128], n3(:,837), t3x128(:,:,171))
  call heltable([16,8,128], n3(:,838), t3x128(:,:,172))
  call heltable([16,8,128], n3(:,839), t3x128(:,:,173))
  call heltable([16,8,128], n3(:,840), t3x128(:,:,174))
  call heltable([8,16,128], n3(:,841), t3x128(:,:,175))
  call heltable([8,16,128], n3(:,842), t3x128(:,:,176))
  call heltable([8,16,128], n3(:,843), t3x128(:,:,177))
  call heltable([8,16,128], n3(:,844), t3x128(:,:,178))
  call heltable([8,16,128], n3(:,845), t3x128(:,:,179))
  call heltable([8,16,128], n3(:,846), t3x128(:,:,180))
  call heltable([4,32,128], n3(:,847), t3x128(:,:,181))
  call heltable([4,32,128], n3(:,848), t3x128(:,:,182))
  call heltable([4,32,128], n3(:,849), t3x128(:,:,183))
  call heltable([8,16,128], n3(:,850), t3x128(:,:,184))
  call heltable([8,16,128], n3(:,851), t3x128(:,:,185))
  call heltable([8,16,128], n3(:,852), t3x128(:,:,186))
  call heltable([16,8,128], n3(:,853), t3x128(:,:,187))
  call heltable([16,8,128], n3(:,854), t3x128(:,:,188))
  call heltable([16,8,128], n3(:,855), t3x128(:,:,189))
  call heltable([8,16,128], n3(:,856), t3x128(:,:,190))
  call heltable([8,16,128], n3(:,857), t3x128(:,:,191))
  call heltable([8,16,128], n3(:,858), t3x128(:,:,192))
  call heltable([16,8,128], n3(:,859), t3x128(:,:,193))
  call heltable([16,8,128], n3(:,860), t3x128(:,:,194))
  call heltable([16,8,128], n3(:,861), t3x128(:,:,195))
  call heltable([8,16,128], n3(:,862), t3x128(:,:,196))
  call heltable([8,16,128], n3(:,863), t3x128(:,:,197))
  call heltable([8,16,128], n3(:,864), t3x128(:,:,198))
  call heltable([4,32,128], n3(:,865), t3x128(:,:,199))
  call heltable([4,32,128], n3(:,866), t3x128(:,:,200))
  call heltable([4,32,128], n3(:,867), t3x128(:,:,201))
  call heltable([8,16,128], n3(:,868), t3x128(:,:,202))
  call heltable([8,16,128], n3(:,869), t3x128(:,:,203))
  call heltable([8,16,128], n3(:,870), t3x128(:,:,204))
  call heltable([16,8,128], n3(:,871), t3x128(:,:,205))
  call heltable([16,8,128], n3(:,872), t3x128(:,:,206))
  call heltable([16,8,128], n3(:,873), t3x128(:,:,207))
  call heltable([4,32,128], n3(:,874), t3x128(:,:,208))
  call heltable([4,32,128], n3(:,875), t3x128(:,:,209))
  call heltable([4,32,128], n3(:,876), t3x128(:,:,210))
  call heltable([8,16,128], n3(:,877), t3x128(:,:,211))
  call heltable([8,16,128], n3(:,878), t3x128(:,:,212))
  call heltable([8,16,128], n3(:,879), t3x128(:,:,213))
  call heltable([16,8,128], n3(:,880), t3x128(:,:,214))
  call heltable([16,8,128], n3(:,881), t3x128(:,:,215))
  call heltable([16,8,128], n3(:,882), t3x128(:,:,216))
  call heltable([8,16,128], n3(:,883), t3x128(:,:,217))
  call heltable([8,16,128], n3(:,884), t3x128(:,:,218))
  call heltable([8,16,128], n3(:,885), t3x128(:,:,219))
  call heltable([16,8,128], n3(:,886), t3x128(:,:,220))
  call heltable([16,8,128], n3(:,887), t3x128(:,:,221))
  call heltable([16,8,128], n3(:,888), t3x128(:,:,222))
  call heltable([8,16,128], n3(:,889), t3x128(:,:,223))
  call heltable([8,16,128], n3(:,890), t3x128(:,:,224))
  call heltable([8,16,128], n3(:,891), t3x128(:,:,225))
  call heltable([16,8,128], n3(:,892), t3x128(:,:,226))
  call heltable([16,8,128], n3(:,893), t3x128(:,:,227))
  call heltable([16,8,128], n3(:,894), t3x128(:,:,228))
  call heltable([8,16,128], n3(:,895), t3x128(:,:,229))
  call heltable([8,16,128], n3(:,896), t3x128(:,:,230))
  call heltable([8,16,128], n3(:,897), t3x128(:,:,231))
  call heltable([8,16,128], n3(:,898), t3x128(:,:,232))
  call heltable([8,16,128], n3(:,899), t3x128(:,:,233))
  call heltable([8,16,128], n3(:,900), t3x128(:,:,234))
  call heltable([8,16,128], n3(:,901), t3x128(:,:,235))
  call heltable([8,16,128], n3(:,902), t3x128(:,:,236))
  call heltable([8,16,128], n3(:,903), t3x128(:,:,237))
  call heltable([16,8,128], n3(:,904), t3x128(:,:,238))
  call heltable([16,8,128], n3(:,905), t3x128(:,:,239))
  call heltable([16,8,128], n3(:,906), t3x128(:,:,240))
  call heltable([8,16,128], n3(:,907), t3x128(:,:,241))
  call heltable([8,16,128], n3(:,908), t3x128(:,:,242))
  call heltable([8,16,128], n3(:,909), t3x128(:,:,243))
  call heltable([8,16,128], n3(:,910), t3x128(:,:,244))
  call heltable([8,16,128], n3(:,911), t3x128(:,:,245))
  call heltable([8,16,128], n3(:,912), t3x128(:,:,246))
  call heltable([16,8,128], n3(:,913), t3x128(:,:,247))
  call heltable([16,8,128], n3(:,914), t3x128(:,:,248))
  call heltable([16,8,128], n3(:,915), t3x128(:,:,249))
  call heltable([8,16,128], n3(:,916), t3x128(:,:,250))
  call heltable([8,16,128], n3(:,917), t3x128(:,:,251))
  call heltable([8,16,128], n3(:,918), t3x128(:,:,252))
  call heltable([16,8,128], n3(:,919), t3x128(:,:,253))
  call heltable([16,8,128], n3(:,920), t3x128(:,:,254))
  call heltable([16,8,128], n3(:,921), t3x128(:,:,255))
  call heltable([8,16,128], n3(:,922), t3x128(:,:,256))
  call heltable([8,16,128], n3(:,923), t3x128(:,:,257))
  call heltable([8,16,128], n3(:,924), t3x128(:,:,258))
  call heltable([8,16,128], n3(:,925), t3x128(:,:,259))
  call heltable([8,16,128], n3(:,926), t3x128(:,:,260))
  call heltable([8,16,128], n3(:,927), t3x128(:,:,261))
  call heltable([8,16,128], n3(:,928), t3x128(:,:,262))
  call heltable([8,16,128], n3(:,929), t3x128(:,:,263))
  call heltable([8,16,128], n3(:,930), t3x128(:,:,264))
  call heltable([8,16,128], n3(:,931), t3x128(:,:,265))
  call heltable([8,16,128], n3(:,932), t3x128(:,:,266))
  call heltable([8,16,128], n3(:,933), t3x128(:,:,267))
  call heltable([8,16,128], n3(:,934), t3x128(:,:,268))
  call heltable([8,16,128], n3(:,935), t3x128(:,:,269))
  call heltable([8,16,128], n3(:,936), t3x128(:,:,270))
  call heltable([4,32,128], n3(:,937), t3x128(:,:,271))
  call heltable([4,32,128], n3(:,938), t3x128(:,:,272))
  call heltable([4,32,128], n3(:,939), t3x128(:,:,273))
  call heltable([8,16,128], n3(:,940), t3x128(:,:,274))
  call heltable([8,16,128], n3(:,941), t3x128(:,:,275))
  call heltable([8,16,128], n3(:,942), t3x128(:,:,276))
  call heltable([16,8,128], n3(:,943), t3x128(:,:,277))
  call heltable([16,8,128], n3(:,944), t3x128(:,:,278))
  call heltable([16,8,128], n3(:,945), t3x128(:,:,279))
  call heltable([8,16,128], n3(:,946), t3x128(:,:,280))
  call heltable([8,16,128], n3(:,947), t3x128(:,:,281))
  call heltable([8,16,128], n3(:,948), t3x128(:,:,282))
  call heltable([16,8,128], n3(:,949), t3x128(:,:,283))
  call heltable([16,8,128], n3(:,950), t3x128(:,:,284))
  call heltable([16,8,128], n3(:,951), t3x128(:,:,285))
  call heltable([8,16,128], n3(:,952), t3x128(:,:,286))
  call heltable([8,16,128], n3(:,953), t3x128(:,:,287))
  call heltable([8,16,128], n3(:,954), t3x128(:,:,288))
  call heltable([4,32,128], n3(:,955), t3x128(:,:,289))
  call heltable([4,32,128], n3(:,956), t3x128(:,:,290))
  call heltable([4,32,128], n3(:,957), t3x128(:,:,291))
  call heltable([8,16,128], n3(:,958), t3x128(:,:,292))
  call heltable([8,16,128], n3(:,959), t3x128(:,:,293))
  call heltable([8,16,128], n3(:,960), t3x128(:,:,294))
  call heltable([16,8,128], n3(:,961), t3x128(:,:,295))
  call heltable([16,8,128], n3(:,962), t3x128(:,:,296))
  call heltable([16,8,128], n3(:,963), t3x128(:,:,297))
  call heltable([4,32,128], n3(:,964), t3x128(:,:,298))
  call heltable([4,32,128], n3(:,965), t3x128(:,:,299))
  call heltable([4,32,128], n3(:,966), t3x128(:,:,300))
  call heltable([8,16,128], n3(:,967), t3x128(:,:,301))
  call heltable([8,16,128], n3(:,968), t3x128(:,:,302))
  call heltable([8,16,128], n3(:,969), t3x128(:,:,303))
  call heltable([16,8,128], n3(:,970), t3x128(:,:,304))
  call heltable([16,8,128], n3(:,971), t3x128(:,:,305))
  call heltable([16,8,128], n3(:,972), t3x128(:,:,306))
  call heltable([8,16,128], n3(:,973), t3x128(:,:,307))
  call heltable([8,16,128], n3(:,974), t3x128(:,:,308))
  call heltable([8,16,128], n3(:,975), t3x128(:,:,309))
  call heltable([16,8,128], n3(:,976), t3x128(:,:,310))
  call heltable([16,8,128], n3(:,977), t3x128(:,:,311))
  call heltable([16,8,128], n3(:,978), t3x128(:,:,312))
  call heltable([8,16,128], n3(:,979), t3x128(:,:,313))
  call heltable([8,16,128], n3(:,980), t3x128(:,:,314))
  call heltable([8,16,128], n3(:,981), t3x128(:,:,315))
  call heltable([16,8,128], n3(:,982), t3x128(:,:,316))
  call heltable([16,8,128], n3(:,983), t3x128(:,:,317))
  call heltable([16,8,128], n3(:,984), t3x128(:,:,318))
  call heltable([8,16,128], n3(:,985), t3x128(:,:,319))
  call heltable([8,16,128], n3(:,986), t3x128(:,:,320))
  call heltable([8,16,128], n3(:,987), t3x128(:,:,321))
  call heltable([8,16,128], n3(:,988), t3x128(:,:,322))
  call heltable([8,16,128], n3(:,989), t3x128(:,:,323))
  call heltable([8,16,128], n3(:,990), t3x128(:,:,324))
  call heltable([8,16,128], n3(:,991), t3x128(:,:,325))
  call heltable([8,16,128], n3(:,992), t3x128(:,:,326))
  call heltable([8,16,128], n3(:,993), t3x128(:,:,327))
  call heltable([16,8,128], n3(:,994), t3x128(:,:,328))
  call heltable([16,8,128], n3(:,995), t3x128(:,:,329))
  call heltable([16,8,128], n3(:,996), t3x128(:,:,330))
  call heltable([8,16,128], n3(:,997), t3x128(:,:,331))
  call heltable([8,16,128], n3(:,998), t3x128(:,:,332))
  call heltable([8,16,128], n3(:,999), t3x128(:,:,333))
  call heltable([8,16,128], n3(:,1000), t3x128(:,:,334))
  call heltable([8,16,128], n3(:,1001), t3x128(:,:,335))
  call heltable([8,16,128], n3(:,1002), t3x128(:,:,336))
  call heltable([16,8,128], n3(:,1003), t3x128(:,:,337))
  call heltable([16,8,128], n3(:,1004), t3x128(:,:,338))
  call heltable([16,8,128], n3(:,1005), t3x128(:,:,339))
  call heltable([8,16,128], n3(:,1006), t3x128(:,:,340))
  call heltable([8,16,128], n3(:,1007), t3x128(:,:,341))
  call heltable([8,16,128], n3(:,1008), t3x128(:,:,342))
  call heltable([16,8,128], n3(:,1009), t3x128(:,:,343))
  call heltable([16,8,128], n3(:,1010), t3x128(:,:,344))
  call heltable([16,8,128], n3(:,1011), t3x128(:,:,345))
  call heltable([8,16,128], n3(:,1012), t3x128(:,:,346))
  call heltable([8,16,128], n3(:,1013), t3x128(:,:,347))
  call heltable([8,16,128], n3(:,1014), t3x128(:,:,348))
  call heltable([8,16,128], n3(:,1015), t3x128(:,:,349))
  call heltable([8,16,128], n3(:,1016), t3x128(:,:,350))
  call heltable([8,16,128], n3(:,1017), t3x128(:,:,351))
  call heltable([8,16,128], n3(:,1018), t3x128(:,:,352))
  call heltable([8,16,128], n3(:,1019), t3x128(:,:,353))
  call heltable([8,16,128], n3(:,1020), t3x128(:,:,354))
  call heltable([8,16,128], n3(:,1021), t3x128(:,:,355))
  call heltable([8,16,128], n3(:,1022), t3x128(:,:,356))
  call heltable([8,16,128], n3(:,1023), t3x128(:,:,357))
  call heltable([8,16,128], n3(:,1024), t3x128(:,:,358))
  call heltable([8,16,128], n3(:,1025), t3x128(:,:,359))
  call heltable([8,16,128], n3(:,1026), t3x128(:,:,360))
  call heltable([8,16,128], n3(:,1027), t3x128(:,:,361))
  call heltable([8,16,128], n3(:,1028), t3x128(:,:,362))
  call heltable([8,16,128], n3(:,1029), t3x128(:,:,363))
  call heltable([16,8,128], n3(:,1030), t3x128(:,:,364))
  call heltable([16,8,128], n3(:,1031), t3x128(:,:,365))
  call heltable([16,8,128], n3(:,1032), t3x128(:,:,366))
  call heltable([8,16,128], n3(:,1033), t3x128(:,:,367))
  call heltable([8,16,128], n3(:,1034), t3x128(:,:,368))
  call heltable([8,16,128], n3(:,1035), t3x128(:,:,369))
  call heltable([8,16,128], n3(:,1036), t3x128(:,:,370))
  call heltable([8,16,128], n3(:,1037), t3x128(:,:,371))
  call heltable([8,16,128], n3(:,1038), t3x128(:,:,372))
  call heltable([16,8,128], n3(:,1039), t3x128(:,:,373))
  call heltable([16,8,128], n3(:,1040), t3x128(:,:,374))
  call heltable([16,8,128], n3(:,1041), t3x128(:,:,375))
  call heltable([8,16,128], n3(:,1042), t3x128(:,:,376))
  call heltable([8,16,128], n3(:,1043), t3x128(:,:,377))
  call heltable([8,16,128], n3(:,1044), t3x128(:,:,378))
  call heltable([16,8,128], n3(:,1045), t3x128(:,:,379))
  call heltable([16,8,128], n3(:,1046), t3x128(:,:,380))
  call heltable([16,8,128], n3(:,1047), t3x128(:,:,381))
  call heltable([8,16,128], n3(:,1048), t3x128(:,:,382))
  call heltable([8,16,128], n3(:,1049), t3x128(:,:,383))
  call heltable([8,16,128], n3(:,1050), t3x128(:,:,384))
  call heltable([8,16,128], n3(:,1051), t3x128(:,:,385))
  call heltable([8,16,128], n3(:,1052), t3x128(:,:,386))
  call heltable([8,16,128], n3(:,1053), t3x128(:,:,387))
  call heltable([8,16,128], n3(:,1054), t3x128(:,:,388))
  call heltable([8,16,128], n3(:,1055), t3x128(:,:,389))
  call heltable([8,16,128], n3(:,1056), t3x128(:,:,390))
  call heltable([8,16,128], n3(:,1057), t3x128(:,:,391))
  call heltable([8,16,128], n3(:,1058), t3x128(:,:,392))
  call heltable([8,16,128], n3(:,1059), t3x128(:,:,393))
  call heltable([8,16,128], n3(:,1060), t3x128(:,:,394))
  call heltable([8,16,128], n3(:,1061), t3x128(:,:,395))
  call heltable([8,16,128], n3(:,1062), t3x128(:,:,396))
  call heltable([8,16,128], n3(:,1063), t3x128(:,:,397))
  call heltable([8,16,128], n3(:,1064), t3x128(:,:,398))
  call heltable([8,16,128], n3(:,1065), t3x128(:,:,399))
  call heltable([8,16,128], n3(:,1066), t3x128(:,:,400))
  call heltable([8,16,128], n3(:,1067), t3x128(:,:,401))
  call heltable([8,16,128], n3(:,1068), t3x128(:,:,402))
  call heltable([8,16,128], n3(:,1069), t3x128(:,:,403))
  call heltable([8,16,128], n3(:,1070), t3x128(:,:,404))
  call heltable([8,16,128], n3(:,1071), t3x128(:,:,405))
  call heltable([8,16,128], n3(:,1072), t3x128(:,:,406))
  call heltable([8,16,128], n3(:,1073), t3x128(:,:,407))
  call heltable([8,16,128], n3(:,1074), t3x128(:,:,408))
  call heltable([16,8,128], n3(:,1075), t3x128(:,:,409))
  call heltable([16,8,128], n3(:,1076), t3x128(:,:,410))
  call heltable([16,8,128], n3(:,1077), t3x128(:,:,411))
  call heltable([16,8,128], n3(:,1078), t3x128(:,:,412))
  call heltable([16,8,128], n3(:,1079), t3x128(:,:,413))
  call heltable([16,8,128], n3(:,1080), t3x128(:,:,414))
  call heltable([16,8,128], n3(:,1081), t3x128(:,:,415))
  call heltable([16,8,128], n3(:,1082), t3x128(:,:,416))
  call heltable([16,8,128], n3(:,1083), t3x128(:,:,417))
  call heltable([16,8,128], n3(:,1084), t3x128(:,:,418))
  call heltable([16,8,128], n3(:,1085), t3x128(:,:,419))
  call heltable([16,8,128], n3(:,1086), t3x128(:,:,420))
  call heltable([8,16,128], n3(:,1087), t3x128(:,:,421))
  call heltable([8,16,128], n3(:,1088), t3x128(:,:,422))
  call heltable([8,16,128], n3(:,1089), t3x128(:,:,423))
  call heltable([8,16,128], n3(:,1090), t3x128(:,:,424))
  call heltable([8,16,128], n3(:,1091), t3x128(:,:,425))
  call heltable([8,16,128], n3(:,1092), t3x128(:,:,426))
  call heltable([16,8,128], n3(:,1093), t3x128(:,:,427))
  call heltable([16,8,128], n3(:,1094), t3x128(:,:,428))
  call heltable([16,8,128], n3(:,1095), t3x128(:,:,429))
  call heltable([16,8,128], n3(:,1096), t3x128(:,:,430))
  call heltable([16,8,128], n3(:,1097), t3x128(:,:,431))
  call heltable([16,8,128], n3(:,1098), t3x128(:,:,432))
  call heltable([16,8,128], n3(:,1099), t3x128(:,:,433))
  call heltable([16,8,128], n3(:,1100), t3x128(:,:,434))
  call heltable([16,8,128], n3(:,1101), t3x128(:,:,435))
  call heltable([8,16,128], n3(:,1102), t3x128(:,:,436))
  call heltable([8,16,128], n3(:,1103), t3x128(:,:,437))
  call heltable([8,16,128], n3(:,1104), t3x128(:,:,438))
  call heltable([8,16,128], n3(:,1105), t3x128(:,:,439))
  call heltable([8,16,128], n3(:,1106), t3x128(:,:,440))
  call heltable([8,16,128], n3(:,1107), t3x128(:,:,441))
  call heltable([16,8,128], n3(:,1108), t3x128(:,:,442))
  call heltable([16,8,128], n3(:,1109), t3x128(:,:,443))
  call heltable([16,8,128], n3(:,1110), t3x128(:,:,444))
  call heltable([16,8,128], n3(:,1111), t3x128(:,:,445))
  call heltable([16,8,128], n3(:,1112), t3x128(:,:,446))
  call heltable([16,8,128], n3(:,1113), t3x128(:,:,447))
  call heltable([8,16,128], n3(:,1114), t3x128(:,:,448))
  call heltable([8,16,128], n3(:,1115), t3x128(:,:,449))
  call heltable([8,16,128], n3(:,1116), t3x128(:,:,450))
  call heltable([8,16,128], n3(:,1117), t3x128(:,:,451))
  call heltable([8,16,128], n3(:,1118), t3x128(:,:,452))
  call heltable([8,16,128], n3(:,1119), t3x128(:,:,453))
  call heltable([16,8,128], n3(:,1120), t3x128(:,:,454))
  call heltable([16,8,128], n3(:,1121), t3x128(:,:,455))
  call heltable([16,8,128], n3(:,1122), t3x128(:,:,456))
  call heltable([8,16,128], n3(:,1123), t3x128(:,:,457))
  call heltable([8,16,128], n3(:,1124), t3x128(:,:,458))
  call heltable([8,16,128], n3(:,1125), t3x128(:,:,459))
  call heltable([8,16,128], n3(:,1126), t3x128(:,:,460))
  call heltable([8,16,128], n3(:,1127), t3x128(:,:,461))
  call heltable([8,16,128], n3(:,1128), t3x128(:,:,462))
  call heltable([16,8,128], n3(:,1129), t3x128(:,:,463))
  call heltable([16,8,128], n3(:,1130), t3x128(:,:,464))
  call heltable([16,8,128], n3(:,1131), t3x128(:,:,465))
  call heltable([16,8,128], n3(:,1132), t3x128(:,:,466))
  call heltable([16,8,128], n3(:,1133), t3x128(:,:,467))
  call heltable([16,8,128], n3(:,1134), t3x128(:,:,468))
  call heltable([16,8,128], n3(:,1135), t3x128(:,:,469))
  call heltable([16,8,128], n3(:,1136), t3x128(:,:,470))
  call heltable([16,8,128], n3(:,1137), t3x128(:,:,471))
  call heltable([16,8,128], n3(:,1138), t3x128(:,:,472))
  call heltable([16,8,128], n3(:,1139), t3x128(:,:,473))
  call heltable([16,8,128], n3(:,1140), t3x128(:,:,474))
  call heltable([8,16,128], n3(:,1141), t3x128(:,:,475))
  call heltable([8,16,128], n3(:,1142), t3x128(:,:,476))
  call heltable([8,16,128], n3(:,1143), t3x128(:,:,477))
  call heltable([8,16,128], n3(:,1144), t3x128(:,:,478))
  call heltable([8,16,128], n3(:,1145), t3x128(:,:,479))
  call heltable([8,16,128], n3(:,1146), t3x128(:,:,480))
  call heltable([16,8,128], n3(:,1147), t3x128(:,:,481))
  call heltable([16,8,128], n3(:,1148), t3x128(:,:,482))
  call heltable([16,8,128], n3(:,1149), t3x128(:,:,483))
  call heltable([16,8,128], n3(:,1150), t3x128(:,:,484))
  call heltable([16,8,128], n3(:,1151), t3x128(:,:,485))
  call heltable([16,8,128], n3(:,1152), t3x128(:,:,486))
  call heltable([16,8,128], n3(:,1153), t3x128(:,:,487))
  call heltable([16,8,128], n3(:,1154), t3x128(:,:,488))
  call heltable([16,8,128], n3(:,1155), t3x128(:,:,489))
  call heltable([8,16,128], n3(:,1156), t3x128(:,:,490))
  call heltable([8,16,128], n3(:,1157), t3x128(:,:,491))
  call heltable([8,16,128], n3(:,1158), t3x128(:,:,492))
  call heltable([8,16,128], n3(:,1159), t3x128(:,:,493))
  call heltable([8,16,128], n3(:,1160), t3x128(:,:,494))
  call heltable([8,16,128], n3(:,1161), t3x128(:,:,495))
  call heltable([16,8,128], n3(:,1162), t3x128(:,:,496))
  call heltable([16,8,128], n3(:,1163), t3x128(:,:,497))
  call heltable([16,8,128], n3(:,1164), t3x128(:,:,498))
  call heltable([16,8,128], n3(:,1165), t3x128(:,:,499))
  call heltable([16,8,128], n3(:,1166), t3x128(:,:,500))
  call heltable([16,8,128], n3(:,1167), t3x128(:,:,501))
  call heltable([8,16,128], n3(:,1168), t3x128(:,:,502))
  call heltable([8,16,128], n3(:,1169), t3x128(:,:,503))
  call heltable([8,16,128], n3(:,1170), t3x128(:,:,504))
  call heltable([8,16,128], n3(:,1171), t3x128(:,:,505))
  call heltable([8,16,128], n3(:,1172), t3x128(:,:,506))
  call heltable([8,16,128], n3(:,1173), t3x128(:,:,507))
  call heltable([16,8,128], n3(:,1174), t3x128(:,:,508))
  call heltable([16,8,128], n3(:,1175), t3x128(:,:,509))
  call heltable([16,8,128], n3(:,1176), t3x128(:,:,510))
  call heltable([8,16,128], n3(:,1177), t3x128(:,:,511))
  call heltable([8,16,128], n3(:,1178), t3x128(:,:,512))
  call heltable([8,16,128], n3(:,1179), t3x128(:,:,513))
  call heltable([16,8,128], n3(:,1180), t3x128(:,:,514))
  call heltable([16,8,128], n3(:,1181), t3x128(:,:,515))
  call heltable([16,8,128], n3(:,1182), t3x128(:,:,516))
  call heltable([16,8,128], n3(:,1183), t3x128(:,:,517))
  call heltable([16,8,128], n3(:,1184), t3x128(:,:,518))
  call heltable([16,8,128], n3(:,1185), t3x128(:,:,519))
  call heltable([16,8,128], n3(:,1186), t3x128(:,:,520))
  call heltable([16,8,128], n3(:,1187), t3x128(:,:,521))
  call heltable([16,8,128], n3(:,1188), t3x128(:,:,522))
  call heltable([16,8,128], n3(:,1189), t3x128(:,:,523))
  call heltable([16,8,128], n3(:,1190), t3x128(:,:,524))
  call heltable([16,8,128], n3(:,1191), t3x128(:,:,525))
  call heltable([16,8,128], n3(:,1192), t3x128(:,:,526))
  call heltable([16,8,128], n3(:,1193), t3x128(:,:,527))
  call heltable([16,8,128], n3(:,1194), t3x128(:,:,528))
  call heltable([16,8,128], n3(:,1195), t3x128(:,:,529))
  call heltable([16,8,128], n3(:,1196), t3x128(:,:,530))
  call heltable([16,8,128], n3(:,1197), t3x128(:,:,531))
  call heltable([16,8,128], n3(:,1198), t3x128(:,:,532))
  call heltable([16,8,128], n3(:,1199), t3x128(:,:,533))
  call heltable([16,8,128], n3(:,1200), t3x128(:,:,534))
  call heltable([16,8,128], n3(:,1201), t3x128(:,:,535))
  call heltable([16,8,128], n3(:,1202), t3x128(:,:,536))
  call heltable([16,8,128], n3(:,1203), t3x128(:,:,537))
  call heltable([16,8,128], n3(:,1204), t3x128(:,:,538))
  call heltable([16,8,128], n3(:,1205), t3x128(:,:,539))
  call heltable([16,8,128], n3(:,1206), t3x128(:,:,540))
  call heltable([16,8,128], n3(:,1207), t3x128(:,:,541))
  call heltable([16,8,128], n3(:,1208), t3x128(:,:,542))
  call heltable([16,8,128], n3(:,1209), t3x128(:,:,543))
  call heltable([16,8,128], n3(:,1210), t3x128(:,:,544))
  call heltable([16,8,128], n3(:,1211), t3x128(:,:,545))
  call heltable([16,8,128], n3(:,1212), t3x128(:,:,546))
  call heltable([16,8,128], n3(:,1213), t3x128(:,:,547))
  call heltable([16,8,128], n3(:,1214), t3x128(:,:,548))
  call heltable([16,8,128], n3(:,1215), t3x128(:,:,549))
  call heltable([16,8,128], n3(:,1216), t3x128(:,:,550))
  call heltable([16,8,128], n3(:,1217), t3x128(:,:,551))
  call heltable([16,8,128], n3(:,1218), t3x128(:,:,552))
  call heltable([16,8,128], n3(:,1219), t3x128(:,:,553))
  call heltable([16,8,128], n3(:,1220), t3x128(:,:,554))
  call heltable([16,8,128], n3(:,1221), t3x128(:,:,555))
  call heltable([16,8,128], n3(:,1222), t3x128(:,:,556))
  call heltable([16,8,128], n3(:,1223), t3x128(:,:,557))
  call heltable([16,8,128], n3(:,1224), t3x128(:,:,558))
  call heltable([16,8,128], n3(:,1225), t3x128(:,:,559))
  call heltable([16,8,128], n3(:,1226), t3x128(:,:,560))
  call heltable([16,8,128], n3(:,1227), t3x128(:,:,561))
  call heltable([16,8,128], n3(:,1228), t3x128(:,:,562))
  call heltable([16,8,128], n3(:,1229), t3x128(:,:,563))
  call heltable([16,8,128], n3(:,1230), t3x128(:,:,564))
  call heltable([16,8,128], n3(:,1231), t3x128(:,:,565))
  call heltable([16,8,128], n3(:,1232), t3x128(:,:,566))
  call heltable([16,8,128], n3(:,1233), t3x128(:,:,567))
  call heltable([16,8,128], n3(:,1234), t3x128(:,:,568))
  call heltable([16,8,128], n3(:,1235), t3x128(:,:,569))
  call heltable([16,8,128], n3(:,1236), t3x128(:,:,570))
  call heltable([16,8,128], n3(:,1237), t3x128(:,:,571))
  call heltable([16,8,128], n3(:,1238), t3x128(:,:,572))
  call heltable([16,8,128], n3(:,1239), t3x128(:,:,573))
  call heltable([16,8,128], n3(:,1240), t3x128(:,:,574))
  call heltable([16,8,128], n3(:,1241), t3x128(:,:,575))
  call heltable([16,8,128], n3(:,1242), t3x128(:,:,576))
  call heltable([16,8,128], n3(:,1243), t3x128(:,:,577))
  call heltable([16,8,128], n3(:,1244), t3x128(:,:,578))
  call heltable([16,8,128], n3(:,1245), t3x128(:,:,579))
  call heltable([16,8,128], n3(:,1246), t3x128(:,:,580))
  call heltable([16,8,128], n3(:,1247), t3x128(:,:,581))
  call heltable([16,8,128], n3(:,1248), t3x128(:,:,582))
  call heltable([16,8,128], n3(:,1249), t3x128(:,:,583))
  call heltable([16,8,128], n3(:,1250), t3x128(:,:,584))
  call heltable([16,8,128], n3(:,1251), t3x128(:,:,585))
  call heltable([16,8,128], n3(:,1252), t3x128(:,:,586))
  call heltable([16,8,128], n3(:,1253), t3x128(:,:,587))
  call heltable([16,8,128], n3(:,1254), t3x128(:,:,588))
  call heltable([16,8,128], n3(:,1255), t3x128(:,:,589))
  call heltable([16,8,128], n3(:,1256), t3x128(:,:,590))
  call heltable([16,8,128], n3(:,1257), t3x128(:,:,591))
  call heltable([16,8,128], n3(:,1258), t3x128(:,:,592))
  call heltable([16,8,128], n3(:,1259), t3x128(:,:,593))
  call heltable([16,8,128], n3(:,1260), t3x128(:,:,594))
  call heltable([16,8,128], n3(:,1261), t3x128(:,:,595))
  call heltable([16,8,128], n3(:,1262), t3x128(:,:,596))
  call heltable([16,8,128], n3(:,1263), t3x128(:,:,597))
  call heltable([16,8,128], n3(:,1264), t3x128(:,:,598))
  call heltable([16,8,128], n3(:,1265), t3x128(:,:,599))
  call heltable([16,8,128], n3(:,1266), t3x128(:,:,600))
  call heltable([16,8,128], n3(:,1267), t3x128(:,:,601))
  call heltable([16,8,128], n3(:,1268), t3x128(:,:,602))
  call heltable([16,8,128], n3(:,1269), t3x128(:,:,603))
  call heltable([16,8,128], n3(:,1270), t3x128(:,:,604))
  call heltable([16,8,128], n3(:,1271), t3x128(:,:,605))
  call heltable([16,8,128], n3(:,1272), t3x128(:,:,606))
  call heltable([16,8,128], n3(:,1273), t3x128(:,:,607))
  call heltable([16,8,128], n3(:,1274), t3x128(:,:,608))
  call heltable([16,8,128], n3(:,1275), t3x128(:,:,609))
  call heltable([16,8,128], n3(:,1276), t3x128(:,:,610))
  call heltable([16,8,128], n3(:,1277), t3x128(:,:,611))
  call heltable([16,8,128], n3(:,1278), t3x128(:,:,612))
  call heltable([16,8,128], n3(:,1279), t3x128(:,:,613))
  call heltable([16,8,128], n3(:,1280), t3x128(:,:,614))
  call heltable([16,8,128], n3(:,1281), t3x128(:,:,615))
  call heltable([16,8,128], n3(:,1282), t3x128(:,:,616))
  call heltable([16,8,128], n3(:,1283), t3x128(:,:,617))
  call heltable([16,8,128], n3(:,1284), t3x128(:,:,618))
  call heltable([16,8,128], n3(:,1285), t3x128(:,:,619))
  call heltable([16,8,128], n3(:,1286), t3x128(:,:,620))
  call heltable([16,8,128], n3(:,1287), t3x128(:,:,621))
  call heltable([16,8,128], n3(:,1288), t3x128(:,:,622))
  call heltable([16,8,128], n3(:,1289), t3x128(:,:,623))
  call heltable([16,8,128], n3(:,1290), t3x128(:,:,624))
  call heltable([16,8,128], n3(:,1291), t3x128(:,:,625))
  call heltable([16,8,128], n3(:,1292), t3x128(:,:,626))
  call heltable([16,8,128], n3(:,1293), t3x128(:,:,627))
  call heltable([16,8,128], n3(:,1294), t3x128(:,:,628))
  call heltable([16,8,128], n3(:,1295), t3x128(:,:,629))
  call heltable([16,8,128], n3(:,1296), t3x128(:,:,630))
  call heltable([16,8,128], n3(:,1297), t3x128(:,:,631))
  call heltable([16,8,128], n3(:,1298), t3x128(:,:,632))
  call heltable([16,8,128], n3(:,1299), t3x128(:,:,633))
  call heltable([16,8,128], n3(:,1300), t3x128(:,:,634))
  call heltable([16,8,128], n3(:,1301), t3x128(:,:,635))
  call heltable([16,8,128], n3(:,1302), t3x128(:,:,636))
  call heltable([16,8,128], n3(:,1303), t3x128(:,:,637))
  call heltable([16,8,128], n3(:,1304), t3x128(:,:,638))
  call heltable([16,8,128], n3(:,1305), t3x128(:,:,639))
  call heltable([16,8,128], n3(:,1306), t3x128(:,:,640))
  call heltable([16,8,128], n3(:,1307), t3x128(:,:,641))
  call heltable([16,8,128], n3(:,1308), t3x128(:,:,642))
  call heltable([16,8,128], n3(:,1309), t3x128(:,:,643))
  call heltable([16,8,128], n3(:,1310), t3x128(:,:,644))
  call heltable([16,8,128], n3(:,1311), t3x128(:,:,645))
  call heltable([16,8,128], n3(:,1312), t3x128(:,:,646))
  call heltable([16,8,128], n3(:,1313), t3x128(:,:,647))
  call heltable([16,8,128], n3(:,1314), t3x128(:,:,648))
  call heltable([16,8,128], n3(:,1315), t3x128(:,:,649))
  call heltable([16,8,128], n3(:,1316), t3x128(:,:,650))
  call heltable([16,8,128], n3(:,1317), t3x128(:,:,651))
  call heltable([16,8,128], n3(:,1318), t3x128(:,:,652))
  call heltable([16,8,128], n3(:,1319), t3x128(:,:,653))
  call heltable([16,8,128], n3(:,1320), t3x128(:,:,654))
  call heltable([16,8,128], n3(:,1321), t3x128(:,:,655))
  call heltable([16,8,128], n3(:,1322), t3x128(:,:,656))
  call heltable([16,8,128], n3(:,1323), t3x128(:,:,657))
  call heltable([8,16,128], n3(:,1324), t3x128(:,:,658))
  call heltable([8,16,128], n3(:,1325), t3x128(:,:,659))
  call heltable([8,16,128], n3(:,1326), t3x128(:,:,660))
  call heltable([16,8,128], n3(:,1327), t3x128(:,:,661))
  call heltable([16,8,128], n3(:,1328), t3x128(:,:,662))
  call heltable([16,8,128], n3(:,1329), t3x128(:,:,663))
  call heltable([16,8,128], n3(:,1330), t3x128(:,:,664))
  call heltable([16,8,128], n3(:,1331), t3x128(:,:,665))
  call heltable([16,8,128], n3(:,1332), t3x128(:,:,666))
  call heltable([16,8,128], n3(:,1333), t3x128(:,:,667))
  call heltable([16,8,128], n3(:,1334), t3x128(:,:,668))
  call heltable([16,8,128], n3(:,1335), t3x128(:,:,669))
  call heltable([8,16,128], n3(:,1336), t3x128(:,:,670))
  call heltable([8,16,128], n3(:,1337), t3x128(:,:,671))
  call heltable([8,16,128], n3(:,1338), t3x128(:,:,672))
  call heltable([8,16,128], n3(:,1339), t3x128(:,:,673))
  call heltable([8,16,128], n3(:,1340), t3x128(:,:,674))
  call heltable([8,16,128], n3(:,1341), t3x128(:,:,675))
  call heltable([16,8,128], n3(:,1342), t3x128(:,:,676))
  call heltable([16,8,128], n3(:,1343), t3x128(:,:,677))
  call heltable([16,8,128], n3(:,1344), t3x128(:,:,678))
  call heltable([16,8,128], n3(:,1345), t3x128(:,:,679))
  call heltable([16,8,128], n3(:,1346), t3x128(:,:,680))
  call heltable([16,8,128], n3(:,1347), t3x128(:,:,681))
  call heltable([8,16,128], n3(:,1348), t3x128(:,:,682))
  call heltable([8,16,128], n3(:,1349), t3x128(:,:,683))
  call heltable([8,16,128], n3(:,1350), t3x128(:,:,684))
  call heltable([8,16,128], n3(:,1351), t3x128(:,:,685))
  call heltable([8,16,128], n3(:,1352), t3x128(:,:,686))
  call heltable([8,16,128], n3(:,1353), t3x128(:,:,687))
  call heltable([16,8,128], n3(:,1354), t3x128(:,:,688))
  call heltable([16,8,128], n3(:,1355), t3x128(:,:,689))
  call heltable([16,8,128], n3(:,1356), t3x128(:,:,690))
  call heltable([8,16,128], n3(:,1357), t3x128(:,:,691))
  call heltable([8,16,128], n3(:,1358), t3x128(:,:,692))
  call heltable([8,16,128], n3(:,1359), t3x128(:,:,693))
  call heltable([8,16,128], n3(:,1360), t3x128(:,:,694))
  call heltable([8,16,128], n3(:,1361), t3x128(:,:,695))
  call heltable([8,16,128], n3(:,1362), t3x128(:,:,696))
  call heltable([16,8,128], n3(:,1363), t3x128(:,:,697))
  call heltable([16,8,128], n3(:,1364), t3x128(:,:,698))
  call heltable([16,8,128], n3(:,1365), t3x128(:,:,699))
  call heltable([16,8,128], n3(:,1366), t3x128(:,:,700))
  call heltable([16,8,128], n3(:,1367), t3x128(:,:,701))
  call heltable([16,8,128], n3(:,1368), t3x128(:,:,702))
  call heltable([16,8,128], n3(:,1369), t3x128(:,:,703))
  call heltable([16,8,128], n3(:,1370), t3x128(:,:,704))
  call heltable([16,8,128], n3(:,1371), t3x128(:,:,705))
  call heltable([8,16,128], n3(:,1372), t3x128(:,:,706))
  call heltable([8,16,128], n3(:,1373), t3x128(:,:,707))
  call heltable([8,16,128], n3(:,1374), t3x128(:,:,708))
  call heltable([8,16,128], n3(:,1375), t3x128(:,:,709))
  call heltable([8,16,128], n3(:,1376), t3x128(:,:,710))
  call heltable([8,16,128], n3(:,1377), t3x128(:,:,711))
  call heltable([16,8,128], n3(:,1378), t3x128(:,:,712))
  call heltable([16,8,128], n3(:,1379), t3x128(:,:,713))
  call heltable([16,8,128], n3(:,1380), t3x128(:,:,714))
  call heltable([16,8,128], n3(:,1381), t3x128(:,:,715))
  call heltable([16,8,128], n3(:,1382), t3x128(:,:,716))
  call heltable([16,8,128], n3(:,1383), t3x128(:,:,717))
  call heltable([8,16,128], n3(:,1384), t3x128(:,:,718))
  call heltable([8,16,128], n3(:,1385), t3x128(:,:,719))
  call heltable([8,16,128], n3(:,1386), t3x128(:,:,720))
  call heltable([8,16,128], n3(:,1387), t3x128(:,:,721))
  call heltable([8,16,128], n3(:,1388), t3x128(:,:,722))
  call heltable([8,16,128], n3(:,1389), t3x128(:,:,723))
  call heltable([16,8,128], n3(:,1390), t3x128(:,:,724))
  call heltable([16,8,128], n3(:,1391), t3x128(:,:,725))
  call heltable([16,8,128], n3(:,1392), t3x128(:,:,726))
  call heltable([8,16,128], n3(:,1393), t3x128(:,:,727))
  call heltable([8,16,128], n3(:,1394), t3x128(:,:,728))
  call heltable([8,16,128], n3(:,1395), t3x128(:,:,729))
  call heltable([16,8,128], n3(:,1396), t3x128(:,:,730))
  call heltable([16,8,128], n3(:,1397), t3x128(:,:,731))
  call heltable([16,8,128], n3(:,1398), t3x128(:,:,732))
  call heltable([16,8,128], n3(:,1399), t3x128(:,:,733))
  call heltable([16,8,128], n3(:,1400), t3x128(:,:,734))
  call heltable([16,8,128], n3(:,1401), t3x128(:,:,735))
  call heltable([16,8,128], n3(:,1402), t3x128(:,:,736))
  call heltable([16,8,128], n3(:,1403), t3x128(:,:,737))
  call heltable([16,8,128], n3(:,1404), t3x128(:,:,738))
  call heltable([16,8,128], n3(:,1405), t3x128(:,:,739))
  call heltable([16,8,128], n3(:,1406), t3x128(:,:,740))
  call heltable([16,8,128], n3(:,1407), t3x128(:,:,741))
  call heltable([16,8,128], n3(:,1408), t3x128(:,:,742))
  call heltable([16,8,128], n3(:,1409), t3x128(:,:,743))
  call heltable([16,8,128], n3(:,1410), t3x128(:,:,744))
  call heltable([16,8,128], n3(:,1411), t3x128(:,:,745))
  call heltable([16,8,128], n3(:,1412), t3x128(:,:,746))
  call heltable([16,8,128], n3(:,1413), t3x128(:,:,747))
  call heltable([16,8,128], n3(:,1414), t3x128(:,:,748))
  call heltable([16,8,128], n3(:,1415), t3x128(:,:,749))
  call heltable([16,8,128], n3(:,1416), t3x128(:,:,750))
  call heltable([16,8,128], n3(:,1417), t3x128(:,:,751))
  call heltable([16,8,128], n3(:,1418), t3x128(:,:,752))
  call heltable([16,8,128], n3(:,1419), t3x128(:,:,753))
  call heltable([16,8,128], n3(:,1420), t3x128(:,:,754))
  call heltable([16,8,128], n3(:,1421), t3x128(:,:,755))
  call heltable([16,8,128], n3(:,1422), t3x128(:,:,756))
  call heltable([16,8,128], n3(:,1423), t3x128(:,:,757))
  call heltable([16,8,128], n3(:,1424), t3x128(:,:,758))
  call heltable([16,8,128], n3(:,1425), t3x128(:,:,759))
  call heltable([16,8,128], n3(:,1426), t3x128(:,:,760))
  call heltable([16,8,128], n3(:,1427), t3x128(:,:,761))
  call heltable([16,8,128], n3(:,1428), t3x128(:,:,762))
  call heltable([16,8,128], n3(:,1429), t3x128(:,:,763))
  call heltable([16,8,128], n3(:,1430), t3x128(:,:,764))
  call heltable([16,8,128], n3(:,1431), t3x128(:,:,765))
  call heltable([16,8,128], n3(:,1432), t3x128(:,:,766))
  call heltable([16,8,128], n3(:,1433), t3x128(:,:,767))
  call heltable([16,8,128], n3(:,1434), t3x128(:,:,768))
  call heltable([16,8,128], n3(:,1435), t3x128(:,:,769))
  call heltable([16,8,128], n3(:,1436), t3x128(:,:,770))
  call heltable([16,8,128], n3(:,1437), t3x128(:,:,771))
  call heltable([16,8,128], n3(:,1438), t3x128(:,:,772))
  call heltable([16,8,128], n3(:,1439), t3x128(:,:,773))
  call heltable([16,8,128], n3(:,1440), t3x128(:,:,774))
  call heltable([16,8,128], n3(:,1441), t3x128(:,:,775))
  call heltable([16,8,128], n3(:,1442), t3x128(:,:,776))
  call heltable([16,8,128], n3(:,1443), t3x128(:,:,777))
  call heltable([16,8,128], n3(:,1444), t3x128(:,:,778))
  call heltable([16,8,128], n3(:,1445), t3x128(:,:,779))
  call heltable([16,8,128], n3(:,1446), t3x128(:,:,780))
  call heltable([16,8,128], n3(:,1447), t3x128(:,:,781))
  call heltable([16,8,128], n3(:,1448), t3x128(:,:,782))
  call heltable([16,8,128], n3(:,1449), t3x128(:,:,783))
  call heltable([16,8,128], n3(:,1450), t3x128(:,:,784))
  call heltable([16,8,128], n3(:,1451), t3x128(:,:,785))
  call heltable([16,8,128], n3(:,1452), t3x128(:,:,786))
  call heltable([16,8,128], n3(:,1453), t3x128(:,:,787))
  call heltable([16,8,128], n3(:,1454), t3x128(:,:,788))
  call heltable([16,8,128], n3(:,1455), t3x128(:,:,789))
  call heltable([16,8,128], n3(:,1456), t3x128(:,:,790))
  call heltable([16,8,128], n3(:,1457), t3x128(:,:,791))
  call heltable([16,8,128], n3(:,1458), t3x128(:,:,792))
  call heltable([16,8,128], n3(:,1459), t3x128(:,:,793))
  call heltable([16,8,128], n3(:,1460), t3x128(:,:,794))
  call heltable([16,8,128], n3(:,1461), t3x128(:,:,795))
  call heltable([16,8,128], n3(:,1462), t3x128(:,:,796))
  call heltable([16,8,128], n3(:,1463), t3x128(:,:,797))
  call heltable([16,8,128], n3(:,1464), t3x128(:,:,798))
  call heltable([16,8,128], n3(:,1465), t3x128(:,:,799))
  call heltable([16,8,128], n3(:,1466), t3x128(:,:,800))
  call heltable([16,8,128], n3(:,1467), t3x128(:,:,801))
  call heltable([16,8,128], n3(:,1468), t3x128(:,:,802))
  call heltable([16,8,128], n3(:,1469), t3x128(:,:,803))
  call heltable([16,8,128], n3(:,1470), t3x128(:,:,804))
  call heltable([16,8,128], n3(:,1471), t3x128(:,:,805))
  call heltable([16,8,128], n3(:,1472), t3x128(:,:,806))
  call heltable([16,8,128], n3(:,1473), t3x128(:,:,807))
  call heltable([16,8,128], n3(:,1474), t3x128(:,:,808))
  call heltable([16,8,128], n3(:,1475), t3x128(:,:,809))
  call heltable([16,8,128], n3(:,1476), t3x128(:,:,810))
  call heltable([16,8,128], n3(:,1477), t3x128(:,:,811))
  call heltable([16,8,128], n3(:,1478), t3x128(:,:,812))
  call heltable([16,8,128], n3(:,1479), t3x128(:,:,813))
  call heltable([16,8,128], n3(:,1480), t3x128(:,:,814))
  call heltable([16,8,128], n3(:,1481), t3x128(:,:,815))
  call heltable([16,8,128], n3(:,1482), t3x128(:,:,816))
  call heltable([16,8,128], n3(:,1483), t3x128(:,:,817))
  call heltable([16,8,128], n3(:,1484), t3x128(:,:,818))
  call heltable([16,8,128], n3(:,1485), t3x128(:,:,819))
  call heltable([8,16,128], n3(:,1486), t3x128(:,:,820))
  call heltable([8,16,128], n3(:,1487), t3x128(:,:,821))
  call heltable([8,16,128], n3(:,1488), t3x128(:,:,822))
  call heltable([16,8,128], n3(:,1489), t3x128(:,:,823))
  call heltable([16,8,128], n3(:,1490), t3x128(:,:,824))
  call heltable([16,8,128], n3(:,1491), t3x128(:,:,825))
  call heltable([16,8,128], n3(:,1492), t3x128(:,:,826))
  call heltable([16,8,128], n3(:,1493), t3x128(:,:,827))
  call heltable([16,8,128], n3(:,1494), t3x128(:,:,828))
  call heltable([8,16,128], n3(:,1495), t3x128(:,:,829))
  call heltable([8,16,128], n3(:,1496), t3x128(:,:,830))
  call heltable([8,16,128], n3(:,1497), t3x128(:,:,831))
  call heltable([8,16,128], n3(:,1498), t3x128(:,:,832))
  call heltable([8,16,128], n3(:,1499), t3x128(:,:,833))
  call heltable([8,16,128], n3(:,1500), t3x128(:,:,834))
  call heltable([16,8,128], n3(:,1501), t3x128(:,:,835))
  call heltable([16,8,128], n3(:,1502), t3x128(:,:,836))
  call heltable([16,8,128], n3(:,1503), t3x128(:,:,837))
  call heltable([8,16,128], n3(:,1504), t3x128(:,:,838))
  call heltable([8,16,128], n3(:,1505), t3x128(:,:,839))
  call heltable([8,16,128], n3(:,1506), t3x128(:,:,840))
  call heltable([8,16,128], n3(:,1507), t3x128(:,:,841))
  call heltable([8,16,128], n3(:,1508), t3x128(:,:,842))
  call heltable([8,16,128], n3(:,1509), t3x128(:,:,843))
  call heltable([16,8,128], n3(:,1510), t3x128(:,:,844))
  call heltable([16,8,128], n3(:,1511), t3x128(:,:,845))
  call heltable([16,8,128], n3(:,1512), t3x128(:,:,846))
  call heltable([16,8,128], n3(:,1513), t3x128(:,:,847))
  call heltable([16,8,128], n3(:,1514), t3x128(:,:,848))
  call heltable([16,8,128], n3(:,1515), t3x128(:,:,849))
  call heltable([8,16,128], n3(:,1516), t3x128(:,:,850))
  call heltable([8,16,128], n3(:,1517), t3x128(:,:,851))
  call heltable([8,16,128], n3(:,1518), t3x128(:,:,852))
  call heltable([8,16,128], n3(:,1519), t3x128(:,:,853))
  call heltable([8,16,128], n3(:,1520), t3x128(:,:,854))
  call heltable([8,16,128], n3(:,1521), t3x128(:,:,855))
  call heltable([16,8,128], n3(:,1522), t3x128(:,:,856))
  call heltable([16,8,128], n3(:,1523), t3x128(:,:,857))
  call heltable([16,8,128], n3(:,1524), t3x128(:,:,858))
  call heltable([8,16,128], n3(:,1525), t3x128(:,:,859))
  call heltable([8,16,128], n3(:,1526), t3x128(:,:,860))
  call heltable([8,16,128], n3(:,1527), t3x128(:,:,861))
  call heltable([16,8,128], n3(:,1528), t3x128(:,:,862))
  call heltable([16,8,128], n3(:,1529), t3x128(:,:,863))
  call heltable([16,8,128], n3(:,1530), t3x128(:,:,864))
  call heltable([16,8,128], n3(:,1531), t3x128(:,:,865))
  call heltable([16,8,128], n3(:,1532), t3x128(:,:,866))
  call heltable([16,8,128], n3(:,1533), t3x128(:,:,867))
  call heltable([16,8,128], n3(:,1534), t3x128(:,:,868))
  call heltable([16,8,128], n3(:,1535), t3x128(:,:,869))
  call heltable([16,8,128], n3(:,1536), t3x128(:,:,870))
  call heltable([16,8,128], n3(:,1537), t3x128(:,:,871))
  call heltable([16,8,128], n3(:,1538), t3x128(:,:,872))
  call heltable([16,8,128], n3(:,1539), t3x128(:,:,873))
  call heltable([16,8,128], n3(:,1540), t3x128(:,:,874))
  call heltable([16,8,128], n3(:,1541), t3x128(:,:,875))
  call heltable([16,8,128], n3(:,1542), t3x128(:,:,876))
  call heltable([16,8,128], n3(:,1543), t3x128(:,:,877))
  call heltable([16,8,128], n3(:,1544), t3x128(:,:,878))
  call heltable([16,8,128], n3(:,1545), t3x128(:,:,879))
  call heltable([16,8,128], n3(:,1546), t3x128(:,:,880))
  call heltable([16,8,128], n3(:,1547), t3x128(:,:,881))
  call heltable([16,8,128], n3(:,1548), t3x128(:,:,882))
  call heltable([16,8,128], n3(:,1549), t3x128(:,:,883))
  call heltable([16,8,128], n3(:,1550), t3x128(:,:,884))
  call heltable([16,8,128], n3(:,1551), t3x128(:,:,885))
  call heltable([16,8,128], n3(:,1552), t3x128(:,:,886))
  call heltable([16,8,128], n3(:,1553), t3x128(:,:,887))
  call heltable([16,8,128], n3(:,1554), t3x128(:,:,888))
  call heltable([16,8,128], n3(:,1555), t3x128(:,:,889))
  call heltable([16,8,128], n3(:,1556), t3x128(:,:,890))
  call heltable([16,8,128], n3(:,1557), t3x128(:,:,891))
  call heltable([16,8,128], n3(:,1558), t3x128(:,:,892))
  call heltable([16,8,128], n3(:,1559), t3x128(:,:,893))
  call heltable([16,8,128], n3(:,1560), t3x128(:,:,894))
  call heltable([16,8,128], n3(:,1561), t3x128(:,:,895))
  call heltable([16,8,128], n3(:,1562), t3x128(:,:,896))
  call heltable([16,8,128], n3(:,1563), t3x128(:,:,897))
  call heltable([16,8,128], n3(:,1564), t3x128(:,:,898))
  call heltable([16,8,128], n3(:,1565), t3x128(:,:,899))
  call heltable([16,8,128], n3(:,1566), t3x128(:,:,900))
  call heltable([16,8,128], n3(:,1567), t3x128(:,:,901))
  call heltable([16,8,128], n3(:,1568), t3x128(:,:,902))
  call heltable([16,8,128], n3(:,1569), t3x128(:,:,903))
  call heltable([16,8,128], n3(:,1570), t3x128(:,:,904))
  call heltable([16,8,128], n3(:,1571), t3x128(:,:,905))
  call heltable([16,8,128], n3(:,1572), t3x128(:,:,906))
  call heltable([16,8,128], n3(:,1573), t3x128(:,:,907))
  call heltable([16,8,128], n3(:,1574), t3x128(:,:,908))
  call heltable([16,8,128], n3(:,1575), t3x128(:,:,909))
  call heltable([8,16,128], n3(:,1576), t3x128(:,:,910))
  call heltable([8,16,128], n3(:,1577), t3x128(:,:,911))
  call heltable([8,16,128], n3(:,1578), t3x128(:,:,912))
  call heltable([16,8,128], n3(:,1579), t3x128(:,:,913))
  call heltable([16,8,128], n3(:,1580), t3x128(:,:,914))
  call heltable([16,8,128], n3(:,1581), t3x128(:,:,915))
  call heltable([8,16,128], n3(:,1582), t3x128(:,:,916))
  call heltable([8,16,128], n3(:,1583), t3x128(:,:,917))
  call heltable([8,16,128], n3(:,1584), t3x128(:,:,918))
  call heltable([8,16,128], n3(:,1585), t3x128(:,:,919))
  call heltable([8,16,128], n3(:,1586), t3x128(:,:,920))
  call heltable([8,16,128], n3(:,1587), t3x128(:,:,921))
  call heltable([16,8,128], n3(:,1588), t3x128(:,:,922))
  call heltable([16,8,128], n3(:,1589), t3x128(:,:,923))
  call heltable([16,8,128], n3(:,1590), t3x128(:,:,924))
  call heltable([8,16,128], n3(:,1591), t3x128(:,:,925))
  call heltable([8,16,128], n3(:,1592), t3x128(:,:,926))
  call heltable([8,16,128], n3(:,1593), t3x128(:,:,927))
  call heltable([16,8,128], n3(:,1594), t3x128(:,:,928))
  call heltable([16,8,128], n3(:,1595), t3x128(:,:,929))
  call heltable([16,8,128], n3(:,1596), t3x128(:,:,930))
  call heltable([16,8,128], n3(:,1597), t3x128(:,:,931))
  call heltable([16,8,128], n3(:,1598), t3x128(:,:,932))
  call heltable([16,8,128], n3(:,1599), t3x128(:,:,933))
  call heltable([16,8,128], n3(:,1600), t3x128(:,:,934))
  call heltable([16,8,128], n3(:,1601), t3x128(:,:,935))
  call heltable([16,8,128], n3(:,1602), t3x128(:,:,936))
  call heltable([16,8,128], n3(:,1603), t3x128(:,:,937))
  call heltable([16,8,128], n3(:,1604), t3x128(:,:,938))
  call heltable([16,8,128], n3(:,1605), t3x128(:,:,939))
  call heltable([16,8,128], n3(:,1606), t3x128(:,:,940))
  call heltable([16,8,128], n3(:,1607), t3x128(:,:,941))
  call heltable([16,8,128], n3(:,1608), t3x128(:,:,942))
  call heltable([16,8,128], n3(:,1609), t3x128(:,:,943))
  call heltable([16,8,128], n3(:,1610), t3x128(:,:,944))
  call heltable([16,8,128], n3(:,1611), t3x128(:,:,945))
  call heltable([8,16,128], n3(:,1612), t3x128(:,:,946))
  call heltable([8,16,128], n3(:,1613), t3x128(:,:,947))
  call heltable([16,8,128], n3(:,1614), t3x128(:,:,948))
  call heltable([8,16,128], n3(:,1615), t3x128(:,:,949))
  call heltable([8,16,128], n3(:,1616), t3x128(:,:,950))
  call heltable([16,8,128], n3(:,1617), t3x128(:,:,951))
  call heltable([8,16,128], n3(:,1618), t3x128(:,:,952))
  call heltable([8,16,128], n3(:,1619), t3x128(:,:,953))
  call heltable([16,8,128], n3(:,1620), t3x128(:,:,954))
  call heltable([8,16,128], n3(:,1621), t3x128(:,:,955))
  call heltable([8,16,128], n3(:,1622), t3x128(:,:,956))
  call heltable([8,16,128], n3(:,1623), t3x128(:,:,957))
  call heltable([8,16,128], n3(:,1624), t3x128(:,:,958))
  call heltable([8,16,128], n3(:,1625), t3x128(:,:,959))
  call heltable([8,16,128], n3(:,1626), t3x128(:,:,960))
  call heltable([8,16,128], n3(:,1627), t3x128(:,:,961))
  call heltable([8,16,128], n3(:,1628), t3x128(:,:,962))
  call heltable([16,8,128], n3(:,1629), t3x128(:,:,963))
  call heltable([8,16,128], n3(:,1630), t3x128(:,:,964))
  call heltable([8,16,128], n3(:,1631), t3x128(:,:,965))
  call heltable([16,8,128], n3(:,1632), t3x128(:,:,966))
  call heltable([8,16,128], n3(:,1633), t3x128(:,:,967))
  call heltable([8,16,128], n3(:,1634), t3x128(:,:,968))
  call heltable([16,8,128], n3(:,1635), t3x128(:,:,969))
  call heltable([8,16,128], n3(:,1636), t3x128(:,:,970))
  call heltable([8,16,128], n3(:,1637), t3x128(:,:,971))
  call heltable([8,16,128], n3(:,1638), t3x128(:,:,972))
  call heltable([8,16,128], n3(:,1639), t3x128(:,:,973))
  call heltable([8,16,128], n3(:,1640), t3x128(:,:,974))
  call heltable([8,16,128], n3(:,1641), t3x128(:,:,975))
  call heltable([8,16,128], n3(:,1642), t3x128(:,:,976))
  call heltable([8,16,128], n3(:,1643), t3x128(:,:,977))
  call heltable([16,8,128], n3(:,1644), t3x128(:,:,978))
  call heltable([8,16,128], n3(:,1645), t3x128(:,:,979))
  call heltable([8,16,128], n3(:,1646), t3x128(:,:,980))
  call heltable([16,8,128], n3(:,1647), t3x128(:,:,981))
  call heltable([8,16,128], n3(:,1648), t3x128(:,:,982))
  call heltable([8,16,128], n3(:,1649), t3x128(:,:,983))
  call heltable([8,16,128], n3(:,1650), t3x128(:,:,984))
  call heltable([8,16,128], n3(:,1651), t3x128(:,:,985))
  call heltable([8,16,128], n3(:,1652), t3x128(:,:,986))
  call heltable([8,16,128], n3(:,1653), t3x128(:,:,987))
  call heltable([8,16,128], n3(:,1654), t3x128(:,:,988))
  call heltable([8,16,128], n3(:,1655), t3x128(:,:,989))
  call heltable([8,16,128], n3(:,1656), t3x128(:,:,990))
  call heltable([8,16,128], n3(:,1657), t3x128(:,:,991))
  call heltable([8,16,128], n3(:,1658), t3x128(:,:,992))
  call heltable([16,8,128], n3(:,1659), t3x128(:,:,993))
  call heltable([8,16,128], n3(:,1660), t3x128(:,:,994))
  call heltable([8,16,128], n3(:,1661), t3x128(:,:,995))
  call heltable([16,8,128], n3(:,1662), t3x128(:,:,996))
  call heltable([8,16,128], n3(:,1663), t3x128(:,:,997))
  call heltable([8,16,128], n3(:,1664), t3x128(:,:,998))
  call heltable([8,16,128], n3(:,1665), t3x128(:,:,999))
  call heltable([8,16,128], n3(:,1666), t3x128(:,:,1000))
  call heltable([8,16,128], n3(:,1667), t3x128(:,:,1001))
  call heltable([8,16,128], n3(:,1668), t3x128(:,:,1002))
  call heltable([8,16,128], n3(:,1669), t3x128(:,:,1003))
  call heltable([8,16,128], n3(:,1670), t3x128(:,:,1004))
  call heltable([16,8,128], n3(:,1671), t3x128(:,:,1005))
  call heltable([8,16,128], n3(:,1672), t3x128(:,:,1006))
  call heltable([8,16,128], n3(:,1673), t3x128(:,:,1007))
  call heltable([8,16,128], n3(:,1674), t3x128(:,:,1008))
  call heltable([8,16,128], n3(:,1675), t3x128(:,:,1009))
  call heltable([8,16,128], n3(:,1676), t3x128(:,:,1010))
  call heltable([8,16,128], n3(:,1677), t3x128(:,:,1011))
  call heltable([8,16,128], n3(:,1678), t3x128(:,:,1012))
  call heltable([8,16,128], n3(:,1679), t3x128(:,:,1013))
  call heltable([8,16,128], n3(:,1680), t3x128(:,:,1014))
  call heltable([8,16,128], n3(:,1681), t3x128(:,:,1015))
  call heltable([8,16,128], n3(:,1682), t3x128(:,:,1016))
  call heltable([16,8,128], n3(:,1683), t3x128(:,:,1017))
  call heltable([8,16,128], n3(:,1684), t3x128(:,:,1018))
  call heltable([8,16,128], n3(:,1685), t3x128(:,:,1019))
  call heltable([8,16,128], n3(:,1686), t3x128(:,:,1020))
  call heltable([8,16,128], n3(:,1687), t3x128(:,:,1021))
  call heltable([8,16,128], n3(:,1688), t3x128(:,:,1022))
  call heltable([8,16,128], n3(:,1689), t3x128(:,:,1023))
  call heltable([8,16,128], n3(:,1690), t3x128(:,:,1024))
  call heltable([8,16,128], n3(:,1691), t3x128(:,:,1025))
  call heltable([8,16,128], n3(:,1692), t3x128(:,:,1026))
  call heltable([8,16,128], n3(:,1693), t3x128(:,:,1027))
  call heltable([8,16,128], n3(:,1694), t3x128(:,:,1028))
  call heltable([8,16,128], n3(:,1695), t3x128(:,:,1029))
  call heltable([8,16,128], n3(:,1696), t3x128(:,:,1030))
  call heltable([8,16,128], n3(:,1697), t3x128(:,:,1031))
  call heltable([8,16,128], n3(:,1698), t3x128(:,:,1032))
  call heltable([8,16,128], n3(:,1699), t3x128(:,:,1033))
  call heltable([8,16,128], n3(:,1700), t3x128(:,:,1034))
  call heltable([8,16,128], n3(:,1701), t3x128(:,:,1035))
  call heltable([8,16,128], n3(:,1702), t3x128(:,:,1036))
  call heltable([8,16,128], n3(:,1703), t3x128(:,:,1037))
  call heltable([8,16,128], n3(:,1704), t3x128(:,:,1038))
  call heltable([8,16,128], n3(:,1705), t3x128(:,:,1039))
  call heltable([8,16,128], n3(:,1706), t3x128(:,:,1040))
  call heltable([8,16,128], n3(:,1707), t3x128(:,:,1041))
  call heltable([8,16,128], n3(:,1708), t3x128(:,:,1042))
  call heltable([8,16,128], n3(:,1709), t3x128(:,:,1043))
  call heltable([8,16,128], n3(:,1710), t3x128(:,:,1044))
  call heltable([8,16,128], n3(:,1711), t3x128(:,:,1045))
  call heltable([8,16,128], n3(:,1712), t3x128(:,:,1046))
  call heltable([8,16,128], n3(:,1713), t3x128(:,:,1047))
  call heltable([8,16,128], n3(:,1714), t3x128(:,:,1048))
  call heltable([8,16,128], n3(:,1715), t3x128(:,:,1049))
  call heltable([8,16,128], n3(:,1716), t3x128(:,:,1050))
  call heltable([16,8,128], n3(:,1717), t3x128(:,:,1051))
  call heltable([16,8,128], n3(:,1718), t3x128(:,:,1052))
  call heltable([8,16,128], n3(:,1719), t3x128(:,:,1053))
  call heltable([16,8,128], n3(:,1720), t3x128(:,:,1054))
  call heltable([16,8,128], n3(:,1721), t3x128(:,:,1055))
  call heltable([8,16,128], n3(:,1722), t3x128(:,:,1056))
  call heltable([16,8,128], n3(:,1723), t3x128(:,:,1057))
  call heltable([16,8,128], n3(:,1724), t3x128(:,:,1058))
  call heltable([8,16,128], n3(:,1725), t3x128(:,:,1059))
  call heltable([8,16,128], n3(:,1726), t3x128(:,:,1060))
  call heltable([8,16,128], n3(:,1727), t3x128(:,:,1061))
  call heltable([8,16,128], n3(:,1728), t3x128(:,:,1062))
  call heltable([8,16,128], n3(:,1729), t3x128(:,:,1063))
  call heltable([8,16,128], n3(:,1730), t3x128(:,:,1064))
  call heltable([8,16,128], n3(:,1731), t3x128(:,:,1065))
  call heltable([8,16,128], n3(:,1732), t3x128(:,:,1066))
  call heltable([16,8,128], n3(:,1733), t3x128(:,:,1067))
  call heltable([8,16,128], n3(:,1734), t3x128(:,:,1068))
  call heltable([8,16,128], n3(:,1735), t3x128(:,:,1069))
  call heltable([16,8,128], n3(:,1736), t3x128(:,:,1070))
  call heltable([8,16,128], n3(:,1737), t3x128(:,:,1071))
  call heltable([16,8,128], n3(:,1738), t3x128(:,:,1072))
  call heltable([16,8,128], n3(:,1739), t3x128(:,:,1073))
  call heltable([8,16,128], n3(:,1740), t3x128(:,:,1074))
  call heltable([8,16,128], n3(:,1741), t3x128(:,:,1075))
  call heltable([8,16,128], n3(:,1742), t3x128(:,:,1076))
  call heltable([8,16,128], n3(:,1743), t3x128(:,:,1077))
  call heltable([8,16,128], n3(:,1744), t3x128(:,:,1078))
  call heltable([8,16,128], n3(:,1745), t3x128(:,:,1079))
  call heltable([8,16,128], n3(:,1746), t3x128(:,:,1080))
  call heltable([8,16,128], n3(:,1747), t3x128(:,:,1081))
  call heltable([16,8,128], n3(:,1748), t3x128(:,:,1082))
  call heltable([8,16,128], n3(:,1749), t3x128(:,:,1083))
  call heltable([8,16,128], n3(:,1750), t3x128(:,:,1084))
  call heltable([16,8,128], n3(:,1751), t3x128(:,:,1085))
  call heltable([8,16,128], n3(:,1752), t3x128(:,:,1086))
  call heltable([8,16,128], n3(:,1753), t3x128(:,:,1087))
  call heltable([16,8,128], n3(:,1754), t3x128(:,:,1088))
  call heltable([16,8,128], n3(:,1755), t3x128(:,:,1089))
  call heltable([8,16,128], n3(:,1756), t3x128(:,:,1090))
  call heltable([8,16,128], n3(:,1757), t3x128(:,:,1091))
  call heltable([8,16,128], n3(:,1758), t3x128(:,:,1092))
  call heltable([8,16,128], n3(:,1759), t3x128(:,:,1093))
  call heltable([8,16,128], n3(:,1760), t3x128(:,:,1094))
  call heltable([8,16,128], n3(:,1761), t3x128(:,:,1095))
  call heltable([8,16,128], n3(:,1762), t3x128(:,:,1096))
  call heltable([16,8,128], n3(:,1763), t3x128(:,:,1097))
  call heltable([8,16,128], n3(:,1764), t3x128(:,:,1098))
  call heltable([8,16,128], n3(:,1765), t3x128(:,:,1099))
  call heltable([16,8,128], n3(:,1766), t3x128(:,:,1100))
  call heltable([8,16,128], n3(:,1767), t3x128(:,:,1101))
  call heltable([16,8,128], n3(:,1768), t3x128(:,:,1102))
  call heltable([8,16,128], n3(:,1769), t3x128(:,:,1103))
  call heltable([8,16,128], n3(:,1770), t3x128(:,:,1104))
  call heltable([8,16,128], n3(:,1771), t3x128(:,:,1105))
  call heltable([8,16,128], n3(:,1772), t3x128(:,:,1106))
  call heltable([8,16,128], n3(:,1773), t3x128(:,:,1107))
  call heltable([8,16,128], n3(:,1774), t3x128(:,:,1108))
  call heltable([16,8,128], n3(:,1775), t3x128(:,:,1109))
  call heltable([8,16,128], n3(:,1776), t3x128(:,:,1110))
  call heltable([8,16,128], n3(:,1777), t3x128(:,:,1111))
  call heltable([16,8,128], n3(:,1778), t3x128(:,:,1112))
  call heltable([16,8,128], n3(:,1779), t3x128(:,:,1113))
  call heltable([8,16,128], n3(:,1780), t3x128(:,:,1114))
  call heltable([8,16,128], n3(:,1781), t3x128(:,:,1115))
  call heltable([8,16,128], n3(:,1782), t3x128(:,:,1116))
  call heltable([8,16,128], n3(:,1783), t3x128(:,:,1117))
  call heltable([8,16,128], n3(:,1784), t3x128(:,:,1118))
  call heltable([8,16,128], n3(:,1785), t3x128(:,:,1119))
  call heltable([8,16,128], n3(:,1786), t3x128(:,:,1120))
  call heltable([16,8,128], n3(:,1787), t3x128(:,:,1121))
  call heltable([8,16,128], n3(:,1788), t3x128(:,:,1122))
  call heltable([8,16,128], n3(:,1789), t3x128(:,:,1123))
  call heltable([16,8,128], n3(:,1790), t3x128(:,:,1124))
  call heltable([16,8,128], n3(:,1791), t3x128(:,:,1125))
  call heltable([8,16,128], n3(:,1792), t3x128(:,:,1126))
  call heltable([8,16,128], n3(:,1793), t3x128(:,:,1127))
  call heltable([8,16,128], n3(:,1794), t3x128(:,:,1128))
  call heltable([8,16,128], n3(:,1795), t3x128(:,:,1129))
  call heltable([8,16,128], n3(:,1796), t3x128(:,:,1130))
  call heltable([8,16,128], n3(:,1797), t3x128(:,:,1131))
  call heltable([16,8,128], n3(:,1798), t3x128(:,:,1132))
  call heltable([8,16,128], n3(:,1799), t3x128(:,:,1133))
  call heltable([8,16,128], n3(:,1800), t3x128(:,:,1134))
  call heltable([8,16,128], n3(:,1801), t3x128(:,:,1135))
  call heltable([8,16,128], n3(:,1802), t3x128(:,:,1136))
  call heltable([8,16,128], n3(:,1803), t3x128(:,:,1137))
  call heltable([8,16,128], n3(:,1804), t3x128(:,:,1138))
  call heltable([8,16,128], n3(:,1805), t3x128(:,:,1139))
  call heltable([8,16,128], n3(:,1806), t3x128(:,:,1140))
  call heltable([8,16,128], n3(:,1807), t3x128(:,:,1141))
  call heltable([8,16,128], n3(:,1808), t3x128(:,:,1142))
  call heltable([8,16,128], n3(:,1809), t3x128(:,:,1143))
  call heltable([8,16,128], n3(:,1810), t3x128(:,:,1144))
  call heltable([8,16,128], n3(:,1811), t3x128(:,:,1145))
  call heltable([8,16,128], n3(:,1812), t3x128(:,:,1146))
  call heltable([8,16,128], n3(:,1813), t3x128(:,:,1147))
  call heltable([8,16,128], n3(:,1814), t3x128(:,:,1148))
  call heltable([8,16,128], n3(:,1815), t3x128(:,:,1149))
  call heltable([8,16,128], n3(:,1816), t3x128(:,:,1150))
  call heltable([8,16,128], n3(:,1817), t3x128(:,:,1151))
  call heltable([8,16,128], n3(:,1818), t3x128(:,:,1152))
  call heltable([8,16,128], n3(:,1819), t3x128(:,:,1153))
  call heltable([8,16,128], n3(:,1820), t3x128(:,:,1154))
  call heltable([8,16,128], n3(:,1821), t3x128(:,:,1155))
  call heltable([16,8,128], n3(:,1822), t3x128(:,:,1156))
  call heltable([16,8,128], n3(:,1823), t3x128(:,:,1157))
  call heltable([8,16,128], n3(:,1824), t3x128(:,:,1158))
  call heltable([16,8,128], n3(:,1825), t3x128(:,:,1159))
  call heltable([16,8,128], n3(:,1826), t3x128(:,:,1160))
  call heltable([8,16,128], n3(:,1827), t3x128(:,:,1161))
  call heltable([16,8,128], n3(:,1828), t3x128(:,:,1162))
  call heltable([16,8,128], n3(:,1829), t3x128(:,:,1163))
  call heltable([8,16,128], n3(:,1830), t3x128(:,:,1164))
  call heltable([8,16,128], n3(:,1831), t3x128(:,:,1165))
  call heltable([8,16,128], n3(:,1832), t3x128(:,:,1166))
  call heltable([8,16,128], n3(:,1833), t3x128(:,:,1167))
  call heltable([8,16,128], n3(:,1834), t3x128(:,:,1168))
  call heltable([8,16,128], n3(:,1835), t3x128(:,:,1169))
  call heltable([8,16,128], n3(:,1836), t3x128(:,:,1170))
  call heltable([16,8,128], n3(:,1837), t3x128(:,:,1171))
  call heltable([8,16,128], n3(:,1838), t3x128(:,:,1172))
  call heltable([8,16,128], n3(:,1839), t3x128(:,:,1173))
  call heltable([16,8,128], n3(:,1840), t3x128(:,:,1174))
  call heltable([8,16,128], n3(:,1841), t3x128(:,:,1175))
  call heltable([8,16,128], n3(:,1842), t3x128(:,:,1176))
  call heltable([16,8,128], n3(:,1843), t3x128(:,:,1177))
  call heltable([16,8,128], n3(:,1844), t3x128(:,:,1178))
  call heltable([8,16,128], n3(:,1845), t3x128(:,:,1179))
  call heltable([8,16,128], n3(:,1846), t3x128(:,:,1180))
  call heltable([8,16,128], n3(:,1847), t3x128(:,:,1181))
  call heltable([8,16,128], n3(:,1848), t3x128(:,:,1182))
  call heltable([8,16,128], n3(:,1849), t3x128(:,:,1183))
  call heltable([8,16,128], n3(:,1850), t3x128(:,:,1184))
  call heltable([8,16,128], n3(:,1851), t3x128(:,:,1185))
  call heltable([16,8,128], n3(:,1852), t3x128(:,:,1186))
  call heltable([8,16,128], n3(:,1853), t3x128(:,:,1187))
  call heltable([8,16,128], n3(:,1854), t3x128(:,:,1188))
  call heltable([16,8,128], n3(:,1855), t3x128(:,:,1189))
  call heltable([8,16,128], n3(:,1856), t3x128(:,:,1190))
  call heltable([8,16,128], n3(:,1857), t3x128(:,:,1191))
  call heltable([8,16,128], n3(:,1858), t3x128(:,:,1192))
  call heltable([8,16,128], n3(:,1859), t3x128(:,:,1193))
  call heltable([8,16,128], n3(:,1860), t3x128(:,:,1194))
  call heltable([8,16,128], n3(:,1861), t3x128(:,:,1195))
  call heltable([8,16,128], n3(:,1862), t3x128(:,:,1196))
  call heltable([8,16,128], n3(:,1863), t3x128(:,:,1197))
  call heltable([8,16,128], n3(:,1864), t3x128(:,:,1198))
  call heltable([8,16,128], n3(:,1865), t3x128(:,:,1199))
  call heltable([8,16,128], n3(:,1866), t3x128(:,:,1200))
  call heltable([16,8,128], n3(:,1867), t3x128(:,:,1201))
  call heltable([8,16,128], n3(:,1868), t3x128(:,:,1202))
  call heltable([8,16,128], n3(:,1869), t3x128(:,:,1203))
  call heltable([16,8,128], n3(:,1870), t3x128(:,:,1204))
  call heltable([8,16,128], n3(:,1871), t3x128(:,:,1205))
  call heltable([8,16,128], n3(:,1872), t3x128(:,:,1206))
  call heltable([8,16,128], n3(:,1873), t3x128(:,:,1207))
  call heltable([8,16,128], n3(:,1874), t3x128(:,:,1208))
  call heltable([16,8,128], n3(:,1875), t3x128(:,:,1209))
  call heltable([8,16,128], n3(:,1876), t3x128(:,:,1210))
  call heltable([8,16,128], n3(:,1877), t3x128(:,:,1211))
  call heltable([8,16,128], n3(:,1878), t3x128(:,:,1212))
  call heltable([16,8,128], n3(:,1879), t3x128(:,:,1213))
  call heltable([8,16,128], n3(:,1880), t3x128(:,:,1214))
  call heltable([8,16,128], n3(:,1881), t3x128(:,:,1215))
  call heltable([8,16,128], n3(:,1882), t3x128(:,:,1216))
  call heltable([8,16,128], n3(:,1883), t3x128(:,:,1217))
  call heltable([8,16,128], n3(:,1884), t3x128(:,:,1218))
  call heltable([8,16,128], n3(:,1885), t3x128(:,:,1219))
  call heltable([8,16,128], n3(:,1886), t3x128(:,:,1220))
  call heltable([8,16,128], n3(:,1887), t3x128(:,:,1221))
  call heltable([8,16,128], n3(:,1888), t3x128(:,:,1222))
  call heltable([8,16,128], n3(:,1889), t3x128(:,:,1223))
  call heltable([8,16,128], n3(:,1890), t3x128(:,:,1224))
  call heltable([16,8,128], n3(:,1891), t3x128(:,:,1225))
  call heltable([8,16,128], n3(:,1892), t3x128(:,:,1226))
  call heltable([8,16,128], n3(:,1893), t3x128(:,:,1227))
  call heltable([8,16,128], n3(:,1894), t3x128(:,:,1228))
  call heltable([8,16,128], n3(:,1895), t3x128(:,:,1229))
  call heltable([8,16,128], n3(:,1896), t3x128(:,:,1230))
  call heltable([8,16,128], n3(:,1897), t3x128(:,:,1231))
  call heltable([8,16,128], n3(:,1898), t3x128(:,:,1232))
  call heltable([8,16,128], n3(:,1899), t3x128(:,:,1233))
  call heltable([8,16,128], n3(:,1900), t3x128(:,:,1234))
  call heltable([8,16,128], n3(:,1901), t3x128(:,:,1235))
  call heltable([8,16,128], n3(:,1902), t3x128(:,:,1236))
  call heltable([8,16,128], n3(:,1903), t3x128(:,:,1237))
  call heltable([8,16,128], n3(:,1904), t3x128(:,:,1238))
  call heltable([16,8,128], n3(:,1905), t3x128(:,:,1239))
  call heltable([8,16,128], n3(:,1906), t3x128(:,:,1240))
  call heltable([8,16,128], n3(:,1907), t3x128(:,:,1241))
  call heltable([8,16,128], n3(:,1908), t3x128(:,:,1242))
  call heltable([8,16,128], n3(:,1909), t3x128(:,:,1243))
  call heltable([8,16,128], n3(:,1910), t3x128(:,:,1244))
  call heltable([8,16,128], n3(:,1911), t3x128(:,:,1245))
  call heltable([8,16,128], n3(:,1912), t3x128(:,:,1246))
  call heltable([8,16,128], n3(:,1913), t3x128(:,:,1247))
  call heltable([8,16,128], n3(:,1914), t3x128(:,:,1248))
  call heltable([8,16,128], n3(:,1915), t3x128(:,:,1249))
  call heltable([8,16,128], n3(:,1916), t3x128(:,:,1250))
  call heltable([8,16,128], n3(:,1917), t3x128(:,:,1251))
  call heltable([8,16,128], n3(:,1918), t3x128(:,:,1252))
  call heltable([8,16,128], n3(:,1919), t3x128(:,:,1253))
  call heltable([8,16,128], n3(:,1920), t3x128(:,:,1254))
  call heltable([8,16,128], n3(:,1921), t3x128(:,:,1255))
  call heltable([8,16,128], n3(:,1922), t3x128(:,:,1256))
  call heltable([8,16,128], n3(:,1923), t3x128(:,:,1257))
  call heltable([8,16,128], n3(:,1924), t3x128(:,:,1258))
  call heltable([8,16,128], n3(:,1925), t3x128(:,:,1259))
  call heltable([8,16,128], n3(:,1926), t3x128(:,:,1260))
  call heltable([8,16,128], n3(:,1927), t3x128(:,:,1261))
  call heltable([8,16,128], n3(:,1928), t3x128(:,:,1262))
  call heltable([8,16,128], n3(:,1929), t3x128(:,:,1263))
  call heltable([8,16,128], n3(:,1930), t3x128(:,:,1264))
  call heltable([8,16,128], n3(:,1931), t3x128(:,:,1265))
  call heltable([8,16,128], n3(:,1932), t3x128(:,:,1266))
  call heltable([16,8,128], n3(:,1933), t3x128(:,:,1267))
  call heltable([16,8,128], n3(:,1934), t3x128(:,:,1268))
  call heltable([8,16,128], n3(:,1935), t3x128(:,:,1269))
  call heltable([8,16,128], n3(:,1936), t3x128(:,:,1270))
  call heltable([8,16,128], n3(:,1937), t3x128(:,:,1271))
  call heltable([8,16,128], n3(:,1938), t3x128(:,:,1272))
  call heltable([8,16,128], n3(:,1939), t3x128(:,:,1273))
  call heltable([8,16,128], n3(:,1940), t3x128(:,:,1274))
  call heltable([8,16,128], n3(:,1941), t3x128(:,:,1275))
  call heltable([8,16,128], n3(:,1942), t3x128(:,:,1276))
  call heltable([8,16,128], n3(:,1943), t3x128(:,:,1277))
  call heltable([8,16,128], n3(:,1944), t3x128(:,:,1278))
  call heltable([8,16,128], n3(:,1945), t3x128(:,:,1279))
  call heltable([8,16,128], n3(:,1946), t3x128(:,:,1280))
  call heltable([8,16,128], n3(:,1947), t3x128(:,:,1281))
  call heltable([8,16,128], n3(:,1948), t3x128(:,:,1282))
  call heltable([16,8,128], n3(:,1949), t3x128(:,:,1283))
  call heltable([8,16,128], n3(:,1950), t3x128(:,:,1284))
  call heltable([8,16,128], n3(:,1951), t3x128(:,:,1285))
  call heltable([8,16,128], n3(:,1952), t3x128(:,:,1286))
  call heltable([8,16,128], n3(:,1953), t3x128(:,:,1287))
  call heltable([8,16,128], n3(:,1954), t3x128(:,:,1288))
  call heltable([8,16,128], n3(:,1955), t3x128(:,:,1289))
  call heltable([8,16,128], n3(:,1956), t3x128(:,:,1290))
  call heltable([8,16,128], n3(:,1957), t3x128(:,:,1291))
  call heltable([8,16,128], n3(:,1958), t3x128(:,:,1292))
  call heltable([8,16,128], n3(:,1959), t3x128(:,:,1293))
  call heltable([16,8,128], n3(:,1960), t3x128(:,:,1294))
  call heltable([16,8,128], n3(:,1961), t3x128(:,:,1295))
  call heltable([8,16,128], n3(:,1962), t3x128(:,:,1296))
  call heltable([8,16,128], n3(:,1963), t3x128(:,:,1297))
  call heltable([8,16,128], n3(:,1964), t3x128(:,:,1298))
  call heltable([8,16,128], n3(:,1965), t3x128(:,:,1299))
  call heltable([8,16,128], n3(:,1966), t3x128(:,:,1300))
  call heltable([8,16,128], n3(:,1967), t3x128(:,:,1301))
  call heltable([8,16,128], n3(:,1968), t3x128(:,:,1302))
  call heltable([8,16,128], n3(:,1969), t3x128(:,:,1303))
  call heltable([8,16,128], n3(:,1970), t3x128(:,:,1304))
  call heltable([8,16,128], n3(:,1971), t3x128(:,:,1305))
  call heltable([8,16,128], n3(:,1972), t3x128(:,:,1306))
  call heltable([16,8,128], n3(:,1973), t3x128(:,:,1307))
  call heltable([8,16,128], n3(:,1974), t3x128(:,:,1308))
  call heltable([8,16,128], n3(:,1975), t3x128(:,:,1309))
  call heltable([8,16,128], n3(:,1976), t3x128(:,:,1310))
  call heltable([8,16,128], n3(:,1977), t3x128(:,:,1311))
  call heltable([8,16,128], n3(:,1978), t3x128(:,:,1312))
  call heltable([8,16,128], n3(:,1979), t3x128(:,:,1313))
  call heltable([8,16,128], n3(:,1980), t3x128(:,:,1314))
  call heltable([16,8,128], n3(:,1981), t3x128(:,:,1315))
  call heltable([16,8,128], n3(:,1982), t3x128(:,:,1316))
  call heltable([8,16,128], n3(:,1983), t3x128(:,:,1317))
  call heltable([8,16,128], n3(:,1984), t3x128(:,:,1318))
  call heltable([16,8,128], n3(:,1985), t3x128(:,:,1319))
  call heltable([8,16,128], n3(:,1986), t3x128(:,:,1320))
  call heltable([8,16,128], n3(:,1987), t3x128(:,:,1321))
  call heltable([8,16,128], n3(:,1988), t3x128(:,:,1322))
  call heltable([8,16,128], n3(:,1989), t3x128(:,:,1323))
  call heltable([16,8,128], n3(:,1990), t3x128(:,:,1324))
  call heltable([8,16,128], n3(:,1991), t3x128(:,:,1325))
  call heltable([8,16,128], n3(:,1992), t3x128(:,:,1326))
  call heltable([8,16,128], n3(:,1993), t3x128(:,:,1327))
  call heltable([8,16,128], n3(:,1994), t3x128(:,:,1328))
  call heltable([8,16,128], n3(:,1995), t3x128(:,:,1329))
  call heltable([8,16,128], n3(:,1996), t3x128(:,:,1330))
  call heltable([8,16,128], n3(:,1997), t3x128(:,:,1331))
  call heltable([8,16,128], n3(:,1998), t3x128(:,:,1332))
  call heltable([8,16,128], n3(:,1999), t3x128(:,:,1333))
  call heltable([8,16,128], n3(:,2000), t3x128(:,:,1334))
  call heltable([8,16,128], n3(:,2001), t3x128(:,:,1335))
  call heltable([8,16,128], n3(:,2002), t3x128(:,:,1336))
  call heltable([8,16,128], n3(:,2003), t3x128(:,:,1337))
  call heltable([8,16,128], n3(:,2004), t3x128(:,:,1338))
  call heltable([8,16,128], n3(:,2005), t3x128(:,:,1339))
  call heltable([8,16,128], n3(:,2006), t3x128(:,:,1340))
  call heltable([8,16,128], n3(:,2007), t3x128(:,:,1341))
  call heltable([16,8,128], n3(:,2008), t3x128(:,:,1342))
  call heltable([8,16,128], n3(:,2009), t3x128(:,:,1343))
  call heltable([8,16,128], n3(:,2010), t3x128(:,:,1344))
  call heltable([8,16,128], n3(:,2011), t3x128(:,:,1345))
  call heltable([8,16,128], n3(:,2012), t3x128(:,:,1346))
  call heltable([8,16,128], n3(:,2013), t3x128(:,:,1347))
  call heltable([16,8,128], n3(:,2014), t3x128(:,:,1348))
  call heltable([8,16,128], n3(:,2015), t3x128(:,:,1349))
  call heltable([8,16,128], n3(:,2016), t3x128(:,:,1350))
  call heltable([8,16,128], n3(:,2017), t3x128(:,:,1351))
  call heltable([8,16,128], n3(:,2018), t3x128(:,:,1352))
  call heltable([8,16,128], n3(:,2019), t3x128(:,:,1353))
  call heltable([8,16,128], n3(:,2020), t3x128(:,:,1354))
  call heltable([8,16,128], n3(:,2021), t3x128(:,:,1355))
  call heltable([8,16,128], n3(:,2022), t3x128(:,:,1356))
  call heltable([16,8,128], n3(:,2023), t3x128(:,:,1357))
  call heltable([16,8,128], n3(:,2024), t3x128(:,:,1358))
  call heltable([8,16,128], n3(:,2025), t3x128(:,:,1359))
  call heltable([8,16,128], n3(:,2026), t3x128(:,:,1360))
  call heltable([8,16,128], n3(:,2027), t3x128(:,:,1361))
  call heltable([8,16,128], n3(:,2028), t3x128(:,:,1362))
  call heltable([8,16,128], n3(:,2029), t3x128(:,:,1363))
  call heltable([8,16,128], n3(:,2030), t3x128(:,:,1364))
  call heltable([8,16,128], n3(:,2031), t3x128(:,:,1365))
  call heltable([8,16,128], n3(:,2032), t3x128(:,:,1366))
  call heltable([8,16,128], n3(:,2033), t3x128(:,:,1367))
  call heltable([8,16,128], n3(:,2034), t3x128(:,:,1368))
  call heltable([8,16,128], n3(:,2035), t3x128(:,:,1369))
  call heltable([8,16,128], n3(:,2036), t3x128(:,:,1370))
  call heltable([8,16,128], n3(:,2037), t3x128(:,:,1371))
  call heltable([8,16,128], n3(:,2038), t3x128(:,:,1372))
  call heltable([8,16,128], n3(:,2039), t3x128(:,:,1373))
  call heltable([8,16,128], n3(:,2040), t3x128(:,:,1374))
  call heltable([8,16,128], n3(:,2041), t3x128(:,:,1375))
  call heltable([8,16,128], n3(:,2042), t3x128(:,:,1376))
  call heltable([8,16,128], n3(:,2043), t3x128(:,:,1377))
  call heltable([8,16,128], n3(:,2044), t3x128(:,:,1378))
  call heltable([8,16,128], n3(:,2045), t3x128(:,:,1379))
  call heltable([8,16,128], n3(:,2046), t3x128(:,:,1380))
  call heltable([8,16,128], n3(:,2047), t3x128(:,:,1381))
  call heltable([8,16,128], n3(:,2048), t3x128(:,:,1382))
  call heltable([8,16,128], n3(:,2049), t3x128(:,:,1383))
  call heltable([16,8,128], n3(:,2050), t3x128(:,:,1384))
  call heltable([16,8,128], n3(:,2051), t3x128(:,:,1385))
  call heltable([8,16,128], n3(:,2052), t3x128(:,:,1386))
  call heltable([8,16,128], n3(:,2053), t3x128(:,:,1387))
  call heltable([8,16,128], n3(:,2054), t3x128(:,:,1388))
  call heltable([8,16,128], n3(:,2055), t3x128(:,:,1389))
  call heltable([8,16,128], n3(:,2056), t3x128(:,:,1390))
  call heltable([8,16,128], n3(:,2057), t3x128(:,:,1391))
  call heltable([8,16,128], n3(:,2058), t3x128(:,:,1392))
  call heltable([8,16,128], n3(:,2059), t3x128(:,:,1393))
  call heltable([8,16,128], n3(:,2060), t3x128(:,:,1394))
  call heltable([8,16,128], n3(:,2061), t3x128(:,:,1395))
  call heltable([8,16,128], n3(:,2062), t3x128(:,:,1396))
  call heltable([8,16,128], n3(:,2063), t3x128(:,:,1397))
  call heltable([8,16,128], n3(:,2064), t3x128(:,:,1398))
  call heltable([8,16,128], n3(:,2065), t3x128(:,:,1399))
  call heltable([8,16,128], n3(:,2066), t3x128(:,:,1400))
  call heltable([8,16,128], n3(:,2067), t3x128(:,:,1401))
  call heltable([8,16,128], n3(:,2068), t3x128(:,:,1402))
  call heltable([8,16,128], n3(:,2069), t3x128(:,:,1403))
  call heltable([8,16,128], n3(:,2070), t3x128(:,:,1404))
  call heltable([16,8,128], n3(:,2071), t3x128(:,:,1405))
  call heltable([16,8,128], n3(:,2072), t3x128(:,:,1406))
  call heltable([8,16,128], n3(:,2073), t3x128(:,:,1407))
  call heltable([8,16,128], n3(:,2074), t3x128(:,:,1408))
  call heltable([8,16,128], n3(:,2075), t3x128(:,:,1409))
  call heltable([8,16,128], n3(:,2076), t3x128(:,:,1410))
  call heltable([8,16,128], n3(:,2077), t3x128(:,:,1411))
  call heltable([8,16,128], n3(:,2078), t3x128(:,:,1412))
  call heltable([8,16,128], n3(:,2079), t3x128(:,:,1413))
  call heltable([8,16,128], n3(:,2080), t3x128(:,:,1414))
  call heltable([8,16,128], n3(:,2081), t3x128(:,:,1415))
  call heltable([16,8,128], n3(:,2082), t3x128(:,:,1416))
  call heltable([8,16,128], n3(:,2083), t3x128(:,:,1417))
  call heltable([8,16,128], n3(:,2084), t3x128(:,:,1418))
  call heltable([8,16,128], n3(:,2085), t3x128(:,:,1419))
  call heltable([8,16,128], n3(:,2086), t3x128(:,:,1420))
  call heltable([8,16,128], n3(:,2087), t3x128(:,:,1421))
  call heltable([8,16,128], n3(:,2088), t3x128(:,:,1422))
  call heltable([8,16,128], n3(:,2089), t3x128(:,:,1423))
  call heltable([8,16,128], n3(:,2090), t3x128(:,:,1424))
  call heltable([8,16,128], n3(:,2091), t3x128(:,:,1425))
  call heltable([8,16,128], n3(:,2092), t3x128(:,:,1426))
  call heltable([8,16,128], n3(:,2093), t3x128(:,:,1427))
  call heltable([8,16,128], n3(:,2094), t3x128(:,:,1428))
  call heltable([8,16,128], n3(:,2095), t3x128(:,:,1429))
  call heltable([8,16,128], n3(:,2096), t3x128(:,:,1430))
  call heltable([8,16,128], n3(:,2097), t3x128(:,:,1431))
  call heltable([8,16,128], n3(:,2098), t3x128(:,:,1432))
  call heltable([8,16,128], n3(:,2099), t3x128(:,:,1433))
  call heltable([16,8,128], n3(:,2100), t3x128(:,:,1434))
  call heltable([8,16,128], n3(:,2101), t3x128(:,:,1435))
  call heltable([8,16,128], n3(:,2102), t3x128(:,:,1436))
  call heltable([8,16,128], n3(:,2103), t3x128(:,:,1437))
  call heltable([8,16,128], n3(:,2104), t3x128(:,:,1438))
  call heltable([8,16,128], n3(:,2105), t3x128(:,:,1439))
  call heltable([16,8,128], n3(:,2106), t3x128(:,:,1440))
  call heltable([8,16,128], n3(:,2107), t3x128(:,:,1441))
  call heltable([8,16,128], n3(:,2108), t3x128(:,:,1442))
  call heltable([8,16,128], n3(:,2109), t3x128(:,:,1443))
  call heltable([8,16,128], n3(:,2110), t3x128(:,:,1444))
  call heltable([8,16,128], n3(:,2111), t3x128(:,:,1445))
  call heltable([8,16,128], n3(:,2112), t3x128(:,:,1446))
  call heltable([8,16,128], n3(:,2113), t3x128(:,:,1447))
  call heltable([16,8,128], n3(:,2114), t3x128(:,:,1448))
  call heltable([8,16,128], n3(:,2115), t3x128(:,:,1449))
  call heltable([8,16,128], n3(:,2116), t3x128(:,:,1450))
  call heltable([8,16,128], n3(:,2117), t3x128(:,:,1451))
  call heltable([8,16,128], n3(:,2118), t3x128(:,:,1452))
  call heltable([8,16,128], n3(:,2119), t3x128(:,:,1453))
  call heltable([8,16,128], n3(:,2120), t3x128(:,:,1454))
  call heltable([8,16,128], n3(:,2121), t3x128(:,:,1455))
  call heltable([8,16,128], n3(:,2122), t3x128(:,:,1456))
  call heltable([8,16,128], n3(:,2123), t3x128(:,:,1457))
  call heltable([8,16,128], n3(:,2124), t3x128(:,:,1458))
  call heltable([8,16,128], n3(:,2125), t3x128(:,:,1459))
  call heltable([8,16,128], n3(:,2126), t3x128(:,:,1460))
  call heltable([8,16,128], n3(:,2127), t3x128(:,:,1461))
  call heltable([8,16,128], n3(:,2128), t3x128(:,:,1462))
  call heltable([8,16,128], n3(:,2129), t3x128(:,:,1463))
  call heltable([8,16,128], n3(:,2130), t3x128(:,:,1464))
  call heltable([8,16,128], n3(:,2131), t3x128(:,:,1465))
  call heltable([8,16,128], n3(:,2132), t3x128(:,:,1466))
  call heltable([8,16,128], n3(:,2133), t3x128(:,:,1467))
  call heltable([8,16,128], n3(:,2134), t3x128(:,:,1468))
  call heltable([8,16,128], n3(:,2135), t3x128(:,:,1469))
  call heltable([8,16,128], n3(:,2136), t3x128(:,:,1470))
  call heltable([8,16,128], n3(:,2137), t3x128(:,:,1471))
  call heltable([8,16,128], n3(:,2138), t3x128(:,:,1472))
  call heltable([8,16,128], n3(:,2139), t3x128(:,:,1473))
  call heltable([8,16,128], n3(:,2140), t3x128(:,:,1474))
  call heltable([16,8,128], n3(:,2141), t3x128(:,:,1475))
  call heltable([8,16,128], n3(:,2142), t3x128(:,:,1476))
  call heltable([8,16,128], n3(:,2143), t3x128(:,:,1477))
  call heltable([8,16,128], n3(:,2144), t3x128(:,:,1478))
  call heltable([8,16,128], n3(:,2145), t3x128(:,:,1479))
  call heltable([8,16,128], n3(:,2146), t3x128(:,:,1480))
  call heltable([8,16,128], n3(:,2147), t3x128(:,:,1481))
  call heltable([8,16,128], n3(:,2148), t3x128(:,:,1482))
  call heltable([8,16,128], n3(:,2149), t3x128(:,:,1483))
  call heltable([8,16,128], n3(:,2150), t3x128(:,:,1484))
  call heltable([8,16,128], n3(:,2151), t3x128(:,:,1485))
  call heltable([8,16,128], n3(:,2152), t3x128(:,:,1486))
  call heltable([8,16,128], n3(:,2153), t3x128(:,:,1487))
  call heltable([8,16,128], n3(:,2154), t3x128(:,:,1488))
  call heltable([8,16,128], n3(:,2155), t3x128(:,:,1489))
  call heltable([8,16,128], n3(:,2156), t3x128(:,:,1490))
  call heltable([8,16,128], n3(:,2157), t3x128(:,:,1491))
  call heltable([8,16,128], n3(:,2158), t3x128(:,:,1492))
  call heltable([8,16,128], n3(:,2159), t3x128(:,:,1493))
  call heltable([8,16,128], n3(:,2160), t3x128(:,:,1494))
  call heltable([8,16,128], n3(:,2161), t3x128(:,:,1495))
  call heltable([16,8,128], n3(:,2162), t3x128(:,:,1496))
  call heltable([8,16,128], n3(:,2163), t3x128(:,:,1497))
  call heltable([8,16,128], n3(:,2164), t3x128(:,:,1498))
  call heltable([8,16,128], n3(:,2165), t3x128(:,:,1499))
  call heltable([8,16,128], n3(:,2166), t3x128(:,:,1500))
  call heltable([8,16,128], n3(:,2167), t3x128(:,:,1501))
  call heltable([8,16,128], n3(:,2168), t3x128(:,:,1502))
  call heltable([8,16,128], n3(:,2169), t3x128(:,:,1503))
  call heltable([8,16,128], n3(:,2170), t3x128(:,:,1504))
  call heltable([8,16,128], n3(:,2171), t3x128(:,:,1505))
  call heltable([16,8,128], n3(:,2172), t3x128(:,:,1506))
  call heltable([8,16,128], n3(:,2173), t3x128(:,:,1507))
  call heltable([8,16,128], n3(:,2174), t3x128(:,:,1508))
  call heltable([8,16,128], n3(:,2175), t3x128(:,:,1509))
  call heltable([8,16,128], n3(:,2176), t3x128(:,:,1510))
  call heltable([8,16,128], n3(:,2177), t3x128(:,:,1511))
  call heltable([8,16,128], n3(:,2178), t3x128(:,:,1512))
  call heltable([8,16,128], n3(:,2179), t3x128(:,:,1513))
  call heltable([8,16,128], n3(:,2180), t3x128(:,:,1514))
  call heltable([8,16,128], n3(:,2181), t3x128(:,:,1515))
  call heltable([8,16,128], n3(:,2182), t3x128(:,:,1516))
  call heltable([8,16,128], n3(:,2183), t3x128(:,:,1517))
  call heltable([8,16,128], n3(:,2184), t3x128(:,:,1518))
  call heltable([8,16,128], n3(:,2185), t3x128(:,:,1519))
  call heltable([8,16,128], n3(:,2186), t3x128(:,:,1520))
  call heltable([8,16,128], n3(:,2187), t3x128(:,:,1521))
  call heltable([8,16,128], n3(:,2188), t3x128(:,:,1522))
  call heltable([8,16,128], n3(:,2189), t3x128(:,:,1523))
  call heltable([16,8,128], n3(:,2190), t3x128(:,:,1524))
  call heltable([8,16,128], n3(:,2191), t3x128(:,:,1525))
  call heltable([8,16,128], n3(:,2192), t3x128(:,:,1526))
  call heltable([8,16,128], n3(:,2193), t3x128(:,:,1527))
  call heltable([8,16,128], n3(:,2194), t3x128(:,:,1528))
  call heltable([8,16,128], n3(:,2195), t3x128(:,:,1529))
  call heltable([16,8,128], n3(:,2196), t3x128(:,:,1530))
  call heltable([8,16,128], n3(:,2197), t3x128(:,:,1531))
  call heltable([8,16,128], n3(:,2198), t3x128(:,:,1532))
  call heltable([8,16,128], n3(:,2199), t3x128(:,:,1533))
  call heltable([16,8,128], n3(:,2200), t3x128(:,:,1534))
  call heltable([16,8,128], n3(:,2201), t3x128(:,:,1535))
  call heltable([8,16,128], n3(:,2202), t3x128(:,:,1536))
  call heltable([8,16,128], n3(:,2203), t3x128(:,:,1537))
  call heltable([8,16,128], n3(:,2204), t3x128(:,:,1538))
  call heltable([8,16,128], n3(:,2205), t3x128(:,:,1539))
  call heltable([8,16,128], n3(:,2206), t3x128(:,:,1540))
  call heltable([8,16,128], n3(:,2207), t3x128(:,:,1541))
  call heltable([8,16,128], n3(:,2208), t3x128(:,:,1542))
  call heltable([8,16,128], n3(:,2209), t3x128(:,:,1543))
  call heltable([8,16,128], n3(:,2210), t3x128(:,:,1544))
  call heltable([8,16,128], n3(:,2211), t3x128(:,:,1545))
  call heltable([8,16,128], n3(:,2212), t3x128(:,:,1546))
  call heltable([16,8,128], n3(:,2213), t3x128(:,:,1547))
  call heltable([8,16,128], n3(:,2214), t3x128(:,:,1548))
  call heltable([8,16,128], n3(:,2215), t3x128(:,:,1549))
  call heltable([8,16,128], n3(:,2216), t3x128(:,:,1550))
  call heltable([8,16,128], n3(:,2217), t3x128(:,:,1551))
  call heltable([8,16,128], n3(:,2218), t3x128(:,:,1552))
  call heltable([8,16,128], n3(:,2219), t3x128(:,:,1553))
  call heltable([8,16,128], n3(:,2220), t3x128(:,:,1554))
  call heltable([16,8,128], n3(:,2221), t3x128(:,:,1555))
  call heltable([16,8,128], n3(:,2222), t3x128(:,:,1556))
  call heltable([8,16,128], n3(:,2223), t3x128(:,:,1557))
  call heltable([8,16,128], n3(:,2224), t3x128(:,:,1558))
  call heltable([16,8,128], n3(:,2225), t3x128(:,:,1559))
  call heltable([8,16,128], n3(:,2226), t3x128(:,:,1560))
  call heltable([8,16,128], n3(:,2227), t3x128(:,:,1561))
  call heltable([8,16,128], n3(:,2228), t3x128(:,:,1562))
  call heltable([8,16,128], n3(:,2229), t3x128(:,:,1563))
  call heltable([16,8,128], n3(:,2230), t3x128(:,:,1564))
  call heltable([8,16,128], n3(:,2231), t3x128(:,:,1565))
  call heltable([8,16,128], n3(:,2232), t3x128(:,:,1566))
  call heltable([8,16,128], n3(:,2233), t3x128(:,:,1567))
  call heltable([8,16,128], n3(:,2234), t3x128(:,:,1568))
  call heltable([8,16,128], n3(:,2235), t3x128(:,:,1569))
  call heltable([8,16,128], n3(:,2236), t3x128(:,:,1570))
  call heltable([8,16,128], n3(:,2237), t3x128(:,:,1571))
  call heltable([8,16,128], n3(:,2238), t3x128(:,:,1572))
  call heltable([8,16,128], n3(:,2239), t3x128(:,:,1573))
  call heltable([8,16,128], n3(:,2240), t3x128(:,:,1574))
  call heltable([8,16,128], n3(:,2241), t3x128(:,:,1575))
  call heltable([8,16,128], n3(:,2242), t3x128(:,:,1576))
  call heltable([8,16,128], n3(:,2243), t3x128(:,:,1577))
  call heltable([8,16,128], n3(:,2244), t3x128(:,:,1578))
  call heltable([8,16,128], n3(:,2245), t3x128(:,:,1579))
  call heltable([8,16,128], n3(:,2246), t3x128(:,:,1580))
  call heltable([8,16,128], n3(:,2247), t3x128(:,:,1581))
  call heltable([16,8,128], n3(:,2248), t3x128(:,:,1582))
  call heltable([8,16,128], n3(:,2249), t3x128(:,:,1583))
  call heltable([8,16,128], n3(:,2250), t3x128(:,:,1584))
  call heltable([8,16,128], n3(:,2251), t3x128(:,:,1585))
  call heltable([8,16,128], n3(:,2252), t3x128(:,:,1586))
  call heltable([8,16,128], n3(:,2253), t3x128(:,:,1587))
  call heltable([16,8,128], n3(:,2254), t3x128(:,:,1588))
  call heltable([8,16,128], n3(:,2255), t3x128(:,:,1589))
  call heltable([8,16,128], n3(:,2256), t3x128(:,:,1590))
  call heltable([8,16,128], n3(:,2257), t3x128(:,:,1591))
  call heltable([8,16,128], n3(:,2258), t3x128(:,:,1592))
  call heltable([8,16,128], n3(:,2259), t3x128(:,:,1593))
  call heltable([16,8,128], n3(:,2260), t3x128(:,:,1594))
  call heltable([16,8,128], n3(:,2261), t3x128(:,:,1595))
  call heltable([8,16,128], n3(:,2262), t3x128(:,:,1596))
  call heltable([8,16,128], n3(:,2263), t3x128(:,:,1597))
  call heltable([8,16,128], n3(:,2264), t3x128(:,:,1598))
  call heltable([8,16,128], n3(:,2265), t3x128(:,:,1599))
  call heltable([8,16,128], n3(:,2266), t3x128(:,:,1600))
  call heltable([8,16,128], n3(:,2267), t3x128(:,:,1601))
  call heltable([8,16,128], n3(:,2268), t3x128(:,:,1602))
  call heltable([8,16,128], n3(:,2269), t3x128(:,:,1603))
  call heltable([8,16,128], n3(:,2270), t3x128(:,:,1604))
  call heltable([8,16,128], n3(:,2271), t3x128(:,:,1605))
  call heltable([8,16,128], n3(:,2272), t3x128(:,:,1606))
  call heltable([8,16,128], n3(:,2273), t3x128(:,:,1607))
  call heltable([8,16,128], n3(:,2274), t3x128(:,:,1608))
  call heltable([8,16,128], n3(:,2275), t3x128(:,:,1609))
  call heltable([8,16,128], n3(:,2276), t3x128(:,:,1610))
  call heltable([8,16,128], n3(:,2277), t3x128(:,:,1611))
  call heltable([8,16,128], n3(:,2278), t3x128(:,:,1612))
  call heltable([8,16,128], n3(:,2279), t3x128(:,:,1613))
  call heltable([8,16,128], n3(:,2280), t3x128(:,:,1614))
  call heltable([16,8,128], n3(:,2281), t3x128(:,:,1615))
  call heltable([16,8,128], n3(:,2282), t3x128(:,:,1616))
  call heltable([8,16,128], n3(:,2283), t3x128(:,:,1617))
  call heltable([8,16,128], n3(:,2284), t3x128(:,:,1618))
  call heltable([8,16,128], n3(:,2285), t3x128(:,:,1619))
  call heltable([8,16,128], n3(:,2286), t3x128(:,:,1620))
  call heltable([8,16,128], n3(:,2287), t3x128(:,:,1621))
  call heltable([8,16,128], n3(:,2288), t3x128(:,:,1622))
  call heltable([8,16,128], n3(:,2289), t3x128(:,:,1623))
  call heltable([8,16,128], n3(:,2290), t3x128(:,:,1624))
  call heltable([8,16,128], n3(:,2291), t3x128(:,:,1625))
  call heltable([16,8,128], n3(:,2292), t3x128(:,:,1626))
  call heltable([8,16,128], n3(:,2293), t3x128(:,:,1627))
  call heltable([8,16,128], n3(:,2294), t3x128(:,:,1628))
  call heltable([8,16,128], n3(:,2295), t3x128(:,:,1629))
  call heltable([8,16,128], n3(:,2296), t3x128(:,:,1630))
  call heltable([8,16,128], n3(:,2297), t3x128(:,:,1631))
  call heltable([8,16,128], n3(:,2298), t3x128(:,:,1632))
  call heltable([8,16,128], n3(:,2299), t3x128(:,:,1633))
  call heltable([8,16,128], n3(:,2300), t3x128(:,:,1634))
  call heltable([8,16,128], n3(:,2301), t3x128(:,:,1635))
  call heltable([8,16,128], n3(:,2302), t3x128(:,:,1636))
  call heltable([8,16,128], n3(:,2303), t3x128(:,:,1637))
  call heltable([8,16,128], n3(:,2304), t3x128(:,:,1638))
  call heltable([8,16,128], n3(:,2305), t3x128(:,:,1639))
  call heltable([8,16,128], n3(:,2306), t3x128(:,:,1640))
  call heltable([8,16,128], n3(:,2307), t3x128(:,:,1641))
  call heltable([8,16,128], n3(:,2308), t3x128(:,:,1642))
  call heltable([8,16,128], n3(:,2309), t3x128(:,:,1643))
  call heltable([16,8,128], n3(:,2310), t3x128(:,:,1644))
  call heltable([8,16,128], n3(:,2311), t3x128(:,:,1645))
  call heltable([8,16,128], n3(:,2312), t3x128(:,:,1646))
  call heltable([8,16,128], n3(:,2313), t3x128(:,:,1647))
  call heltable([8,16,128], n3(:,2314), t3x128(:,:,1648))
  call heltable([8,16,128], n3(:,2315), t3x128(:,:,1649))
  call heltable([16,8,128], n3(:,2316), t3x128(:,:,1650))
  call heltable([8,16,128], n3(:,2317), t3x128(:,:,1651))
  call heltable([8,16,128], n3(:,2318), t3x128(:,:,1652))
  call heltable([8,16,128], n3(:,2319), t3x128(:,:,1653))
  call heltable([8,16,128], n3(:,2320), t3x128(:,:,1654))
  call heltable([16,8,128], n3(:,2321), t3x128(:,:,1655))
  call heltable([8,16,128], n3(:,2322), t3x128(:,:,1656))
  call heltable([8,16,128], n3(:,2323), t3x128(:,:,1657))
  call heltable([8,16,128], n3(:,2324), t3x128(:,:,1658))
  call heltable([8,16,128], n3(:,2325), t3x128(:,:,1659))
  call heltable([8,16,128], n3(:,2326), t3x128(:,:,1660))
  call heltable([8,16,128], n3(:,2327), t3x128(:,:,1661))
  call heltable([8,16,128], n3(:,2328), t3x128(:,:,1662))
  call heltable([8,16,128], n3(:,2329), t3x128(:,:,1663))
  call heltable([8,16,128], n3(:,2330), t3x128(:,:,1664))
  call heltable([8,16,128], n3(:,2331), t3x128(:,:,1665))
  call heltable([8,16,128], n3(:,2332), t3x128(:,:,1666))
  call heltable([8,16,128], n3(:,2333), t3x128(:,:,1667))
  call heltable([8,16,128], n3(:,2334), t3x128(:,:,1668))
  call heltable([8,16,128], n3(:,2335), t3x128(:,:,1669))
  call heltable([8,16,128], n3(:,2336), t3x128(:,:,1670))
  call heltable([8,16,128], n3(:,2337), t3x128(:,:,1671))
  call heltable([8,16,128], n3(:,2338), t3x128(:,:,1672))
  call heltable([8,16,128], n3(:,2339), t3x128(:,:,1673))
  call heltable([8,16,128], n3(:,2340), t3x128(:,:,1674))
  call heltable([8,16,128], n3(:,2341), t3x128(:,:,1675))
  call heltable([16,8,128], n3(:,2342), t3x128(:,:,1676))
  call heltable([8,16,128], n3(:,2343), t3x128(:,:,1677))
  call heltable([8,16,128], n3(:,2344), t3x128(:,:,1678))
  call heltable([8,16,128], n3(:,2345), t3x128(:,:,1679))
  call heltable([8,16,128], n3(:,2346), t3x128(:,:,1680))
  call heltable([8,16,128], n3(:,2347), t3x128(:,:,1681))
  call heltable([8,16,128], n3(:,2348), t3x128(:,:,1682))
  call heltable([8,16,128], n3(:,2349), t3x128(:,:,1683))
  call heltable([8,16,128], n3(:,2350), t3x128(:,:,1684))
  call heltable([8,16,128], n3(:,2351), t3x128(:,:,1685))
  call heltable([16,8,128], n3(:,2352), t3x128(:,:,1686))
  call heltable([8,16,128], n3(:,2353), t3x128(:,:,1687))
  call heltable([8,16,128], n3(:,2354), t3x128(:,:,1688))
  call heltable([8,16,128], n3(:,2355), t3x128(:,:,1689))
  call heltable([8,16,128], n3(:,2356), t3x128(:,:,1690))
  call heltable([8,16,128], n3(:,2357), t3x128(:,:,1691))
  call heltable([8,16,128], n3(:,2358), t3x128(:,:,1692))
  call heltable([8,16,128], n3(:,2359), t3x128(:,:,1693))
  call heltable([8,16,128], n3(:,2360), t3x128(:,:,1694))
  call heltable([8,16,128], n3(:,2361), t3x128(:,:,1695))
  call heltable([8,16,128], n3(:,2362), t3x128(:,:,1696))
  call heltable([8,16,128], n3(:,2363), t3x128(:,:,1697))
  call heltable([8,16,128], n3(:,2364), t3x128(:,:,1698))
  call heltable([8,16,128], n3(:,2365), t3x128(:,:,1699))
  call heltable([8,16,128], n3(:,2366), t3x128(:,:,1700))
  call heltable([8,16,128], n3(:,2367), t3x128(:,:,1701))
  call heltable([8,16,128], n3(:,2368), t3x128(:,:,1702))
  call heltable([8,16,128], n3(:,2369), t3x128(:,:,1703))
  call heltable([16,8,128], n3(:,2370), t3x128(:,:,1704))
  call heltable([8,16,128], n3(:,2371), t3x128(:,:,1705))
  call heltable([8,16,128], n3(:,2372), t3x128(:,:,1706))
  call heltable([8,16,128], n3(:,2373), t3x128(:,:,1707))
  call heltable([8,16,128], n3(:,2374), t3x128(:,:,1708))
  call heltable([8,16,128], n3(:,2375), t3x128(:,:,1709))
  call heltable([16,8,128], n3(:,2376), t3x128(:,:,1710))
  call heltable([16,8,128], n3(:,2377), t3x128(:,:,1711))
  call heltable([16,8,128], n3(:,2378), t3x128(:,:,1712))
  call heltable([8,16,128], n3(:,2379), t3x128(:,:,1713))
  call heltable([8,16,128], n3(:,2380), t3x128(:,:,1714))
  call heltable([16,8,128], n3(:,2381), t3x128(:,:,1715))
  call heltable([8,16,128], n3(:,2382), t3x128(:,:,1716))
  call heltable([8,16,128], n3(:,2383), t3x128(:,:,1717))
  call heltable([8,16,128], n3(:,2384), t3x128(:,:,1718))
  call heltable([8,16,128], n3(:,2385), t3x128(:,:,1719))
  call heltable([16,8,128], n3(:,2386), t3x128(:,:,1720))
  call heltable([8,16,128], n3(:,2387), t3x128(:,:,1721))
  call heltable([8,16,128], n3(:,2388), t3x128(:,:,1722))
  call heltable([16,8,128], n3(:,2389), t3x128(:,:,1723))
  call heltable([16,8,128], n3(:,2390), t3x128(:,:,1724))
  call heltable([8,16,128], n3(:,2391), t3x128(:,:,1725))
  call heltable([8,16,128], n3(:,2392), t3x128(:,:,1726))
  call heltable([8,16,128], n3(:,2393), t3x128(:,:,1727))
  call heltable([8,16,128], n3(:,2394), t3x128(:,:,1728))
  call heltable([8,16,128], n3(:,2395), t3x128(:,:,1729))
  call heltable([8,16,128], n3(:,2396), t3x128(:,:,1730))
  call heltable([8,16,128], n3(:,2397), t3x128(:,:,1731))
  call heltable([8,16,128], n3(:,2398), t3x128(:,:,1732))
  call heltable([8,16,128], n3(:,2399), t3x128(:,:,1733))
  call heltable([16,8,128], n3(:,2400), t3x128(:,:,1734))
  call heltable([8,16,128], n3(:,2401), t3x128(:,:,1735))
  call heltable([16,8,128], n3(:,2402), t3x128(:,:,1736))
  call heltable([8,16,128], n3(:,2403), t3x128(:,:,1737))
  call heltable([8,16,128], n3(:,2404), t3x128(:,:,1738))
  call heltable([8,16,128], n3(:,2405), t3x128(:,:,1739))
  call heltable([8,16,128], n3(:,2406), t3x128(:,:,1740))
  call heltable([8,16,128], n3(:,2407), t3x128(:,:,1741))
  call heltable([8,16,128], n3(:,2408), t3x128(:,:,1742))
  call heltable([8,16,128], n3(:,2409), t3x128(:,:,1743))
  call heltable([8,16,128], n3(:,2410), t3x128(:,:,1744))
  call heltable([8,16,128], n3(:,2411), t3x128(:,:,1745))
  call heltable([16,8,128], n3(:,2412), t3x128(:,:,1746))
  call heltable([8,16,128], n3(:,2413), t3x128(:,:,1747))
  call heltable([8,16,128], n3(:,2414), t3x128(:,:,1748))
  call heltable([8,16,128], n3(:,2415), t3x128(:,:,1749))
  call heltable([16,8,128], n3(:,2416), t3x128(:,:,1750))
  call heltable([8,16,128], n3(:,2417), t3x128(:,:,1751))
  call heltable([8,16,128], n3(:,2418), t3x128(:,:,1752))
  call heltable([8,16,128], n3(:,2419), t3x128(:,:,1753))
  call heltable([8,16,128], n3(:,2420), t3x128(:,:,1754))
  call heltable([8,16,128], n3(:,2421), t3x128(:,:,1755))
  call heltable([8,16,128], n3(:,2422), t3x128(:,:,1756))
  call heltable([8,16,128], n3(:,2423), t3x128(:,:,1757))
  call heltable([16,8,128], n3(:,2424), t3x128(:,:,1758))
  call heltable([8,16,128], n3(:,2425), t3x128(:,:,1759))
  call heltable([8,16,128], n3(:,2426), t3x128(:,:,1760))
  call heltable([8,16,128], n3(:,2427), t3x128(:,:,1761))
  call heltable([8,16,128], n3(:,2428), t3x128(:,:,1762))
  call heltable([8,16,128], n3(:,2429), t3x128(:,:,1763))
  call heltable([16,8,128], n3(:,2430), t3x128(:,:,1764))
  call heltable([8,16,128], n3(:,2431), t3x128(:,:,1765))
  call heltable([8,16,128], n3(:,2432), t3x128(:,:,1766))
  call heltable([8,16,128], n3(:,2433), t3x128(:,:,1767))
  call heltable([8,16,128], n3(:,2434), t3x128(:,:,1768))
  call heltable([8,16,128], n3(:,2435), t3x128(:,:,1769))
  call heltable([8,16,128], n3(:,2436), t3x128(:,:,1770))
  call heltable([8,16,128], n3(:,2437), t3x128(:,:,1771))
  call heltable([8,16,128], n3(:,2438), t3x128(:,:,1772))
  call heltable([8,16,128], n3(:,2439), t3x128(:,:,1773))
  call heltable([8,16,128], n3(:,2440), t3x128(:,:,1774))
  call heltable([8,16,128], n3(:,2441), t3x128(:,:,1775))
  call heltable([8,16,128], n3(:,2442), t3x128(:,:,1776))
  call heltable([8,16,128], n3(:,2443), t3x128(:,:,1777))
  call heltable([8,16,128], n3(:,2444), t3x128(:,:,1778))
  call heltable([8,16,128], n3(:,2445), t3x128(:,:,1779))
  call heltable([8,16,128], n3(:,2446), t3x128(:,:,1780))
  call heltable([8,16,128], n3(:,2447), t3x128(:,:,1781))
  call heltable([8,16,128], n3(:,2448), t3x128(:,:,1782))
  call heltable([8,16,128], n3(:,2449), t3x128(:,:,1783))
  call heltable([8,16,128], n3(:,2450), t3x128(:,:,1784))
  call heltable([8,16,128], n3(:,2451), t3x128(:,:,1785))
  call heltable([16,8,128], n3(:,2452), t3x128(:,:,1786))
  call heltable([8,16,128], n3(:,2453), t3x128(:,:,1787))
  call heltable([8,16,128], n3(:,2454), t3x128(:,:,1788))
  call heltable([8,16,128], n3(:,2455), t3x128(:,:,1789))
  call heltable([8,16,128], n3(:,2456), t3x128(:,:,1790))
  call heltable([8,16,128], n3(:,2457), t3x128(:,:,1791))
  call heltable([16,8,128], n3(:,2458), t3x128(:,:,1792))
  call heltable([8,16,128], n3(:,2459), t3x128(:,:,1793))
  call heltable([8,16,128], n3(:,2460), t3x128(:,:,1794))
  call heltable([8,16,128], n3(:,2461), t3x128(:,:,1795))
  call heltable([8,16,128], n3(:,2462), t3x128(:,:,1796))
  call heltable([8,16,128], n3(:,2463), t3x128(:,:,1797))
  call heltable([8,16,128], n3(:,2464), t3x128(:,:,1798))
  call heltable([8,16,128], n3(:,2465), t3x128(:,:,1799))
  call heltable([8,16,128], n3(:,2466), t3x128(:,:,1800))
  call heltable([8,16,128], n3(:,2467), t3x128(:,:,1801))
  call heltable([8,16,128], n3(:,2468), t3x128(:,:,1802))
  call heltable([8,16,128], n3(:,2469), t3x128(:,:,1803))
  call heltable([8,16,128], n3(:,2470), t3x128(:,:,1804))
  call heltable([8,16,128], n3(:,2471), t3x128(:,:,1805))
  call heltable([8,16,128], n3(:,2472), t3x128(:,:,1806))
  call heltable([8,16,128], n3(:,2473), t3x128(:,:,1807))
  call heltable([8,16,128], n3(:,2474), t3x128(:,:,1808))
  call heltable([8,16,128], n3(:,2475), t3x128(:,:,1809))
  call heltable([8,16,128], n3(:,2476), t3x128(:,:,1810))
  call heltable([8,16,128], n3(:,2477), t3x128(:,:,1811))
  call heltable([16,8,128], n3(:,2478), t3x128(:,:,1812))
  call heltable([8,16,128], n3(:,2479), t3x128(:,:,1813))
  call heltable([8,16,128], n3(:,2480), t3x128(:,:,1814))
  call heltable([8,16,128], n3(:,2481), t3x128(:,:,1815))
  call heltable([8,16,128], n3(:,2482), t3x128(:,:,1816))
  call heltable([8,16,128], n3(:,2483), t3x128(:,:,1817))
  call heltable([16,8,128], n3(:,2484), t3x128(:,:,1818))
  call heltable([8,16,128], n3(:,2485), t3x128(:,:,1819))
  call heltable([8,16,128], n3(:,2486), t3x128(:,:,1820))
  call heltable([8,16,128], n3(:,2487), t3x128(:,:,1821))
  call heltable([8,16,128], n3(:,2488), t3x128(:,:,1822))
  call heltable([8,16,128], n3(:,2489), t3x128(:,:,1823))
  call heltable([8,16,128], n3(:,2490), t3x128(:,:,1824))
  call heltable([8,16,128], n3(:,2491), t3x128(:,:,1825))
  call heltable([8,16,128], n3(:,2492), t3x128(:,:,1826))
  call heltable([8,16,128], n3(:,2493), t3x128(:,:,1827))
  call heltable([8,16,128], n3(:,2494), t3x128(:,:,1828))
  call heltable([8,16,128], n3(:,2495), t3x128(:,:,1829))
  call heltable([8,16,128], n3(:,2496), t3x128(:,:,1830))
  call heltable([8,16,128], n3(:,2497), t3x128(:,:,1831))
  call heltable([8,16,128], n3(:,2498), t3x128(:,:,1832))
  call heltable([8,16,128], n3(:,2499), t3x128(:,:,1833))
  call heltable([8,16,128], n3(:,2500), t3x128(:,:,1834))
  call heltable([8,16,128], n3(:,2501), t3x128(:,:,1835))
  call heltable([16,8,128], n3(:,2502), t3x128(:,:,1836))
  call heltable([8,16,128], n3(:,2503), t3x128(:,:,1837))
  call heltable([8,16,128], n3(:,2504), t3x128(:,:,1838))
  call heltable([8,16,128], n3(:,2505), t3x128(:,:,1839))
  call heltable([8,16,128], n3(:,2506), t3x128(:,:,1840))
  call heltable([8,16,128], n3(:,2507), t3x128(:,:,1841))
  call heltable([16,8,128], n3(:,2508), t3x128(:,:,1842))
  call heltable([8,16,128], n3(:,2509), t3x128(:,:,1843))
  call heltable([8,16,128], n3(:,2510), t3x128(:,:,1844))
  call heltable([8,16,128], n3(:,2511), t3x128(:,:,1845))
  call heltable([16,8,128], n3(:,2512), t3x128(:,:,1846))
  call heltable([8,16,128], n3(:,2513), t3x128(:,:,1847))
  call heltable([8,16,128], n3(:,2514), t3x128(:,:,1848))
  call heltable([8,16,128], n3(:,2515), t3x128(:,:,1849))
  call heltable([8,16,128], n3(:,2516), t3x128(:,:,1850))
  call heltable([8,16,128], n3(:,2517), t3x128(:,:,1851))
  call heltable([8,16,128], n3(:,2518), t3x128(:,:,1852))
  call heltable([8,16,128], n3(:,2519), t3x128(:,:,1853))
  call heltable([16,8,128], n3(:,2520), t3x128(:,:,1854))
  call heltable([8,16,128], n3(:,2521), t3x128(:,:,1855))
  call heltable([8,16,128], n3(:,2522), t3x128(:,:,1856))
  call heltable([8,16,128], n3(:,2523), t3x128(:,:,1857))
  call heltable([8,16,128], n3(:,2524), t3x128(:,:,1858))
  call heltable([8,16,128], n3(:,2525), t3x128(:,:,1859))
  call heltable([16,8,128], n3(:,2526), t3x128(:,:,1860))
  call heltable([8,16,128], n3(:,2527), t3x128(:,:,1861))
  call heltable([8,16,128], n3(:,2528), t3x128(:,:,1862))
  call heltable([8,16,128], n3(:,2529), t3x128(:,:,1863))
  call heltable([8,16,128], n3(:,2530), t3x128(:,:,1864))
  call heltable([8,16,128], n3(:,2531), t3x128(:,:,1865))
  call heltable([8,16,128], n3(:,2532), t3x128(:,:,1866))
  call heltable([8,16,128], n3(:,2533), t3x128(:,:,1867))
  call heltable([8,16,128], n3(:,2534), t3x128(:,:,1868))
  call heltable([8,16,128], n3(:,2535), t3x128(:,:,1869))
  call heltable([16,8,128], n3(:,2536), t3x128(:,:,1870))
  call heltable([8,16,128], n3(:,2537), t3x128(:,:,1871))
  call heltable([8,16,128], n3(:,2538), t3x128(:,:,1872))
  call heltable([8,16,128], n3(:,2539), t3x128(:,:,1873))
  call heltable([8,16,128], n3(:,2540), t3x128(:,:,1874))
  call heltable([8,16,128], n3(:,2541), t3x128(:,:,1875))
  call heltable([8,16,128], n3(:,2542), t3x128(:,:,1876))
  call heltable([8,16,128], n3(:,2543), t3x128(:,:,1877))
  call heltable([16,8,128], n3(:,2544), t3x128(:,:,1878))
  call heltable([8,16,128], n3(:,2545), t3x128(:,:,1879))
  call heltable([8,16,128], n3(:,2546), t3x128(:,:,1880))
  call heltable([8,16,128], n3(:,2547), t3x128(:,:,1881))
  call heltable([8,16,128], n3(:,2548), t3x128(:,:,1882))
  call heltable([8,16,128], n3(:,2549), t3x128(:,:,1883))
  call heltable([16,8,128], n3(:,2550), t3x128(:,:,1884))
  call heltable([8,16,128], n3(:,2551), t3x128(:,:,1885))
  call heltable([8,16,128], n3(:,2552), t3x128(:,:,1886))
  call heltable([8,16,128], n3(:,2553), t3x128(:,:,1887))
  call heltable([8,16,128], n3(:,2554), t3x128(:,:,1888))
  call heltable([8,16,128], n3(:,2555), t3x128(:,:,1889))
  call heltable([8,16,128], n3(:,2556), t3x128(:,:,1890))

  heltables_not_init = .false.

end subroutine init_heltables

end module ol_heltables_qqxggggg_ddxggggg_1
